//MaCDavid: 20020204
//MaCDavid: 20030721

/*
 * G_TEST3.prg, v 3.0 2002/02/28 03:36:38 MaCDavid
 * TG3xnet.prg, v 3.0 2003/07/21 01:08:38 MaCDavid
 */

/*
 * TGraph 3 source code:
 * Programa de demostracion de TGraph 3
 *
 * Copyright 2002 David Arturo Macias Corona <dmacias@mail.udg.mx>
 *
 * TG3xnet source code:
 * Programa de demostracion de: "Lo inevitable: TGraph 3 y ClipNet-xNet juntos"
 *
 * Copyright 2002-2003 David Arturo Macias Corona <dmacias@mail.udg.mx>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA (or visit the web site http://www.gnu.org/).
 *
 * V 3.0  David Arturo Macias Corona     Version 3 del modelo TGraph
 *
 */



/*2003/07/21 (VGM) MaCDavid:
- Este programa puede usarse:
  + Como el clasico G_TEST3.prg del Modelo TGraph 3
    Si no se especifica parametro, se usa esta modalidad
  + Generar graficas en archivos de imagen para el Modelo ClipNet-xNet
    Si se especifica parametro, se usa esta modalidad
    Se asume que el parametro es el nombre del archivo:
      * Contiene informacion  para la grafica
      * Se usa para guardar el archivo de imagen resultante

- Los ejemplos son los de G_TEST3.prg del Modelo TGraph 3
 En todos menos el de DIALOG solo se ocupo aplicar:
   IF lClipxNet
    ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
     oGraph:Save2BMP( cArcTG3 ), ;
     oGWnd:oWnd:End() )
   ELSE
    oGWnd:Activate()
   ENDI
   
- Se agrego el ejemplo  TG3xnet_2(): Estadistica de intervenciones
 para muestras del Modelo ClipNet-xNet
 
*/


#Include "Fivewin.Ch"
#Include "Common.ch"
#Include "G_Graph.ch"
#Include "Colors.ch"


FUNCTION G_Test3()
PARA xParam

/* Por alguna razon desconocida, si se usa primero un ejemplo con WINDOW
y despues otro con DIALOG, no funciona especificamente:
   ACTIVATE DIALOG oWnd en G_WINDOW.prg
Si alguien sabe porque y como corregirlo, adelante

Por lo pronto se puso el ejemplo de DIALOG y despues todos los demas en WINDOW

Tambien se quito el uso de MAXROW(),MAXCOL() en los ejemplos porque FWH
reporta valores diferentes dependiendo de Win98 o Win2000, en ambos
casos los valores son incorrectos
*/

PRIV lClipxNet := .F.

IF ! TYPE("XPARAM")=="C"
 xParam := ""
ENDI
IF ! EMPTY( xParam )   //Lo inevitable: TGraph 3 y ClipNet-xNet juntos
 lClipxNet := .T.
 TG3xnet( xParam )
 RETU NIL
ENDI

//Continua el G_TEST3 de siempre ...

//Ejemplo 2: Test.prg de TGraph 2, "Resource Test"
TGraph2b()

//Ejemplo 1: Test.prg de TGraph 2
TGraph2a()

//Ejemplo 3: TGraph 3 basico
TGraph3a()

//Ejemplo 4: TGraph 3 con formato
TGraph3b()

//Ejemplo 5: TGraph 3 con columnas asignadas a AxisYR
TGraph3c()

//Ejemplo 6: TGraph 3 con columnas con valores particulares
TGraph3d()

//Ejemplo 7: TGraph 3 con columnas calculadas
TGraph3e()

//Ejemplo 8: TGraph 3 con escalamiento manual en AxisYL
TGraph3f()

//Ejemplo 9: TGraph 3 tipo Sectores
TGraph3g()

//Ejemplo 10: TGraph 3 con escala numerica en AxisX
TGraph3h()

//Ejemplo 11: TGraph 3 con escala de fecha en AxisX
TGraph3i()

//Ejemplo 12: TGraph 3 con archivo DBF como fuente de datos
TGraph3j()

//Ejemplo 13: TGraph 3 con textos de posicion libre
TGraph3k()

//Ejemplo 14: TGraph 3 con textos de posicion libre II
TGraph3l()

//Ejemplo 15: TGraph 3 con actualizacion cada 5 segundos
TGraph3m()

//Ejemplo 16: TGraph 3 con avance continuo cada 5 segundos
TGraph3n()

//Ejemplo 17: TGraph 3 en quiosco de tipos de grafica
TGraph3o()

//Ejemplo 18: TGraph 3 en quiosco de tipos de grafica e inversion de ejes
TGraph3p()

//Ejemplo 19: TGraph 3 en grafica de una base de datos
TGraph3q()

//Ejemplo 20: TGraph 3 en grafica de funciones matematicas
TGraph3r()

//Ejemplo 21: TGraph 3 con escalamiento de datos
TGraph3s()

//Ejemplo 22: TGraph 3 con ejes logaritmicos
TGraph3t()

//Ejemplo 23: TGraph 3 con nAxisBase y leyendas
TGraph3u()

//Ejemplo 24: TGraph 3 y solucion de ecuaciones con una variable
TGraph3v()

//Ejemplo 25: TGraph 3 con valores en tiempo real para Kleyber Derick
TGraph3w()

//Ejemplo 26: TGraph 3 con impresion directa
TGraph3x()

//Ejemplo 27: TGraph 3 sin ventana de navegacion (o como control)
TGraph3y()

RETURN (NIL)


FUNC tg3xnet
PARA xParam   //Archivo de intercambio de informacion

PRIV cTG3ejemplo   //Ejemplo a procesar
PRIV cArcTG3   //Archivo de intercambio de informacion e imagen
PRIV xCadena,cLinea
PRIV ii, jj
PRIV aValues, aTitCol
//Tipo de grafica y atributos
PRIV nTGrafica, lRotate, lAxisInv, l3d, lViewVal, lLegend, lFill, cBitMap

cArcTG3 := LOWE( xParam )
IF EMPTY( cArcTG3 )
 RETU NIL
ENDI
aValues := {}
aTitCol := {}
nTGrafica := 1
xCadena := ALLTRIM( MEMOREAD( cArcTG3 ) )
//Analizar lineas
//Nota: MLCOUNT()/MEMOLINE() es lento, asi que es mas eficiente separar por CR+LF
//DAVID: MEMOLINE() no respeta CRLF en Harbour de FWH Jul2003, y si lo hace en Harbour 42 oficial
xCadena := SGTTOA( xCadena, CHR(13)+CHR(10) )   //Texto TO Array
FOR ii = 1 TO LEN(xCadena)
 cLinea := xCadena[ ii ]
 IF EMPTY( cLinea )
  LOOP
 ENDI
 IF ":=" $ cLinea   //Evaluar para asignar
  EVAL( &( "{ | | "+cLinea+"}" ) )
 ELSEIF "aTitCol" $ cLinea  //Titulos de columnas
  cLinea := STRTRAN( cLinea, "aTitCol", "" )  //Suprimir indicador
  aTitCol := &( "{"+cLinea+"}" )
 ELSE   //Se asume fila de datos
  cLinea := &( "{"+cLinea+"}" )
  AADD( aValues, cLinea )
 ENDI
NEXT ii

IF EMPTY( cTG3ejemplo )
 cTG3ejemplo := "TG3xnet_2()"   //Estadistica de intervenciones
ENDI 
EVAL( &( "{ | | "+cTG3ejemplo+"}" ) )

RETU NIL


FUNC SGTTOA( cLisPares, cDelimita )
//DAVID: Vector de elementos separados. Auxiliar basado en SGPTOD()
LOCAL nPos,cVarVal,aMatDic:={}
IF cLisPares == NIL
 RETU aMatDic
ENDI
  //Por delimitador
  IF ! VALTYPE( cLisPares )=="C" .OR. ! VALTYPE( cDelimita ) == "C"
   RETU aMatDic
  ENDI
  WHIL ! EMPTY( cLisPares )
   IF ! ( nPos := AT( cDelimita, cLisPares ) ) == 0   //Posicion de delimitador
    cVarVal := LEFT( cLisPares, nPos - 1 )  //Extraer linea
    cLisPares := SUBS( cLisPares, nPos + LEN( cDelimita ) )  //Texto restante
   ELSE
    cVarVal := cLisPares ; cLisPares := SPAC(0)
   ENDI
   AADD( aMatDic, cVarVal )
  ENDD
RETU aMatDic


FUNC TG3xnet_2()
//Estadistica de intervenciones
// Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii, jj
LOCAL oFontT, oFontX, oFontY, oFont

   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-10
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-10

//WINDOW para grafica
//oGWnd := GraWnd():New( 1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: FiveWin Graphics", GraServer():New(aValues) )

//Sin ToolBar
// oGWnd:bToolBar := { || nil }

//Tomar grafica
oGraph := oGWnd:oGraph

oGraph:lPopUp := .T.

oGraph:oTitle:cText   := "Lo inevitable: TGraph 3 y ClipNet-xNet juntos"
oGraph:oSubTitle:cText:= "Estadisticas de intervenciones"
oGraph:oAxisX:cText   := "Meses (AAAAMM)"
oGraph:oAxisYL:cText  := "Intervenciones"
oGraph:oAxisYR:cText  := "Intervenciones"

//Titulo a la izquierda
// oGraph:oTitle:AliLeft()

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
oGraph:AutoData()

//Asignar titulos a Columnas (la primer columna son valores de X)
FOR ii = 1 TO oGraph:nColGraph()
 oColumn := oGraph:GetColGraph(ii)
 oColumn:cTitle   := aTitCol[ii]
NEXT ii

//3D
oGraph:l3D := l3d

//Valores de datos
oGraph:lViewVal := lViewVal

//Algo de color
oGraph:nClrBack := RGB(204,255,255)   //CLR_HCYAN

//Marcos a textos
// oGraph:oTitle:lFrame := .F.
// oGraph:oSubTitle:lFrame := .F.
// oGraph:oAxisX:lFrame := .T.
// oGraph:oAxisYL:lFrame := .T.
// oGraph:oAxisYR:lFrame := .T.

//Ver todas las Filas
oGraph:nRowView := LEN( aValues )
//Ver todas las Columnas
oGraph:nColView := oGraph:nColGraph()

//Usar tipo de grafica:
IF nTGrafica == 41
 oGraph:GPieSerie()
ELSEIF nTGrafica == 42
 oGraph:GPiePeriod()
ELSE
 oGraph:nType := nTGrafica
ENDI
// oGraph:GTypePie()
// oGraph:GPieSerie()
// oGraph:GTypeLine()
// oGraph:TPoint3()

// IF oGraph:nColGraph() <= 8
 //Leyendas abajo
//  oGraph:oLegend:PosBottom()
//  oGraph:oLegend:AliCenter()
// ELSE
 //Leyendas a la derecha
 oGraph:oLegend:PosRight()
// ENDI

//Leyendas
oGraph:oLegend:lShow := lLegend
//Rotas Filas / Columnas
oGraph:lRotate := lRotate
//Inversion de ejes
oGraph:lAxisInv := lAxisInv
//Llenado
oGraph:lFill := lFill
//Imagen de fondo
oGraph:cBitmap:= cBitMap

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()
oGWnd:End()
RETURN (NIL)


// =======  Ejemplos provenientes de G_TEST3.prg del Modelo TGraph 3  ====================

FUNC TGraph3r0()
//Ejemplo 20: TGraph 3 con grafica de funciones matematicas (modificada)
LOCAL aValues, aTitCol
LOCAL oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-14
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-14

//Datos en matriz
aValues := { }
FOR ii = -2 TO 10 STEP 0.2
 AADD( aValues, { ii } )
NEXT ii

//WINDOW para grafica
//oGWnd := GraWnd():New( 1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: FiveWin Graphics", GraServer():New(aValues) )

//Tomar grafica
oGraph := oGWnd:oGraph

oGraph:oTitle:cText   := "Graficas de funciones matematicas"
oGraph:oSubTitle:cText:= "SubTitulo"
oGraph:oAxisX:cText   := "Titulo de Eje X"
oGraph:oAxisYL:cText  := "Titulo de Eje YL"
oGraph:oAxisYR:cText  := "Titulo de Eje YR"

oGraph:lPopUp := .T.

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
// oGraph:AutoData()

//La primer columna de ::oData son los valores y/o etiquetas en AxisX
oGraph:oAxisX:bBlock := { | nParam, oData | oData:FieldGet(nParam) }
oGraph:oAxisX:nIndex := 1
//Agregar las demas columnas
oGraph:nCurWheel := 1
//El numero indica el numero de columna en la fuente de datos

oColumn := oGraph:AddColumn( { |nParam,oData| X:=oData:FieldGet(1), 2*x*x-18*x+5 }, ;
           "2 * X * X - 18 * X + 5", oGraph:GetClrWheel(), , 2 )
oColumn := oGraph:AddColumn( { |nParam,oData| X:=oData:FieldGet(1), 10*sin(x*2)/x }, ;
           "10 * Sin( 2 * X ) / X", oGraph:GetClrWheel(), , 2 )
oColumn:lAxisYL := .F.

//Usar tipo de grafica: Barras
oGraph:GTypeBar()

//Forzar escala numerica en X
oGraph:oAxisX:lAxisScale := .T.

//Ver todas las Filas
oGraph:nRowView := LEN( aValues )

//Algo de color
//DAVID: oGraph:nClrBack := CLR_HCYAN

//Suprimir 3D
//DAVID: oGraph:l3D := .F.

//Leyendas en el fondo y centradas
oGraph:oLegend:PosBottom()
oGraph:oLegend:AliCenter()
oGraph:oLegend:lFrame := .T.

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()
oGWnd:End()

RETURN (NIL)


FUNCTION TGraph2a()
//Ejemplo 1: Test.prg de TGraph 2
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT

//Datos en matriz
aValues := { { "Jan", -428, 0, 186, 154 }, ;
             { "Feb", -325, 0, 126, 218 }, ;
             { "Mar", -123, 0, 220,-133 }, ;
             { "Apr", -319, 0, 412,   0 }, ;
             { "May", -135, 0, 238, 148 }, ;
             { "Jun", -382, 0, 158,-319 }  ;
           }

aTitCol := { { "Serie 1", RGB(255,102, 10) }, ;
             { "Serie 2", RGB(255,128,128) }, ;
             { "Serie 3", RGB(128,128,255) }, ;
             { "Serie 4", RGB( 55,201, 48) }  ;
           }

//WINDOW para grafica
oGWnd := GraWnd():New( , , , , ;
 "TGraph 3: FiveWin Graphics", GraServer():New(aValues) )
//Sin ToolBar
oGWnd:bToolBar := { || nil }
//Tomar grafica
oGraph := oGWnd:oGraph

oGraph:oTitle:cText   := "TGraph 3: G R A P H   T E S T"
//Fuente para Titulo
DEFINE FONT oFontT NAME "Arial" SIZE 0,-15 BOLD
oGraph:oTitle:oFontT  := oFontT

oGraph:oSubTitle:cText:= "SubTitle ( DEFAULT SETTINGS )"
//Subtitulo a la izquierda
oGraph:oSubTitle:AliLeft()
oGraph:oAxisX:cText   := "X Labels"
oGraph:oAxisYL:cText  := "Y Labels"
oGraph:lPopUp := .T.
//Sin linea punteada en Grid
oGraph:oAxisX:lDottedGrid := .F.
oGraph:oAxisYL:lDottedGrid := .F.
//Intervalo de AxisYL
oGraph:oAxisYL:nStepOne := 150
//Color gris en oAxisYL:nAxisBase
oGraph:oAxisYL:nClrZ := CLR_GRAY

//Asignar automaticamente las Columnas del servidor de datos
oGraph:AutoData()

//Asignar titulos y colores a Columnas (la primer columna son valores de X)
FOR ii = 1 TO oGraph:nColGraph()
 oColumn := oGraph:GetColGraph(ii)
 oColumn:cTitle   := aTitCol[ii,1]
 oColumn:nClrFill := aTitCol[ii,2]
NEXT ii

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

oFontT:End()

RETURN (NIL)


FUNCTION TGraph2b()
//Ejemplo 2: Test.prg de TGraph 2, "Resource Test"
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont


//   SET RESOURCES TO "Test.Dll"

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-10
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-10

//Datos en matriz
aValues := { { "Jan", 10000, 15000 }, ;
             { "Feb", 21000,  2000 }, ;
             { "Mar", 13000, 11500 }, ;
             { "Apr", 18500, 14000 }, ;
             { "May", 13600, 16000 }, ;
             { "Jun",   500,  8000 }, ;
             { "Jul", 12000,  3000 }, ;
             { "Aug", 14500, 11000 }, ;
             { "Sep", 14600, 18600 }  ;
           }

aTitCol := { { "Software", RGB(150,150,150) }, ;
             { "Hardware", RGB(  0,200,100) } ;
           }

//DIALOG para grafica
oGWnd := GraWnd():New( , , , , ;
 "TGraph 3: FiveWin Graphics (Resource Test)", GraServer():New(aValues), ;
 .T. )

oGWnd:oWnd:oFont := oFont

//Sin ToolBar
oGWnd:bToolBar := { || nil }
//Tomar grafica
oGraph := oGWnd:oGraph

oGraph:lPopUp := .T.
oGraph:oTitle:cText   := "TGraph 3: Other graph test"
//Tipo Lineas
oGraph:GTypeLine()
//Titulo a la izquierda
oGraph:oTitle:AliLeft()
//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oAxisX:oFontL:=oFontX
oGraph:oAxisYL:oFontL:=oFontY
//Asignar colores
oGraph:oTitle:nClrT   :=RGB( 55, 55, 55)
oGraph:oAxisX:nClrL   :=CLR_RED
oGraph:oAxisYL:nClrL   :=CLR_BLUE
//Presentacion de etiquetas AxisYL
oGraph:oAxisYL:bToLabel := { |nParam| TRANSFORM(nParam,"999,999") }
oGraph:cBitmap:= "beige2.bmp"

//Sin linea punteada en Grid
oGraph:oAxisX:lDottedGrid := .F.
oGraph:oAxisYL:lDottedGrid := .F.
//Intervalo de AxisYL
oGraph:oAxisYL:nStepOne := 6000
//Color gris en oAxisYL:nAxisBase
oGraph:oAxisYL:nClrZ := CLR_GRAY
//Anular escalamiento automatico en AxisYL
oGraph:oAxisYL:bToScale := { | nVal | nVal }

//Asignar automaticamente las Columnas del servidor de datos
oGraph:AutoData()

//Asignar titulos y colores a Columnas (la primer columna son valores de X)
FOR ii = 1 TO oGraph:nColGraph()
 oColumn := oGraph:GetColGraph(ii)
 oColumn:cTitle   := aTitCol[ii,1]
 oColumn:nClrFill := aTitCol[ii,2]
NEXT ii

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

//   SET RESOURCES TO

oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()
RETURN (NIL)


FUNCTION TGraph3a()
//Ejemplo 3: TGraph 3 basico
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii

//Datos en matriz
aValues := GETARRAY()
aTitCol := GETTITLES()

//WINDOW para grafica
//oGWnd := GraWnd():New( 1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: FiveWin Graphics", GraServer():New(aValues) )

//Tomar grafica
oGraph := oGWnd:oGraph

oGraph:oTitle:cText   := "TGraph 3 basico"
oGraph:oSubTitle:cText:= "SubTitulo"
oGraph:oAxisX:cText   := "Titulo de Eje X"
oGraph:oAxisYL:cText  := "Titulo de Eje YL"
oGraph:oAxisYR:cText  := "Titulo de Eje YR"

oGraph:lPopUp := .T.

//Asignar automaticamente las Columnas del servidor de datos
oGraph:AutoData()

//Asignar titulos a Columnas
FOR ii = 1 TO oGraph:nColGraph()
 oColumn := oGraph:GetColGraph(ii)
 oColumn:cTitle   := aTitCol[ii]
NEXT ii

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

RETURN (NIL)


FUNCTION TGraph3b()
//Ejemplo 4: TGraph 3 con formato
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-14
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-14

//Datos en matriz
aValues := GETARRAY()
aTitCol := GETTITLES()

//WINDOW para grafica
//oGWnd := GraWnd():New( 1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: FiveWin Graphics", GraServer():New(aValues) )

//Tomar grafica
oGraph := oGWnd:oGraph

oGraph:oTitle:cText   := "TGraph 3 con formato"
oGraph:oSubTitle:cText:= "SubTitulo"
oGraph:oAxisX:cText   := "Titulo de Eje X"
oGraph:oAxisYL:cText  := "Titulo de Eje YL"
oGraph:oAxisYR:cText  := "Titulo de Eje YR"

oGraph:lPopUp := .T.

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
oGraph:AutoData()

//Asignar titulos a Columnas
FOR ii = 1 TO oGraph:nColGraph()
 oColumn := oGraph:GetColGraph(ii)
 oColumn:cTitle   := aTitCol[ii]
NEXT ii

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()

RETURN (NIL)


FUNCTION TGraph3c()
//Ejemplo 5: TGraph 3 con columnas asignadas a AxisYR
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-14
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-14

//Datos en matriz
aValues := GETARRAY()
aTitCol := GETTITLES()

//WINDOW para grafica
//oGWnd := GraWnd():New( 1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: FiveWin Graphics", GraServer():New(aValues) )

//Tomar grafica
oGraph := oGWnd:oGraph

oGraph:oTitle:cText   := "Columnas asignadas a AxisYR"
oGraph:oSubTitle:cText:= "SubTitulo"
oGraph:oAxisX:cText   := "Titulo de Eje X"
oGraph:oAxisYL:cText  := "Titulo de Eje YL"
oGraph:oAxisYR:cText  := "Titulo de Eje YR"

oGraph:lPopUp := .T.

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
oGraph:AutoData()

//Asignar titulos a Columnas
FOR ii = 1 TO oGraph:nColGraph()
 oColumn := oGraph:GetColGraph(ii)
 oColumn:cTitle   := aTitCol[ii]
NEXT ii

//Asignar columnas de valores pequeos a AxisYR
oColumn := oGraph:GetColGraph(5) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(6) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(7) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(8) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(9) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(10) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(15) ; oColumn:lAxisYL  := .F.

//Aumentar a 8 el numero de columnas en la Vista
oGraph:nColView := 8

//Usar tipo de grafica: Lineas
oGraph:GTypeLine()

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()

RETURN (NIL)


FUNCTION TGraph3d()
//Ejemplo 6: TGraph 3 con columnas con valores particulares
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-14
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-14

//Datos en matriz
aValues := GETARRAY()
aTitCol := GETTITLES()

//WINDOW para grafica
//oGWnd := GraWnd():New( 1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: FiveWin Graphics", GraServer():New(aValues) )

//Tomar grafica
oGraph := oGWnd:oGraph

oGraph:oTitle:cText   := "Columnas con valores particulares"
oGraph:oSubTitle:cText:= "SubTitulo"
oGraph:oAxisX:cText   := "Titulo de Eje X"
oGraph:oAxisYL:cText  := "Titulo de Eje YL"
oGraph:oAxisYR:cText  := "Titulo de Eje YR"

oGraph:lPopUp := .T.

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
oGraph:AutoData()

//Asignar titulos a Columnas
FOR ii = 1 TO oGraph:nColGraph()
 oColumn := oGraph:GetColGraph(ii)
 oColumn:cTitle   := aTitCol[ii]
NEXT ii

//Asignar columnas de valores pequeos a AxisYR
oColumn := oGraph:GetColGraph(5) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(6) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(7) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(8) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(9) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(10) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(15) ; oColumn:lAxisYL  := .F.

//Usar tipo de grafica: Barras
oGraph:GTypeBar()

oColumn := oGraph:GetColGraph(4)
oColumn:GTypeLine()  //Tipo lineas
oColumn:lFill := .F.  //Sin llenado
oColumn:l3D := .F.    //Sin 3D
oColumn:lShowVal := .T.  //Con visualizacion de valores

oGraph:lFill := .F.  //Sin llenado

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()

RETURN (NIL)


FUNCTION TGraph3e()
//Ejemplo 7: TGraph 3 con columnas calculadas
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-14
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-14

//Datos en matriz
aValues := GETARRAY()
aTitCol := GETTITLES()

//WINDOW para grafica
//oGWnd := GraWnd():New( 1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: FiveWin Graphics", GraServer():New(aValues) )

//Tomar grafica
oGraph := oGWnd:oGraph

oGraph:oTitle:cText   := "Columnas calculadas"
oGraph:oSubTitle:cText:= "SubTitulo"
oGraph:oAxisX:cText   := "Titulo de Eje X"
oGraph:oAxisYL:cText  := "Titulo de Eje YL"
oGraph:oAxisYR:cText  := "Titulo de Eje YR"

oGraph:lPopUp := .T.

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
// oGraph:AutoData()

//La primer columna de ::oData son los valores y/o etiquetas en AxisX
oGraph:oAxisX:bBlock := { | nParam, oData | oData:FieldGet(nParam) }
oGraph:oAxisX:nIndex := 1
//Agregar las demas columnas
oGraph:nCurWheel := 1
//El numero indica el numero de columna en la fuente de datos
oColumn := oGraph:AddColumn( { |nParam,oData| AsNumber(oData:FieldGet(nParam)) }, ;
                 aTitCol[1], oGraph:GetClrWheel(), , 2 )
oColumn := oGraph:AddColumn( { |nParam,oData| AsNumber(oData:FieldGet(nParam)) }, ;
                 aTitCol[2], oGraph:GetClrWheel(), , 3 )
oColumn := oGraph:AddColumn( { |nParam,oData| AsNumber(oData:FieldGet(nParam)) }, ;
                 aTitCol[3], oGraph:GetClrWheel(), , 4 )
//Promedio de columnas 1 a 3
oColumn := oGraph:AddColumn( { |nParam,oData| ;
 (oData:FieldGet(2)+oData:FieldGet(3)+oData:FieldGet(4))/3 }, ;
 "Promedio", oGraph:GetClrWheel() )

//Usar tipo de grafica: Barras
oGraph:GTypeBar()

oColumn := oGraph:GetColGraph(4)
oColumn:GTypeLine()  //Tipo lineas
oColumn:lFill := .F.  //Sin llenado
oColumn:l3D := .F.    //Sin 3D
oColumn:lShowVal := .T.  //Con visualizacion de valores

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()

RETURN (NIL)


FUNCTION TGraph3f()
//Ejemplo 8: TGraph 3 con escalamiento manual en AxisYL
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-14
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-14

//Datos en matriz
aValues := GETARRAY()
aTitCol := GETTITLES()

//WINDOW para grafica
//oGWnd := GraWnd():New( 1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: FiveWin Graphics", GraServer():New(aValues) )

//Tomar grafica
oGraph := oGWnd:oGraph

oGraph:oTitle:cText   := "Escalamiento manual en AxisYL"
oGraph:oSubTitle:cText:= "SubTitulo"
oGraph:oAxisX:cText   := "Titulo de Eje X"
oGraph:oAxisYL:cText  := "Titulo de Eje YL"
oGraph:oAxisYR:cText  := "Titulo de Eje YR"

oGraph:lPopUp := .T.

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
oGraph:AutoData()

//Asignar titulos a Columnas
FOR ii = 1 TO oGraph:nColGraph()
 oColumn := oGraph:GetColGraph(ii)
 oColumn:cTitle   := aTitCol[ii]
NEXT ii

//Asignar columnas de valores pequeos a AxisYR
oColumn := oGraph:GetColGraph(5) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(6) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(7) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(8) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(9) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(10) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(15) ; oColumn:lAxisYL  := .F.

//Usar tipo de grafica: Barras
oGraph:GTypeBar()

oColumn := oGraph:GetColGraph(4)
oColumn:GTypeLine()  //Tipo lineas
oColumn:lFill := .F.  //Sin llenado
oColumn:l3D := .F.    //Sin 3D
oColumn:lShowVal := .T.  //Con visualizacion de valores

//Escala manual en AxisYL
oGraph:oAxisYL:lAutoSize := .F.
oGraph:oAxisYL:nAxisMin := -20
oGraph:oAxisYL:nAxisMax := 100

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()

RETURN (NIL)


FUNCTION TGraph3g()
//Ejemplo 9: TGraph 3 tipo Sectores
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-14
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-14

//Datos en matriz
aValues := GETARRAY()
aTitCol := GETTITLES()

//WINDOW para grafica
//oGWnd := GraWnd():New( 1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: FiveWin Graphics", GraServer():New(aValues) )

//Tomar grafica
oGraph := oGWnd:oGraph

oGraph:oTitle:cText   := "Tipo Sectores"
oGraph:oSubTitle:cText:= "SubTitulo"
oGraph:oAxisX:cText   := "Titulo de Eje X"
oGraph:oAxisYL:cText  := "Titulo de Eje YL"
oGraph:oAxisYR:cText  := "Titulo de Eje YR"

oGraph:lPopUp := .T.

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
oGraph:AutoData()

//Asignar titulos a Columnas
FOR ii = 1 TO oGraph:nColGraph()
 oColumn := oGraph:GetColGraph(ii)
 oColumn:cTitle   := aTitCol[ii]
NEXT ii

//Asignar columnas de valores pequeos a AxisYR
oColumn := oGraph:GetColGraph(5) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(6) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(7) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(8) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(9) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(10) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(15) ; oColumn:lAxisYL  := .F.

//Usar tipo de grafica: Sectores (en Columna)
oGraph:GPieSerie()

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()

RETURN (NIL)


FUNCTION TGraph3h()
//Ejemplo 10: TGraph 3 con escala numerica en AxisX
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-14
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-14

//Datos en matriz
aValues := GETARRAY()
aTitCol := GETTITLES()

//Asignar valor numerico a primer columna
FOR ii = 1 TO LEN( aValues )
 aValues[ii,1] := ii
NEXT ii

//WINDOW para grafica
//oGWnd := GraWnd():New( 1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: FiveWin Graphics", GraServer():New(aValues) )

//Tomar grafica
oGraph := oGWnd:oGraph

oGraph:oTitle:cText   := "Escala numerica en AxisX"
oGraph:oSubTitle:cText:= "SubTitulo"
oGraph:oAxisX:cText   := "Titulo de Eje X"
oGraph:oAxisYL:cText  := "Titulo de Eje YL"
oGraph:oAxisYR:cText  := "Titulo de Eje YR"

oGraph:lPopUp := .T.

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
oGraph:AutoData()

//Asignar titulos a Columnas
FOR ii = 1 TO oGraph:nColGraph()
 oColumn := oGraph:GetColGraph(ii)
 oColumn:cTitle   := aTitCol[ii]
NEXT ii

//Asignar columnas de valores pequeos a AxisYR
oColumn := oGraph:GetColGraph(5) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(6) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(7) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(8) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(9) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(10) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(15) ; oColumn:lAxisYL  := .F.

//Usar tipo de grafica: XY
oGraph:GTypeXY()

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()

RETURN (NIL)


FUNCTION TGraph3i()
//Ejemplo 11: TGraph 3 con escala de fecha en AxisX
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont
LOCAL dIni, nJ

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-14
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-14

//Datos en matriz
aValues := GETARRAY()
aTitCol := GETTITLES()

//Asignar fechas a primer columna
//Deliberadamente se saltan algunas fechas para mostrar el efecto en la escala
dIni := DATE() - 150
nJ := 1
FOR ii = 1 TO LEN( aValues )
 aValues[ii,1] := dIni+ii
 nJ++
 IF nJ > 5
  nJ := 1
  dIni := dIni+2
 ENDIF
NEXT ii

//WINDOW para grafica
//oGWnd := GraWnd():New( 1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: FiveWin Graphics", GraServer():New(aValues) )

//Tomar grafica
oGraph := oGWnd:oGraph

oGraph:oTitle:cText   := "Escala de fecha en AxisX"
oGraph:oSubTitle:cText:= "SubTitulo"
oGraph:oAxisX:cText   := "Titulo de Eje X"
oGraph:oAxisYL:cText  := "Titulo de Eje YL"
oGraph:oAxisYR:cText  := "Titulo de Eje YR"

oGraph:lPopUp := .T.

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
oGraph:AutoData()

//Asignar titulos a Columnas
FOR ii = 1 TO oGraph:nColGraph()
 oColumn := oGraph:GetColGraph(ii)
 oColumn:cTitle   := aTitCol[ii]
NEXT ii

//Asignar columnas de valores pequeos a AxisYR
oColumn := oGraph:GetColGraph(5) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(6) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(7) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(8) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(9) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(10) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(15) ; oColumn:lAxisYL  := .F.

oColumn := oGraph:GetColGraph(4)
oColumn:GTypeLine()  //Tipo lineas
oColumn:lFill := .F.  //Sin llenado
oColumn:l3D := .F.    //Sin 3D
oColumn:lShowVal := .T.  //Con visualizacion de valores

//Usar tipo de grafica: Barras
oGraph:GTypeBar()

//Aplicar escala de fechas
oGraph:oAxisX:lAxisScale := .T.  //Es necesario que sea eje escalable
oGraph:oAxisX:lAxisDate := .T.   //Considerar la escala como fechas

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()

RETURN (NIL)


FUNCTION TGraph3j()
//Ejemplo 12: TGraph 3 con archivo DBF como fuente de datos
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-14
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-14

CheckDBF()

USE G_GRAPH SHARED

//WINDOW para grafica
//oGWnd := GraWnd():New( 1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: FiveWin Graphics", GraServer():New( ALIAS() ) )

//Tomar grafica
oGraph := oGWnd:oGraph

oGraph:oTitle:cText   := "Archivo DBF como fuente de datos"
oGraph:oSubTitle:cText:= "SubTitulo"
oGraph:oAxisX:cText   := "Titulo de Eje X"
oGraph:oAxisYL:cText  := "Titulo de Eje YL"
oGraph:oAxisYR:cText  := "Titulo de Eje YR"

oGraph:lPopUp := .T.

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
oGraph:AutoData()

//Asignar columnas de valores pequeos a AxisYR
oColumn := oGraph:GetColGraph(5) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(6) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(7) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(8) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(9) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(10) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(15) ; oColumn:lAxisYL  := .F.

//Usar tipo de grafica: Barras
oGraph:GTypeBar()

oColumn := oGraph:GetColGraph(4)
oColumn:GTypeLine()  //Tipo lineas
oColumn:lFill := .F.  //Sin llenado
oColumn:l3D := .F.    //Sin 3D
oColumn:lShowVal := .T.  //Con visualizacion de valores

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()

RETURN (NIL)


FUNCTION TGraph3k()
//Ejemplo 13: TGraph 3 con textos de posicion libre
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont
LOCAL oText

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-14 BOLD ITALIC
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-14

//Datos en matriz
aValues := GETARRAY()
aTitCol := GETTITLES()

//WINDOW para grafica
//oGWnd := GraWnd():New( 1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: FiveWin Graphics", GraServer():New(aValues) )

//Tomar grafica
oGraph := oGWnd:oGraph

oGraph:oTitle:cText   := "Textos de posicion libre"
oGraph:oSubTitle:cText:= "SubTitulo"
oGraph:oAxisX:cText   := "Titulo de Eje X"
oGraph:oAxisYL:cText  := "Titulo de Eje YL"
oGraph:oAxisYR:cText  := "Titulo de Eje YR"

oGraph:lPopUp := .T.

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
oGraph:AutoData()

//Asignar titulos a Columnas
FOR ii = 1 TO oGraph:nColGraph()
 oColumn := oGraph:GetColGraph(ii)
 oColumn:cTitle   := aTitCol[ii]
NEXT ii

//Asignar columnas de valores pequeos a AxisYR
oColumn := oGraph:GetColGraph(5) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(6) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(7) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(8) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(9) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(10) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(15) ; oColumn:lAxisYL  := .F.

//Usar tipo de grafica: Barras
oGraph:GTypeBar()

oColumn := oGraph:GetColGraph(4)
oColumn:GTypeLine()  //Tipo lineas
oColumn:lFill := .F.  //Sin llenado
oColumn:l3D := .F.    //Sin 3D
oColumn:lShowVal := .T.  //Con visualizacion de valores

//Agregar textos de posicion libre
oGraph:AddText( "Texto libre 1", , , , , , , , ,  )

FOR ii = 0 TO 359 STEP 15
 oText := oGraph:AddText( "Texto libre "+TRAN(ii,"999")+" grados", , , , , , , , ,  )
 oText:nAngleDeg := ii
 oText:PosCenter()
 oText:oFontT := oFontX
 oText:nClrT := RGB( INT(ii/1.5),INT(ii/2), INT(ii/1.5) )
NEXT ii

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()

RETURN (NIL)


FUNCTION TGraph3l()
//Ejemplo 14: TGraph 3 con textos de posicion libre II
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont
LOCAL oText

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-90 BOLD
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-14

//Datos en matriz
aValues := GETARRAY()
aTitCol := GETTITLES()

//WINDOW para grafica
//oGWnd := GraWnd():New( 1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: FiveWin Graphics", GraServer():New(aValues) )

//Tomar grafica
oGraph := oGWnd:oGraph

oGraph:oTitle:cText   := "Textos de posicion libre II"
oGraph:oSubTitle:cText:= "SubTitulo"
oGraph:oAxisX:cText   := "Titulo de Eje X"
oGraph:oAxisYL:cText  := "Titulo de Eje YL"
oGraph:oAxisYR:cText  := "Titulo de Eje YR"

oGraph:lPopUp := .T.

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
oGraph:AutoData()

//Asignar titulos a Columnas
FOR ii = 1 TO oGraph:nColGraph()
 oColumn := oGraph:GetColGraph(ii)
 oColumn:cTitle   := aTitCol[ii]
NEXT ii

//Asignar columnas de valores pequeos a AxisYR
oColumn := oGraph:GetColGraph(5) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(6) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(7) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(8) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(9) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(10) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(15) ; oColumn:lAxisYL  := .F.

//Usar tipo de grafica: Barras
oGraph:GTypeBar()

oColumn := oGraph:GetColGraph(4)
oColumn:GTypeLine()  //Tipo lineas
oColumn:lFill := .F.  //Sin llenado
oColumn:l3D := .F.    //Sin 3D
oColumn:lShowVal := .T.  //Con visualizacion de valores

//Agregar textos de posicion libre
oGraph:AddText( "Texto libre 1", , , , , , , , ,  )

oText := oGraph:AddText( "Cancelled" )
oText:nAngleDeg := 30
oText:PosBottom()
oText:oFontT := oFontX
oText:nClrT := RGB( 128, 0, 0 )

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()

RETURN (NIL)


FUNCTION TGraph3m()
//Ejemplo 15: TGraph 3 con actualizacion cada 5 segundos
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont
LOCAL oText

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-14
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-14

//Datos en matriz
aValues := GETARRAY()
aTitCol := GETTITLES()

//WINDOW para grafica
/* No funciona el Timer cuando se usa DIALOG
Si alguien puede explicar porque, hagalo

Al parecer cuando se usa DIALOG no se tiene valor de ::oWnd:hWnd, por lo
tanto el Timer NO puede asignarse a un hWndOwner determinado
*/
//oGWnd := GraWnd():New( 1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: FiveWin Graphics", GraServer():New(aValues), ;
 .F. , , , , , 5, )   //Actualizar cada 5 segundos

//Tomar grafica
oGraph := oGWnd:oGraph

oGraph:oTitle:cText   := "Actualizacion cada 5 segundos"
oGraph:oSubTitle:cText:= "SubTitulo"
oGraph:oAxisX:cText   := "Titulo de Eje X"
oGraph:oAxisYL:cText  := "Titulo de Eje YL"
oGraph:oAxisYR:cText  := "Titulo de Eje YR"

oGraph:lPopUp := .T.

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
oGraph:AutoData()

//Asignar titulos a Columnas
FOR ii = 1 TO oGraph:nColGraph()
 oColumn := oGraph:GetColGraph(ii)
 oColumn:cTitle   := aTitCol[ii]
NEXT ii

//Asignar columnas de valores pequeos a AxisYR
oColumn := oGraph:GetColGraph(5) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(6) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(7) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(8) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(9) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(10) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(15) ; oColumn:lAxisYL  := .F.

//Usar tipo de grafica: Barras
oGraph:GTypeBar()

oColumn := oGraph:GetColGraph(4)
oColumn:GTypeLine()  //Tipo lineas
oColumn:lFill := .F.  //Sin llenado
oColumn:l3D := .F.    //Sin 3D
oColumn:lShowVal := .T.  //Con visualizacion de valores

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()

RETURN (NIL)


FUNCTION TGraph3n()
//Ejemplo 16: TGraph 3 con avance continuo cada 5 segundos
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont
LOCAL oText

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-14
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-14

//Datos en matriz
aValues := GETARRAY()
aTitCol := GETTITLES()

//WINDOW para grafica
/* No funciona el Timer cuando se usa DIALOG
Si alguien puede explicar porque, hagalo

Al parecer cuando se usa DIALOG no se tiene valor de ::oWnd:hWnd, por lo
tanto el Timer NO puede asignarse a un hWndOwner determinado
*/
//oGWnd := GraWnd():New( 1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: FiveWin Graphics", GraServer():New(aValues), ;
 .F. )
//Otra forma de modificar el Timer
oGWnd:oTimer:bAction := { || oGWnd:ForWard() }
oGWnd:oTimer:nInterval := 5*1000

//Tomar grafica
oGraph := oGWnd:oGraph

oGraph:oTitle:cText   := "Avance continuo cada 5 segundos"
oGraph:oSubTitle:cText:= "SubTitulo"
oGraph:oAxisX:cText   := "Titulo de Eje X"
oGraph:oAxisYL:cText  := "Titulo de Eje YL"
oGraph:oAxisYR:cText  := "Titulo de Eje YR"

oGraph:lPopUp := .T.

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
oGraph:AutoData()

//Asignar titulos a Columnas
FOR ii = 1 TO oGraph:nColGraph()
 oColumn := oGraph:GetColGraph(ii)
 oColumn:cTitle   := aTitCol[ii]
NEXT ii

//Asignar columnas de valores pequeos a AxisYR
oColumn := oGraph:GetColGraph(5) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(6) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(7) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(8) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(9) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(10) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(15) ; oColumn:lAxisYL  := .F.

//Usar tipo de grafica: Barras
oGraph:GTypeBar()

oColumn := oGraph:GetColGraph(4)
oColumn:GTypeLine()  //Tipo lineas
oColumn:lFill := .F.  //Sin llenado
oColumn:l3D := .F.    //Sin 3D
oColumn:lShowVal := .T.  //Con visualizacion de valores

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()

RETURN (NIL)


FUNCTION TGraph3o()
//Ejemplo 17: TGraph 3 en quiosco de tipos de grafica
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont
LOCAL oText

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-14
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-14

//Datos en matriz
aValues := GETARRAY()
aTitCol := GETTITLES()

//WINDOW para grafica
/* No funciona el Timer cuando se usa DIALOG
Si alguien puede explicar porque, hagalo

Al parecer cuando se usa DIALOG no se tiene valor de ::oWnd:hWnd, por lo
tanto el Timer NO puede asignarse a un hWndOwner determinado
*/
//oGWnd := GraWnd():New( 1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: FiveWin Graphics", GraServer():New(aValues), ;
 .F. )

//Tomar grafica
oGraph := oGWnd:oGraph

//Otra forma de modificar el Timer
oGWnd:oTimer:bAction := { || Quiosco( oGWnd ) }
oGWnd:oTimer:nInterval := 5*1000

oGraph:oTitle:cText   := "Quiosco de tipos de grafica"
oGraph:oSubTitle:cText:= "Con navegacion de Filas y Columnas"
oGraph:oAxisX:cText   := "Titulo de Eje X"
oGraph:oAxisYL:cText  := "Titulo de Eje YL"
oGraph:oAxisYR:cText  := "Titulo de Eje YR"

oGraph:lPopUp := .T.

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
oGraph:AutoData()

//Asignar titulos a Columnas
FOR ii = 1 TO oGraph:nColGraph()
 oColumn := oGraph:GetColGraph(ii)
 oColumn:cTitle   := aTitCol[ii]
NEXT ii

//Asignar columnas de valores pequeos a AxisYR
oColumn := oGraph:GetColGraph(5) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(6) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(7) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(8) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(9) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(10) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(15) ; oColumn:lAxisYL  := .F.

//Usar tipo de grafica: Barras
oGraph:GTypeBar()

oColumn := oGraph:GetColGraph(4)
oColumn:GTypeLine()  //Tipo lineas
// oColumn:lFill := .F.  //Sin llenado
// oColumn:l3D := .F.    //Sin 3D
// oColumn:lShowVal := .T.  //Con visualizacion de valores

//Visualizacion global de valores de datos
oGraph:lViewVal := .T.

//Aumentar a 8 el numero de columnas en la Vista
oGraph:nColView := 8

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()

RETURN (NIL)


FUNCTION TGraph3p()
//Ejemplo 18: TGraph 3 en quiosco de tipos de grafica e inversion de ejes
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont
LOCAL oText

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-14
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-14

//Datos en matriz
aValues := GETARRAY()
aTitCol := GETTITLES()

//WINDOW para grafica
/* No funciona el Timer cuando se usa DIALOG
Si alguien puede explicar porque, hagalo

Al parecer cuando se usa DIALOG no se tiene valor de ::oWnd:hWnd, por lo
tanto el Timer NO puede asignarse a un hWndOwner determinado
*/
//oGWnd := GraWnd():New( 1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: FiveWin Graphics", GraServer():New(aValues), ;
 .F. )

//Tomar grafica
oGraph := oGWnd:oGraph

//Otra forma de modificar el Timer
oGWnd:oTimer:bAction := { || Quiosco( oGWnd ) }
oGWnd:oTimer:nInterval := 5*1000

oGraph:oTitle:cText   := "Quiosco de tipos de grafica"
oGraph:oSubTitle:cText:= "Con navegacion e Inversion de Ejes"
oGraph:oAxisX:cText   := "Titulo de Eje X"
oGraph:oAxisYL:cText  := "Titulo de Eje YL"
oGraph:oAxisYR:cText  := "Titulo de Eje YR"

oGraph:lPopUp := .T.

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
oGraph:AutoData()

//Asignar titulos a Columnas
FOR ii = 1 TO oGraph:nColGraph()
 oColumn := oGraph:GetColGraph(ii)
 oColumn:cTitle   := aTitCol[ii]
NEXT ii

//Asignar columnas de valores pequeos a AxisYR
oColumn := oGraph:GetColGraph(5) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(6) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(7) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(8) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(9) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(10) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(15) ; oColumn:lAxisYL  := .F.

//Usar tipo de grafica: Barras
oGraph:GTypeBar()

oColumn := oGraph:GetColGraph(4)
oColumn:GTypeLine()  //Tipo lineas
// oColumn:lFill := .F.  //Sin llenado
// oColumn:l3D := .F.    //Sin 3D
// oColumn:lShowVal := .T.  //Con visualizacion de valores

//Visualizacion global de valores de datos
oGraph:lViewVal := .T.

//Aumentar a 8 el numero de columnas en la Vista
oGraph:nColView := 8

//Inversion de Ejes
oGraph:lAxisInv := .T.

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()

RETURN (NIL)


FUNCTION TGraph3q()
//Ejemplo 19: TGraph 3 en grafica de un archivo DBF
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont
LOCAL cFile

IF Empty( ( cFile:=cGetFile32("Archivos DBF|*.dbf","Seleccionar archivo DBF" ) ) )
 RETURN NIL
ENDIF

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-14
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-14

USE (cFile) SHARED

//WINDOW para grafica
//oGWnd := GraWnd():New( 1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: FiveWin Graphics", GraServer():New( ALIAS() ) )

//Tomar grafica
oGraph := oGWnd:oGraph

oGraph:oTitle:cText   := "Archivo DBF como fuente de datos"
oGraph:oSubTitle:cText:= "SubTitulo"
oGraph:oAxisX:cText   := "Titulo de Eje X"
oGraph:oAxisYL:cText  := "Titulo de Eje YL"
oGraph:oAxisYR:cText  := "Titulo de Eje YR"

oGraph:lPopUp := .T.

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
oGraph:AutoData()

//Usar tipo de grafica: Barras
oGraph:GTypeBar()

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()

RETURN (NIL)


FUNCTION TGraph3r()
//Ejemplo 20: TGraph 3 con grafica de funciones matematicas
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-14
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-14

//Datos en matriz
aValues := { }
FOR ii = -2 TO 10 STEP 0.2
 AADD( aValues, { ii } )
NEXT ii


//WINDOW para grafica
//oGWnd := GraWnd():New( 1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: FiveWin Graphics", GraServer():New(aValues) )

//Tomar grafica
oGraph := oGWnd:oGraph

oGraph:oTitle:cText   := "Graficas de funciones matematicas"
oGraph:oSubTitle:cText:= "SubTitulo"
oGraph:oAxisX:cText   := "Titulo de Eje X"
oGraph:oAxisYL:cText  := "Titulo de Eje YL"
oGraph:oAxisYR:cText  := "Titulo de Eje YR"

oGraph:lPopUp := .T.

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
// oGraph:AutoData()

//La primer columna de ::oData son los valores y/o etiquetas en AxisX
oGraph:oAxisX:bBlock := { | nParam, oData | oData:FieldGet(nParam) }
oGraph:oAxisX:nIndex := 1
//Agregar las demas columnas
oGraph:nCurWheel := 1
//El numero indica el numero de columna en la fuente de datos

oColumn := oGraph:AddColumn( { |nParam,oData| X:=oData:FieldGet(1), 2*x*x-18*x+5 }, ;
           "2 * X * X - 18 * X + 5", oGraph:GetClrWheel(), , 2 )
oColumn := oGraph:AddColumn( { |nParam,oData| X:=oData:FieldGet(1), 10*sin(x*2)/x }, ;
           "10 * Sin( 2 * X ) / X", oGraph:GetClrWheel(), , 2 )
oColumn:lAxisYL := .F.


//Usar tipo de grafica: Lineas
oGraph:GTypeLine()

//Forzar escala numerica en X
oGraph:oAxisX:lAxisScale := .T.

//Ver todas las Filas
oGraph:nRowView := LEN( aValues )

//Algo de color
oGraph:nClrBack := CLR_HCYAN

//Suprimir 3D
oGraph:l3D := .F.

//Leyendas a la izquierda
oGraph:oLegend:PosLeft()

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()

RETURN (NIL)


FUNCTION TGraph3s()
//Ejemplo 21: TGraph 3 con escalamiento de datos
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-14
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-10

//Datos en matriz
aValues := { }
FOR ii = 40 TO 120 STEP 5
 AADD( aValues, { ii } )
NEXT ii

//WINDOW para grafica
//oGWnd := GraWnd():New( 1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: FiveWin Graphics", GraServer():New(aValues) )

//Tomar grafica
oGraph := oGWnd:oGraph

oGraph:oTitle:cText   := "Escalamiento de datos"
oGraph:oSubTitle:cText:= "SubTitulo"
oGraph:oAxisX:cText   := "T: Temperatura agua F"
oGraph:oAxisYL:cText  := "Entalpia en BTU/lb"
oGraph:oAxisYR:cText  := "Entalpia en BTU/lb"

oGraph:lPopUp := .T.

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
// oGraph:AutoData()

//La primer columna de ::oData son los valores y/o etiquetas en AxisX
oGraph:oAxisX:bBlock := { | nParam, oData | oData:FieldGet(nParam) }
oGraph:oAxisX:nIndex := 1
//Agregar las demas columnas
oGraph:nCurWheel := 1
//El numero indica el numero de columna en la fuente de datos
//Notar que ambas columnas contienen el mismo conjunto de datos
oColumn := oGraph:AddColumn( { |nParam,oData| X:=oData:FieldGet(1), 10**(0.758+0.011*X) }, ;
           "10**(0.758+0.011*T)", oGraph:GetClrWheel(), , 2 )
oColumn := oGraph:AddColumn( { |nParam,oData| X:=oData:FieldGet(1), 10**(0.758+0.011*X) }, ;
           "10**(0.758+0.011*T)", oGraph:GetClrWheel(), , 2 )
oColumn:lAxisYL := .F.

//Usar tipo de grafica: Lineas
oGraph:GTypeLine()

//Ver todas las Filas
oGraph:nRowView := LEN( aValues )

//Algo de color
oGraph:nClrBack := CLR_HCYAN

//Suprimir 3D
oGraph:l3D := .F.

//Leyendas a la izquierda
oGraph:oLegend:PosLeft()

//Escalar datos asignados a oAxisYR (Columna 2) usando logaritmo decimal
oGraph:oAxisYR:bToScale := { | nVal | LOG(nVal)/LOG(10) }
oGraph:oAxisYR:cToScale := "Log10 de entalpia"
oGraph:oAxisYR:cHeader := "Log10"

//Forzar escala numerica en X
oGraph:oAxisX:lAxisScale := .T.
oGraph:oAxisX:nStepOne := 20

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()

RETURN (NIL)


FUNCTION TGraph3t()
//Ejemplo 22: TGraph 3 con ejes logaritmicos
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-24 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-14
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-10

//Datos en matriz
aValues := { }
FOR ii = 10 TO 60 STEP 5
 AADD( aValues, { ii } )
NEXT ii

//WINDOW para grafica
//oGWnd := GraWnd():New( 1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: FiveWin Graphics", GraServer():New(aValues) )

//Tomar grafica
oGraph := oGWnd:oGraph

oGraph:oTitle:cText   := "Ejes logaritmicos"
oGraph:oSubTitle:cText:= "SubTitulo"
oGraph:oAxisX:cText   := "P: Presion"
oGraph:oAxisYL:cText  := "Volumen"
oGraph:oAxisYR:cText  := "Volumen"

oGraph:lPopUp := .T.

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:nCurWheel := 2
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
// oGraph:AutoData()

//La primer columna de ::oData son los valores y/o etiquetas en AxisX
oGraph:oAxisX:bBlock := { | nParam, oData | oData:FieldGet(nParam) }
oGraph:oAxisX:nIndex := 1
//Agregar las demas columnas
oGraph:nCurWheel := 1
//El numero indica el numero de columna en la fuente de datos

//Notar que ambas columnas contienen el mismo conjunto de datos
oColumn := oGraph:AddColumn( { |nParam,oData| X:=oData:FieldGet(1), 328.942*X**(-0.938) }, ;
           "328.942*P**(-0.938)", oGraph:GetClrWheel(), , 2 )
oColumn := oGraph:AddColumn( { |nParam,oData| X:=oData:FieldGet(1), 328.942*X**(-0.938) }, ;
           "328.942*P**(-0.938)", oGraph:GetClrWheel(), , 2 )
oColumn:lAxisYL := .F.

//Usar tipo de grafica: Lineas
oGraph:GTypeLine()

//Ver todas las Filas
oGraph:nRowView := LEN( aValues )

//Algo de color
oGraph:nClrBack := CLR_HCYAN

//Suprimir 3D
oGraph:l3D := .F.

//Forzar escala numerica en X
oGraph:oAxisX:lAxisScale := .T.
//Logaritmo decimal en AxisX
oGraph:oAxisX:nAxisLog := 1
oGraph:oAxisX:cHeader := "Log(10)"

//Logaritmo decimal en AxisYL
oGraph:oAxisYL:nAxisLog := 1
oGraph:oAxisYL:cHeader := "Log(10)"
//Logaritmo natural en AxisYR
oGraph:oAxisYR:nAxisLog := 2
oGraph:oAxisYR:cHeader := "Log(e)"
//Escalamiento manual en AxisYR
oGraph:oAxisYR:lAutoSize := .F.
oGraph:oAxisYR:nAxisMin := 5
oGraph:oAxisYR:nAxisMax := 20
//Ocultar Grid de oAxisYR
oGraph:oAxisYR:lGrid := .F.

//Textos de ejes a la derecha
oGraph:oAxisX:AliRight()
oGraph:oAxisYL:AliRight()
oGraph:oAxisYR:AliRight()

//Marcos a textos
oGraph:oTitle:lFrame := .T.
oGraph:oSubTitle:lFrame := .T.
oGraph:oAxisX:lFrame := .T.
oGraph:oAxisYL:lFrame := .T.
oGraph:oAxisYR:lFrame := .T.

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()

RETURN (NIL)


FUNCTION TGraph3u()
//Ejemplo 23: TGraph 3 con nAxisBase y leyendas
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-14
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-14

//Datos en matriz
aValues := GETARRAY()
aTitCol := GETTITLES()

//WINDOW para grafica
//oGWnd := GraWnd():New( 1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: FiveWin Graphics", GraServer():New(aValues) )

//Tomar grafica
oGraph := oGWnd:oGraph

oGraph:oTitle:cText   := "nAxisBase y Leyendas"
oGraph:oSubTitle:cText:= "SubTitulo"
oGraph:oAxisX:cText   := "Titulo de Eje X"
oGraph:oAxisYL:cText  := "Titulo de Eje YL"
oGraph:oAxisYR:cText  := "Titulo de Eje YR"

oGraph:lPopUp := .T.

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
oGraph:AutoData()

//Asignar titulos a Columnas
FOR ii = 1 TO oGraph:nColGraph()
 oColumn := oGraph:GetColGraph(ii)
 oColumn:cTitle   := aTitCol[ii]
NEXT ii

//Asignar columnas de valores pequeos a AxisYR
oColumn := oGraph:GetColGraph(5) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(6) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(7) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(8) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(9) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(10) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(15) ; oColumn:lAxisYL  := .F.

oColumn := oGraph:GetColGraph(4)
oColumn:GTypeLine()  //Tipo lineas
oColumn:lFill := .F.  //Sin llenado
oColumn:l3D := .F.    //Sin 3D
oColumn:lShowVal := .T.  //Con visualizacion de valores

//Usar tipo de grafica: Barras
oGraph:GTypeBar()

//Algo de color
oGraph:nClrBack := CLR_HCYAN

//AxisYL con nAxisBase diferente de 0
oGraph:oAxisYL:nAxisBase := 40

//Leyendas en el fondo y centradas
oGraph:oLegend:PosBottom()
oGraph:oLegend:AliCenter()
oGraph:oLegend:lFrame := .T.

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()

RETURN (NIL)


FUNCTION TGraph3v()
//Ejemplo 24: TGraph 3 y solucion de ecuaciones con una variable
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont
LOCAL oText
/* Observacion:
Se puede resolver la ecuacion y calcular el conjunto de datos antes
de graficarlos; sin embargo, no se hace asi porque el objetivo del
ejemplo es mostrar dos de las capacidades de TGraph 3:
- Aplicacion de procesos iterativos
- Modificacion dinamica de los datos de la grafica
*/

// solucion de ecuaciones de una variable  ** mn1.ev (prg) **
// rem i.q. david arturo macias corona     abril 1989

PRIV nMetNum, aMetNum
PRIV n,e,x0,f,x1,d,bf,bd
PRIV a,b,p,i,x2,x3,xn,xs
PRIV lFin  //Para lClipXnet

aMetNum := { "1.- particion de intervalo", ;
             "2.- iteraciones sucesivas", ;
             "3.- newton", ;
             "4.- secante", ;
             "5.- steffenson" }

// rem *** sbr entrada de datos ***
n := 100       //Iteraciones maximas
e := 0.000001  //tolerancia de error
x0 := 1          //valor inicial
x1 := 500        //valor final
//f := "3*x**2-exp(x)+2*x"   //f(x)   Funcion
//d := "2*3*x-exp(x)+2"      //df(x)/dx=f'(x)  Primer derivada de la funcion

// f := "x+sin(x)"
// d := "1+cos(x)"

//Ecuacion de Van Der Waals para el volumen de una mezcla de gases particular
f := "x**3-385*x**2+25600*x-1150000"
d := "3*x**2-385*2*x+25600"

//Metodo a aplicar
nMetNum := 3

//Inicializacion
bf := &("{ |x|"+f+"}")  //Bloque para evaluar la funcion

//Datos en matriz
aValues := { { 0, x0, EVAL(bf,x0)} }

i:=1  //Contador de iteraciones
DO CASE
CASE nMetNum == 1  //rem *** particion de intervalo ***
d := abs(x1-x0)
n := int((log(d)-log(e))/log(2))+10
a := ARRAY( n )
b := ARRAY( n )
p := ARRAY( n )
a[i]:=x0
b[i]:=x1

CASE nMetNum == 2  //rem *** iteraciones sucesivas ***
// "recuerde: x = g(x) = f(x)+x"
//Aplicar g(x)=f(x)+x
bf := &("{ |x|"+f+" + x }")  //Bloque para evaluar la funcion
x2:=x0
d:=100000

CASE nMetNum == 3  //rem *** metodo de newton ***
bd := &("{ |x|"+d+"}")  //Bloque para evaluar la derivada de la funcion

CASE nMetNum == 4  //rem *** metodo de la secante ***

CASE nMetNum == 5  //rem *** metodo de steffenson ***
// rem (iteraciones sucesivas modificado)
// "recuerde: x = g(x) = f(x)+x"
//Aplicar g(x)=f(x)+x
bf := &("{ |x|"+f+" + x }")  //Bloque para evaluar la funcion

ENDCASE

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-14
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-14

//WINDOW para grafica
/* No funciona el Timer cuando se usa DIALOG
Si alguien puede explicar porque, hagalo

Al parecer cuando se usa DIALOG no se tiene valor de ::oWnd:hWnd, por lo
tanto el Timer NO puede asignarse a un hWndOwner determinado
*/
//oGWnd := GraWnd():New( 1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: FiveWin Graphics", GraServer():New(aValues), ;
 .F. )

//Tomar grafica
oGraph := oGWnd:oGraph

//Otra forma de modificar el Timer
oGWnd:oTimer:bAction := { || Mn1Eva( oGWnd ) }
oGWnd:oTimer:nInterval := 3*1000

oGraph:oTitle:cText   := "Solucion de ecuaciones de una variable"
oGraph:oSubTitle:cText:= aMetNum[ nMetNum ]

oGraph:oAxisX:cText   := "Iteraciones"
oGraph:oAxisYL:cText  := "Valor de x"
oGraph:oAxisYR:cText  := "Funcion de x"
oGraph:oAxisYR:cHeader  := "f(x)"

SET DECI TO 6
oGraph:oAxisYL:bToLabel := { |nData| Transform(nData,"9,9999.999") }
//oGraph:oAxisYR:bToLabel := { |nData| Transform(nData,"9,9999.999999") }
oGraph:oAxisYR:bToLabel := { |nData| ALLTRIM(STR(nData,14,6)) }

oGraph:lPopUp := .T.

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
oGraph:AutoData()

//bToLabel y propiedades particulares por columna
oColumn := oGraph:GetColGraph(1)
oColumn:cTitle   := "Valor de X"
oColumn:bToLabel := { |nData| Transform(nData,"9,9999.999999") }
oColumn:oFontL   := oFontT
// oColumn:lFrame   := .T.

oColumn := oGraph:GetColGraph(2)
oColumn:cTitle   := "f(x)="+f
oColumn:lAxisYL  := .F.
oColumn:bToLabel := { |nData| Transform(nData,"9,9999.99") }

//Usar tipo de grafica: Lineas
oGraph:GTypeLine()

//Visualizacion global de valores de datos
oGraph:lViewVal := .T.

oGraph:l3D := .F.

//Leyendas en el fondo y centradas
oGraph:oLegend:PosBottom()
oGraph:oLegend:AliCenter()
oGraph:oLegend:lFrame := .T.

IF lClipxNet
 lFin := .F.
 WHILE ! lFin
  EVAL( oGWnd:oTimer:bAction )
 ENDD

 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()

RETURN (NIL)


FUNCTION TGraph3w()
//Ejemplo 25: TGraph 3 con valores en tiempo real para Kleyber Derick
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont
LOCAL oText

/*
Este ejemplo se elabora como respuesta a una peticion de Kleyber Derick
En realidad el ejemplo conjunta caracteristicas de otros ejemplos, pero se
incluye como un aplicacion en un requerimiento especifico


El caso de Kleyber Derick es un caso de los varios que se pensaron cuando
le inclui a TGraph 3 un proceso iterativo, que sirviera para situaciones como:
+ Grafica en tiempo real de las producciones de un grupo de maquinas
+ Grafica en tiempo real de las operaciones de una cadena de tiendas
+ Grafica en tiempo real de las ventas de tipos de articulos o por
  departamento en una o mas tiendas

La peticion original es:

>     Quando falo em "atualizao de dados", refiro-me a um grfico que
estou
> fazendo, onde as 4 barras representam as compras, vendas, rentabilidade
> bruta e rentabilidade liquida. Como o programa funciona em rede,
obviamente
> os valores so modificados a cada instante e com o grfico atualizando a
> cada 5 segundos, permitiria ao usurio ver como est sua empresa a cada
> momento, pois o grfico l todas as informaes de compras, de vendas e
faz
> os clculos de rentabilidade, antes de gerar o grfico. Os clculos eu j
> tenho, s falta saber coloc-los no (*maravilhoso)grfico.
>
>     Gracias novamente.
>
> --
> Kleyber Derick Batalha Ribeiro
> Analista de Sistemas
> KGC Informdia Ltda
> email: kleyber@kgc.com.br
>           kleyberderick@ig.com.br
> Internet: www.kgc.com.br

junto con:

    I liked very much TGraph 3 and I just need an example of TGraph3m which
make updates each 5 seconds to, in my case, 12 columns and 4 bars,
(representing all months of a year and 4 products) that I want to update
even all data has changed. The example I saw is a little bit complicated to
my (still) poor knowledge. I don't know how to do this and I need to learn a
little bit more.

y la traduccion por Pedro Gonzalez es:

Cuando hablo de "actualizacin de datos", me refiero a un grfico que estoy
haciendo,
donde las 4 barras representan las compras, ventas, rentabilidad bruta y
rentabilidad liquida.
Como el programa funciona en red, obviamente los valores son modificados a
cada instante, y con
el grfico actualizandose cada 5 segundos, permitira al usuario visualizar
como est su empresa
en cada momento, pues el grafico lee todas las informaciones de compras, de
ventas y hace los
calculos de rentabilidad, antes de genera el grfico. Los calculos yo ya los
tengo, solo me falta saber
como colocarlos en el (*maravilloso*) grfico.


Para abundar en el ejemplo, se haran diversas suposiciones y se trataran
tres casos diferentes:
a) Valores calculados por TGraph 3 y aplicados en una matriz en memoria
b) Valores tomados por TGraph 3 desde un archivo DBF y aplicados en una matriz en memoria
c) Valores tomados por TGraph 3 desde un archivo DBF y usados directamente del archivo

En el ejemplo se ira diferenciando el codigo para cada caso

*/

PRIV nCaso     //Caso a aplicar
PRIV aMatriz   //Matriz de valores

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-14
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-14


//Caso a aplicar
IF lclipxnet
 nCaso := 3
ELSE
 nCaso := 1
ENDI

//WINDOW para grafica
/* No funciona el Timer cuando se usa DIALOG
Si alguien puede explicar porque, hagalo

Al parecer cuando se usa DIALOG no se tiene valor de ::oWnd:hWnd, por lo
tanto el Timer NO puede asignarse a un hWndOwner determinado
*/

DO CASE
CASE nCaso == 1
//Matriz nula para creacion de grafica
aMatriz := { { "NIL", 0, 0, 0, 0 } }
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: KGC Informdia Ltda", GraServer():New(aMatriz), ;
 .F. )

CASE nCaso == 2
//Matriz nula para creacion de grafica
aMatriz := { { "NIL", 0, 0, 0, 0 } }
VerKley()  //Verificar que exista la base de datos
// Abrir base de datos compartida
USE kleyber SHARED

oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: KGC Informdia Ltda", GraServer():New(aMatriz), ;
 .F. )

CASE nCaso == 3
VerKley()  //Verificar que exista la base de datos
// Abrir base de datos compartida
USE kleyber SHARED

//WINDOW para grafica
//oGWnd := GraWnd():New( 1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph 3: KGC Informdia Ltda", GraServer():New( ALIAS() ), ;
 .F. )

ENDC

//Tomar grafica
oGraph := oGWnd:oGraph

//Otra forma de modificar el Timer
oGWnd:oTimer:bAction := { || ActGrafica( oGWnd ) }
oGWnd:oTimer:nInterval := 5*1000  //Cada 5 segundos

oGraph:oTitle:cText   := "Valores en tiempo real"
oGraph:oSubTitle:cText:= "para Kleyber Derick"
oGraph:oAxisX:cText   := "M e s e s"
oGraph:oAxisYL:cText  := "Titulo de Eje YL"

// SET DECI TO 6
// oGraph:oAxisYL:bToLabel := { |nData| Transform(nData,"9,9999.999") }
// oGraph:oAxisYR:bToLabel := { |nData| Transform(nData,"9,9999.999999") }
// oGraph:oAxisYR:bToLabel := { |nData| ALLTRIM(STR(nData,14,6)) }

oGraph:lPopUp := .T.

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
//oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
//oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

DO CASE
CASE nCaso == 1
//Asignar automaticamente las Columnas del servidor de datos
oGraph:AutoData()
//Asignar titulos a columnas
oGraph:GetColGraph(1):cTitle   := "Compras"
oGraph:GetColGraph(2):cTitle   := "Ventas"
oGraph:GetColGraph(3):cTitle   := "Renta. bruta"
oGraph:GetColGraph(4):cTitle   := "Renta. neta"

CASE nCaso == 2
//Asignar automaticamente las Columnas del servidor de datos
oGraph:AutoData()
//Asignar titulos a columnas
oGraph:GetColGraph(1):cTitle   := "Compras"
oGraph:GetColGraph(2):cTitle   := "Ventas"
oGraph:GetColGraph(3):cTitle   := "Renta. bruta"
oGraph:GetColGraph(4):cTitle   := "Renta. neta"

CASE nCaso == 3
//Asignar manualmente las Columnas del servidor de datos
//para que sirva para cualquier posicion de los campos en el archivo DBF

//La primer columna de ::oData son los valores y/o etiquetas en AxisX
oGraph:oAxisX:bBlock := { | nParam, oData | oData:FieldGet(FIELDPOS("MES")) }
oGraph:oAxisX:nIndex := 1
//Agregar las demas columnas
oGraph:nCurWheel := 1

//El numero indica el numero de columna en la fuente de datos
oColumn := oGraph:AddColumn( { |nParam,oData| AsNumber(oData:FieldGet(FIELDPOS("COMPRAS"))) }, ;
                 "Compras", oGraph:GetClrWheel(), , 2 )
oColumn := oGraph:AddColumn( { |nParam,oData| AsNumber(oData:FieldGet(FIELDPOS("VENTAS"))) }, ;
                 "Ventas", oGraph:GetClrWheel(), , 3 )
oColumn := oGraph:AddColumn( { |nParam,oData| AsNumber(oData:FieldGet(FIELDPOS("RBRUTA"))) }, ;
                 "Renta. bruta", oGraph:GetClrWheel(), , 4 )
oColumn := oGraph:AddColumn( { |nParam,oData| AsNumber(oData:FieldGet(FIELDPOS("RNETA"))) }, ;
                 "Renta. neta", oGraph:GetClrWheel(), , 5 )

ENDC

//Usar tipo de grafica: Barras
oGraph:GTypeBar()

//bToLabel y propiedades particulares por columna
oColumn := oGraph:GetColGraph(4)
oColumn:bToLabel := { |nData| Transform(nData,"9,9999.999") }
oColumn:oFontL   := oFontT
// oColumn:lFrame   := .T.

//Visualizacion global de valores de datos
oGraph:lViewVal := .T.

//Leyendas en el fondo y centradas
oGraph:oLegend:PosBottom()
oGraph:oLegend:AliCenter()
oGraph:oLegend:lFrame := .T.

//Visualizar 12 Filas
oGraph:nRowView := 12

//Visualizar 4 Columnas
oGraph:nColView := 4

ActGrafica( oGWnd )  //Actualizar matriz en primera ocasion

IF lClipxNet
 ACTIVATE WINDOW oGWnd:oWnd  ON INIT (   ;
  oGraph:Save2BMP( cArcTG3 ), ;
  oGWnd:oWnd:End() )
ELSE
 oGWnd:Activate()
ENDI

oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()

RETURN (NIL)


FUNCTION TGraph3x()
//Ejemplo 26: TGraph 3 con impresion directa
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont

LOCAL nLin
LOCAL nCol
LOCAL A0, A1, ALTO
LOCAL B0, B1, ANCHO

LOCAL oPrn

IF ! MsgYesNo( "Aplicar prueba de impresion directa ?" )
 RETU NIL
ENDI

PRINT oPrn
DEFINE FONT oFont NAME "Arial" SIZE 0,-25 BOLD OF oPrn
PAGE

nLin := oPrn:nVertRes() / 66   // Pixels en vertical 3969
nCol := oPrn:nHorzRes() / 80   // Pixels en horizont 2892

A0 := 3
B0 := 3
oPrn:Say( A0*nLin, B0*nCol, "Hola mundo", oFont,,RGB(0,0,0) )

A0 := 5
B0 := 3
oPrn:Say( A0*nLin, B0*nCol, "Saludos desde Guadalajara, Jalisco, Mexico", oFont,,RGB(0,0,0))

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-14
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-14

//Datos en matriz
aValues := { }
FOR ii = -2 TO 10 STEP 0.2
 AADD( aValues, { ii } )
NEXT ii

//WINDOW para grafica
oGWnd := GraWnd():New( 1,1, 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1), ;
 "TGraph3x(): TGraph 3 con impresion directa", GraServer():New(aValues) )

//Tomar grafica
oGraph := oGWnd:oGraph

oGraph:oTitle:cText   := "Graficas de funciones matematicas"
oGraph:oSubTitle:cText:= "SubTitulo"
oGraph:oAxisX:cText   := "Titulo de Eje X"
oGraph:oAxisYL:cText  := "Titulo de Eje YL"
oGraph:oAxisYR:cText  := "Titulo de Eje YR"

oGraph:lPopUp := .T.

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
// oGraph:AutoData()

//La primer columna de ::oData son los valores y/o etiquetas en AxisX
oGraph:oAxisX:bBlock := { | nParam, oData | oData:FieldGet(nParam) }
oGraph:oAxisX:nIndex := 1
//Agregar las demas columnas
oGraph:nCurWheel := 1
//El numero indica el numero de columna en la fuente de datos

oColumn := oGraph:AddColumn( { |nParam,oData| X:=oData:FieldGet(1), 2*x*x-18*x+5 }, ;
           "2 * X * X - 18 * X + 5", oGraph:GetClrWheel(), , 2 )
oColumn := oGraph:AddColumn( { |nParam,oData| X:=oData:FieldGet(1), 10*sin(x*2)/x }, ;
           "10 * Sin( 2 * X ) / X", oGraph:GetClrWheel(), , 2 )
oColumn:lAxisYL := .F.

//Usar tipo de grafica: Barras
oGraph:GTypeBar()

//Forzar escala numerica en X
oGraph:oAxisX:lAxisScale := .T.

//Ver todas las Filas
oGraph:nRowView := LEN( aValues )

//Leyendas en el fondo y centradas
oGraph:oLegend:PosBottom()
oGraph:oLegend:AliCenter()
oGraph:oLegend:lFrame := .T.

A0 := 8
B0 := 5
A1 := 25*1.5
B1 := 50*1.5

nLin := oPrn:nVertRes() / 66   // Pixels en vertical 3969
nCol := oPrn:nHorzRes() / 80   // Pixels en horizont 2892
ALTO:= A1-A0
ANCHO:=B1-B0

ACTIVATE WINDOW oGWnd:oWnd ON INIT ( ;
 oGraph:Print( oPrn, A0*nLin, B0*nCol , ancho*nCol, alto*nLin), ;
 oGWnd:oWnd:End() )

oFontT:End()
oFontX:End()
oFontY:End()

ENDPAGE
ENDPRINT

oGWnd:End()
oFont:End()
oPrn:End()

RETURN (NIL)


FUNCTION TGraph3y()
//Ejemplo 27: TGraph 3 sin ventana de navegacion (o como control)
Local aValues, aTitCol
Local oGWnd, oGraph, oColumn, ii
LOCAL oFontT, oFontX, oFontY, oFont

LOCAL oGraph2
LOCAL nX1, nY1, nW1, nH1
LOCAL nX2, nY2, nW2, nH2

   // Other fonts
   //
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-15
   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-9 BOLD ITALIC
   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-7
   DEFINE FONT oFontY NAME "Times New Roman" SIZE 0,-7

//WINDOW para grafica
DEFINE WINDOW oGWnd FROM 1,1 TO 35*IF(lClipxNet,4/5,1), 100*IF(lClipxNet,4/5,1) ;
 TITLE "TGraph3y(): TGraph 3 sin ventana de navegacion (o como control)" ;
 COLOR Rgb(192,192,192),Rgb(192,192,192)

@ 0, 10 SAY "Hola Mundo !  " OF oGWnd COLOR "B/W"
@ 1, 10 SAY "Saludos desde Guadalajara, Jalisco, Mexico" OF oGWnd COLOR "B/W"
@ 2, 10 SAY "Controles TGraph 3  " OF oGWnd COLOR "R/W"

//Para primer grafica

//Datos en matriz
aValues := GETARRAY()
aTitCol := GETTITLES()

//Asignar una grafica
//Dimensiones en fraccion
nX1 := (10/80)
nY1 := ( 3/25)
nW1 := (60/80)
nH1 := (10/25)

oGraph := TGraph():New( nY1, nX1, oGWnd, nW1, nH1 )

//Asignar el servidor de datos
oGraph:oData := GraServer():New(aValues)

oGraph:oTitle:cText   := "Columnas con valores particulares"
oGraph:oSubTitle:cText:= "SubTitulo"
oGraph:oAxisX:cText   := "Titulo de Eje X"
oGraph:oAxisYL:cText  := "Titulo de Eje YL"
oGraph:oAxisYR:cText  := "Titulo de Eje YR"

oGraph:lPopUp := .T.

//Asignar Fonts
oGraph:oTitle:oFontT:=oFontT
oGraph:oSubTitle:oFontT:=oFontT
oGraph:oAxisX:oFontT:=oFontT
oGraph:oAxisYL:oFontT:=oFontT
oGraph:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph:oTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oSubTitle:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisX:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYL:nClrT:=oGraph:GetClrWheel( )
oGraph:oAxisYR:nClrT:=oGraph:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
oGraph:AutoData()

//Asignar titulos a Columnas
FOR ii = 1 TO oGraph:nColGraph()
 oColumn := oGraph:GetColGraph(ii)
 oColumn:cTitle   := aTitCol[ii]
NEXT ii

//Asignar columnas de valores pequeos a AxisYR
oColumn := oGraph:GetColGraph(5) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(6) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(7) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(8) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(9) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(10) ; oColumn:lAxisYL  := .F.
oColumn := oGraph:GetColGraph(15) ; oColumn:lAxisYL  := .F.

//Usar tipo de grafica: Barras
oGraph:GTypeBar()

oColumn := oGraph:GetColGraph(4)
oColumn:GTypeLine()  //Tipo lineas
oColumn:lFill := .F.  //Sin llenado
oColumn:l3D := .F.    //Sin 3D
oColumn:lShowVal := .T.  //Con visualizacion de valores

oGraph:lFill := .F.  //Sin llenado

//Algo de color
oGraph:nClrBack := CLR_HCYAN


//Para segunda grafica

//Datos en matriz
aValues := { }
FOR ii = -2 TO 10 STEP 0.2
 AADD( aValues, { ii } )
NEXT ii

//Dimensiones en fraccion
nX2 := nX1 + 10/80
nY2 := nY1 + nH1 + 0/25
nW2 := (40/80)
nH2 := (10/25)

oGraph2 := TGraph():New( nY2, nX2, oGWnd, nW2, nH2 )

//Asignar el servidor de datos
oGraph2:oData := GraServer():New(aValues)

oGraph2:oTitle:cText   := "Graficas de funciones matematicas"
oGraph2:oSubTitle:cText:= "SubTitulo"
oGraph2:oAxisX:cText   := "Titulo de Eje X"
oGraph2:oAxisYL:cText  := "Titulo de Eje YL"
oGraph2:oAxisYR:cText  := "Titulo de Eje YR"

oGraph2:lPopUp := .T.

//Asignar Fonts
oGraph2:oTitle:oFontT:=oFontT
oGraph2:oSubTitle:oFontT:=oFontT
oGraph2:oAxisX:oFontT:=oFontT
oGraph2:oAxisYL:oFontT:=oFontT
oGraph2:oAxisYR:oFontT:=oFontT

//Asignar colores
oGraph2:oTitle:nClrT:=oGraph2:GetClrWheel( )
oGraph2:oSubTitle:nClrT:=oGraph2:GetClrWheel( )
oGraph2:oAxisX:nClrT:=oGraph2:GetClrWheel( )
oGraph2:oAxisYL:nClrT:=oGraph2:GetClrWheel( )
oGraph2:oAxisYR:nClrT:=oGraph2:GetClrWheel( )

//Asignar automaticamente las Columnas del servidor de datos
// oGraph2:AutoData()

//La primer columna de ::oData son los valores y/o etiquetas en AxisX
oGraph2:oAxisX:bBlock := { | nParam, oData | oData:FieldGet(nParam) }
oGraph2:oAxisX:nIndex := 1
//Agregar las demas columnas
oGraph2:nCurWheel := 1
//El numero indica el numero de columna en la fuente de datos

oColumn := oGraph2:AddColumn( { |nParam,oData| X:=oData:FieldGet(1), 2*x*x-18*x+5 }, ;
           "2 * X * X - 18 * X + 5", oGraph2:GetClrWheel(), , 2 )
oColumn := oGraph2:AddColumn( { |nParam,oData| X:=oData:FieldGet(1), 10*sin(x*2)/x }, ;
           "10 * Sin( 2 * X ) / X", oGraph2:GetClrWheel(), , 2 )
oColumn:lAxisYL := .F.

//Usar tipo de grafica: Barras
oGraph2:GTypeBar()

//Forzar escala numerica en X
oGraph2:oAxisX:lAxisScale := .T.

//Ver todas las Filas
oGraph2:nRowView := LEN( aValues )

//Leyendas en el fondo y centradas
oGraph2:oLegend:PosBottom()
oGraph2:oLegend:AliCenter()
oGraph2:oLegend:lFrame := .T.

//Visualizacion con redimensionamiento de graficas
IF lClipxNet
ACTIVATE WINDOW oGWnd ;
 ON PAINT ( oGraph:nLeft := nX1*oGWnd:nWidth(), oGraph:nTop := nY1*oGWnd:nHeight(), ;
 oGraph:nWidth := nW1*oGWnd:nWidth(), oGraph:nHeight := nH1*oGWnd:nHeight(), ;
 oGraph:Refresh(.f.), ;
 oGraph2:nLeft := nX2*oGWnd:nWidth(), oGraph2:nTop := nY2*oGWnd:nHeight(), ;
 oGraph2:nWidth := nW2*oGWnd:nWidth(), oGraph2:nHeight := nH2*oGWnd:nHeight(), ;
 oGraph2:Refresh(.f.) ;
 ) ;
 ON INIT (   ;
  Wnd2BMP( cArcTG3, oGWnd ), ;
  oGWnd:End() )
ELSE
ACTIVATE WINDOW oGWnd ;
 ON PAINT ( oGraph:nLeft := nX1*oGWnd:nWidth(), oGraph:nTop := nY1*oGWnd:nHeight(), ;
 oGraph:nWidth := nW1*oGWnd:nWidth(), oGraph:nHeight := nH1*oGWnd:nHeight(), ;
 oGraph:Refresh(.f.), ;
 oGraph2:nLeft := nX2*oGWnd:nWidth(), oGraph2:nTop := nY2*oGWnd:nHeight(), ;
 oGraph2:nWidth := nW2*oGWnd:nWidth(), oGraph2:nHeight := nH2*oGWnd:nHeight(), ;
 oGraph2:Refresh(.f.) ;
 )
ENDI
 
oFontT:End()
oFontX:End()
oFontY:End()
oFont:End()

RETURN (NIL)


FUNC Wnd2Bmp( cFile, oWnd )
//Ejemplo 27: Auxiliar para guardar BMP con la ventana completa
   LOCAL hBmp, hDib
   DEFAULT cFile := "TGraph3.Bmp"

   hBmp := WndBitmap( oWnd:hWnd )
   hDib := DibFromBitmap( hBmp )
   DibWrite( cFile, hDib )
   GloBalFree( hDib )
   DeleteObject( hBmp )
RETURN ( FILE( cFile ) )


FUNCTION Quiosco( oGWnd )
//Quiosco de tipos de grafica
LOCAL oGraph
IF ! ISOBJECT( oGWnd )
 RETURN NIL
ENDIF
oGraph := oGWnd:oGraph
DO CASE
CASE oGraph:IsGTypeBar()
 oGraph:GTypeLine()
 oGraph:oTitle:cText := "Quiosco: Tipo Lineas"
CASE oGraph:IsGTypeLine()
 oGraph:GTypePoint()
 oGraph:oTitle:cText := "Quiosco: Tipo Puntos"
CASE oGraph:IsGTypePoint()
 oGraph:GTypeAll()
 oGraph:oTitle:cText := "Quiosco: Tipo Todas"
CASE oGraph:IsGTypeAll()
 oGraph:GPieSerie()
 oGraph:oTitle:cText := "Quiosco: Tipo Sectores (de Columna)"
CASE oGraph:IsGPieSerie()
 oGraph:GPiePeriod()
 oGraph:oTitle:cText := "Quiosco: Tipo Sectores (de Fila)"
CASE oGraph:IsGPiePeriod()
 oGraph:GTypeXY()
 oGraph:oTitle:cText := "Quiosco: Tipo XY (Cartesiano)"
CASE oGraph:IsGTypeXY()
 oGraph:GTypeMaxMin()
 oGraph:oTitle:cText := "Quiosco: Tipo Maximos-Minimos"
CASE oGraph:IsGTypeMaxMin()
 oGraph:GTypeStack()
 oGraph:oTitle:cText := "Quiosco: Tipo Pila"
CASE oGraph:IsGTypeStack()
 oGraph:GStackPer()
 oGraph:oTitle:cText := "Quiosco: Tipo Pila en %"
CASE oGraph:IsGStackPer()
 oGraph:GTypeArea()
 oGraph:oTitle:cText := "Quiosco: Tipo Area"
CASE oGraph:IsGTypeArea()
 oGraph:GTypeBar()
 oGraph:oTitle:cText := "Quiosco: Tipo Barras"
ENDCASE
//Recorrer Filas
oGraph:MoveDown(4)
//Recorrer una Columna
oGraph:MoveRight(1)
oGWnd:UpdateView()
RETURN NIL


FUNCTION GETTITLES()
//Matriz de titulos generica
LOCAL aArray
aArray := { "Prod1","Prod2","Prod3","ProdT", ;
            "Des1","Des2","Des3","DesT","EfiN","EfiR", ;
            "ProNom","ProObj","ProCom","VARIA","PVARIA","NDAT" }
RETURN aArray


FUNCTION GETARRAY()
//Matriz de datos generica
LOCAL aArray 
//Si se definia completamente, se produce C3002: Input Buffer Overflow
//Por eso se aplico AADD()
aArray := {}
AADD( aArray, { "010701",38.20,37.18,41.48,116.85,0.18,0.13,0.15,0.15,0.55,0.86,213.07,135.78,28.10,9.18,6.76,69 } )
AADD( aArray, { "010702",35.62,36.23,34.49,106.34,0.18,0.12,0.09,0.13,0.52,0.78,206.34,136.56,34.13,3.91,2.87,65 } )
AADD( aArray, { "010703",39.66,42.37,47.81,129.83,0.14,0.10,0.06,0.10,0.54,0.88,238.80,148.02,31.64,13.46,9.09,77 } )
AADD( aArray, { "010704",35.24,37.64,37.67,110.55,0.24,0.12,0.24,0.20,0.49,0.74,227.76,148.70,42.16,4.00,2.69,74 } )
AADD( aArray, { "010705",28.08,32.67,41.94,102.69,0.30,0.26,0.22,0.25,0.44,0.70,233.72,146.27,47.95,4.37,2.98,78 } )
AADD( aArray, { "010706",34.70,30.66,32.22,97.58,0.16,0.24,0.17,0.19,0.45,0.76,214.73,128.55,42.42,11.45,8.91,71 } )
AADD( aArray, { "010707",22.79,27.99,33.61,84.39,0.14,0.22,0.12,0.16,0.45,0.73,188.78,115.39,39.49,8.49,7.36,62 } )
AADD( aArray, { "010708",32.97,31.18,32.64,96.79,0.16,0.16,0.13,0.15,0.50,0.86,192.43,112.82,31.01,14.97,13.27,65 } )
AADD( aArray, { "010709",34.88,34.45,33.20,102.53,0.19,0.15,0.34,0.23,0.51,0.85,199.49,120.00,25.28,7.81,6.51,65 } )
AADD( aArray, { "010710",35.82,29.61,38.24,103.66,0.21,0.16,0.16,0.18,0.48,0.78,217.05,133.73,33.90,3.83,2.86,72 } )
AADD( aArray, { "010711",23.88,23.10,32.14,79.12,0.16,0.14,0.15,0.15,0.48,0.74,166.37,107.23,33.82,5.70,5.32,54 } )
AADD( aArray, { "010712",36.31,31.75,24.61,92.67,0.14,0.17,0.16,0.16,0.50,0.79,186.36,116.98,32.65,8.34,7.13,61 } )
AADD( aArray, { "010713",21.07,21.61,29.15,71.83,0.10,0.14,0.12,0.12,0.45,0.71,158.42,101.02,33.85,4.65,4.61,52 } )
AADD( aArray, { "010714",27.08,27.10,31.74,85.92,0.11,0.11,0.09,0.10,0.50,0.78,172.78,110.30,33.58,9.20,8.34,56 } )
AADD( aArray, { "010715",27.88,31.98,33.54,93.41,0.13,0.16,0.08,0.12,0.50,0.77,186.80,121.72,34.00,5.68,4.67,62 } )
AADD( aArray, { "010716",31.14,32.95,28.80,92.89,0.12,0.07,0.07,0.09,0.52,0.86,179.73,107.68,29.44,14.64,13.60,58 } )
AADD( aArray, { "010717",22.34,22.12,25.46,69.93,0.20,0.19,0.11,0.16,0.41,0.65,169.80,108.15,41.40,3.18,2.94,58 } )
AADD( aArray, { "010718",18.91,19.45,16.61,54.97,0.11,0.14,0.28,0.17,0.38,0.56,145.07,98.43,37.08,-6.37,-6.48,46 } )
AADD( aArray, { "010719",21.63,20.78,34.91,77.32,0.35,0.32,0.15,0.25,0.46,0.68,167.92,114.40,40.66,3.57,3.12,54 } )
AADD( aArray, { "010720",30.23,35.74,37.77,103.73,0.23,0.22,0.24,0.23,0.52,0.75,199.60,138.08,35.43,1.09,0.79,64 } )
AADD( aArray, { "010721",35.87,38.91,40.51,115.29,0.16,0.21,0.20,0.19,0.50,0.77,228.53,149.62,39.26,4.93,3.29,74 } )
AADD( aArray, { "010722",36.01,32.98,39.19,108.18,0.18,0.21,0.34,0.25,0.49,0.78,222.57,139.15,39.53,8.56,6.15,71 } )
AADD( aArray, { "010723",34.22,27.02,33.14,94.37,0.18,0.27,0.46,0.31,0.46,0.68,206.01,137.95,46.31,2.73,1.98,66 } )
AADD( aArray, { "010724",30.42,32.30,34.00,96.72,0.27,0.22,0.27,0.25,0.47,0.68,207.11,141.74,41.87,-3.15,-2.22,66 } )
AADD( aArray, { "010725",34.52,31.10,34.69,100.31,0.21,0.32,0.53,0.36,0.48,0.77,210.97,130.10,37.51,7.71,5.93,68 } )
AADD( aArray, { "010726",33.23,36.61,36.23,106.07,0.19,0.42,0.41,0.34,0.49,0.83,218.04,128.20,34.31,12.18,9.50,71 } )
AADD( aArray, { "010727",31.14,28.28,39.34,98.76,0.27,0.28,0.60,0.41,0.44,0.72,225.44,136.74,47.70,9.72,7.11,74 } )
AADD( aArray, { "010728",32.68,23.27,30.46,86.41,0.15,0.62,0.30,0.33,0.39,0.64,219.81,135.41,32.23,-16.77,-12.38,72 } )
AADD( aArray, { "010729",29.06,35.18,30.56,94.80,0.29,0.25,0.35,0.30,0.44,0.74,214.73,128.84,39.45,5.41,4.20,71 } )
AADD( aArray, { "010730",35.41,33.54,35.96,104.91,0.30,0.35,0.17,0.27,0.46,0.72,227.64,144.85,41.77,1.83,1.26,76 } )
AADD( aArray, { "010731",36.39,33.94,35.07,105.40,0.42,0.23,0.29,0.32,0.47,0.79,222.12,132.95,12.13,-15.42,-11.60,74 } )
AADD( aArray, { "010801",34.76,34.64,41.79,111.18,0.37,0.42,0.17,0.31,0.48,0.78,231.80,141.82,18.26,-12.37,-8.72,77 } )
AADD( aArray, { "010802",38.08,39.07,39.43,116.58,0.28,0.31,0.26,0.28,0.47,0.82,245.71,141.78,13.32,-11.88,-8.38,80 } )
AADD( aArray, { "010803",37.74,41.27,40.14,119.15,0.32,0.27,0.18,0.25,0.48,0.82,248.73,145.38,18.25,-7.98,-5.49,81 } )
AADD( aArray, { "010804",39.09,41.73,38.77,119.59,0.41,0.31,0.26,0.33,0.49,0.85,244.32,141.30,9.14,-12.56,-8.89,80 } )
AADD( aArray, { "010805",43.05,44.90,39.70,127.65,0.25,0.25,0.25,0.25,0.52,0.86,245.53,148.07,10.52,-9.90,-6.69,79 } )
AADD( aArray, { "010806",35.53,40.23,36.55,112.31,0.18,0.31,0.22,0.24,0.51,0.80,220.36,140.44,14.59,-13.54,-9.64,71 } )
AADD( aArray, { "010807",37.15,38.79,38.47,114.41,0.25,0.34,0.23,0.27,0.49,0.80,233.94,143.09,8.46,-20.21,-14.13,75 } )
AADD( aArray, { "010808",37.72,37.99,41.65,117.37,0.24,0.26,0.25,0.25,0.50,0.81,234.72,145.56,11.33,-16.86,-11.58,76 } )
AADD( aArray, { "010809",43.87,40.61,45.65,130.14,0.28,0.30,0.31,0.29,0.52,0.86,249.84,151.35,31.20,9.99,6.60,81 } )
AADD( aArray, { "010810",38.34,40.83,45.69,124.86,0.35,0.33,0.20,0.29,0.53,0.92,235.92,135.86,26.74,15.75,11.59,75 } )
AADD( aArray, { "010811",42.34,42.89,42.61,127.84,0.24,0.18,0.21,0.21,0.55,0.93,231.73,137.22,25.15,15.77,11.49,74 } )
AADD( aArray, { "010812",40.35,45.28,45.30,130.93,0.28,0.36,0.26,0.30,0.53,0.90,245.43,145.62,31.80,17.11,11.75,77 } )
AADD( aArray, { "010813",46.38,43.29,43.47,133.14,0.18,0.17,0.15,0.17,0.55,0.94,243.10,141.54,28.17,19.76,13.96,78 } )
AADD( aArray, { "010814",44.58,31.13,44.12,119.83,0.22,0.31,0.19,0.23,0.52,0.88,229.41,136.08,31.27,15.03,11.04,75 } )
AADD( aArray, { "010815",44.67,38.95,41.84,125.46,0.24,0.28,0.31,0.28,0.49,0.84,256.05,149.54,16.69,-7.39,-4.94,85 } )
AADD( aArray, { "010816",41.40,32.07,40.24,113.70,0.29,0.27,0.33,0.30,0.49,0.84,234.27,135.24,23.49,1.94,1.44,78 } )
AADD( aArray, { "010817",42.74,37.06,42.24,122.04,0.23,0.39,0.25,0.29,0.47,0.82,260.32,149.65,8.46,-19.15,-12.80,85 } )
AADD( aArray, { "010818",44.09,43.35,37.68,125.11,0.34,0.17,0.24,0.25,0.50,0.86,252.69,144.83,6.96,-12.75,-8.81,79 } )
AADD( aArray, { "010819",45.19,42.36,41.62,129.17,0.33,0.31,0.27,0.30,0.52,0.85,249.06,151.10,34.94,13.01,8.61,81 } )
AADD( aArray, { "010820",45.21,27.65,32.45,105.31,0.24,0.13,0.16,0.19,0.48,0.83,219.25,126.76,5.33,-16.12,-12.72,70 } )
AADD( aArray, { "010821",43.64,39.51,41.01,124.16,0.36,0.26,0.18,0.27,0.52,0.91,239.35,136.59,28.39,15.96,11.68,78 } )
AADD( aArray, { "010822",41.03,34.73,43.52,119.28,0.31,0.29,0.26,0.28,0.50,0.87,239.35,137.11,36.20,18.37,13.40,78 } )
AADD( aArray, { "010823",41.57,40.19,46.24,128.00,0.29,0.31,0.13,0.24,0.52,0.90,245.75,142.62,28.82,14.20,9.96,80 } )
AADD( aArray, { "010824",47.41,40.70,46.50,134.61,0.34,0.27,0.22,0.28,0.54,0.92,250.72,146.79,28.94,16.76,11.42,81 } )
AADD( aArray, { "010825",44.11,37.70,38.89,120.70,0.28,0.27,0.23,0.26,0.52,0.90,233.50,134.77,31.93,17.86,13.25,76 } )
AADD( aArray, { "010826",39.44,44.89,41.74,126.07,0.27,0.23,0.28,0.26,0.53,0.90,238.24,139.73,26.48,12.82,9.17,77 } )
AADD( aArray, { "010827",42.92,39.60,50.84,133.36,0.23,0.21,0.15,0.19,0.54,0.91,248.73,147.25,33.67,19.78,13.43,81 } )
AADD( aArray, { "010828",43.47,46.40,47.22,137.10,0.19,0.22,0.18,0.19,0.54,0.94,252.11,146.01,29.69,20.78,14.23,82 } )
AADD( aArray, { "010829",43.07,39.44,38.96,121.47,0.31,0.24,0.33,0.30,0.48,0.85,252.37,143.74,42.77,20.50,14.26,83 } )
AADD( aArray, { "010830",40.82,45.55,49.81,136.18,0.23,0.19,0.19,0.20,0.53,0.94,256.79,145.02,31.84,23.01,15.87,83 } )
AADD( aArray, { "010831",45.54,40.25,46.50,132.29,0.31,0.19,0.19,0.23,0.51,0.87,260.10,152.11,40.41,20.59,13.53,84 } )
AADD( aArray, { "010901",35.20,37.47,48.11,120.77,0.31,0.20,0.13,0.20,0.52,0.91,232.50,133.21,33.26,20.82,15.63,75 } )
AADD( aArray, { "010902",41.46,41.75,47.19,130.39,0.21,0.16,0.17,0.18,0.55,0.96,238.57,135.56,27.67,22.50,16.60,77 } )
AADD( aArray, { "010903",41.94,34.31,42.74,118.98,0.14,0.20,0.18,0.17,0.49,0.86,243.32,139.04,39.21,19.15,13.78,78 } )
AADD( aArray, { "010904",52.65,37.26,46.37,136.28,0.19,0.27,0.19,0.21,0.56,0.97,244.32,140.13,35.85,32.01,22.84,82 } )
AADD( aArray, { "010905",37.36,38.01,44.91,120.28,0.21,0.34,0.17,0.24,0.48,0.84,249.06,143.46,43.25,20.07,13.99,83 } )
AADD( aArray, { "010906",32.76,37.10,41.30,111.16,0.33,0.25,0.18,0.24,0.47,0.83,234.82,134.23,37.02,13.95,10.39,77 } )
AADD( aArray, { "010907",35.95,39.83,42.58,118.36,0.23,0.14,0.21,0.19,0.48,0.84,245.64,140.48,39.39,17.27,12.29,81 } )
AADD( aArray, { "010908",39.20,41.73,43.65,124.57,0.20,0.16,0.28,0.21,0.51,0.90,242.88,138.96,29.36,14.97,10.78,80 } )
AADD( aArray, { "010909",45.98,43.49,43.90,133.36,0.41,0.19,0.25,0.29,0.51,0.88,262.56,150.93,36.55,18.99,12.58,87 } )
AADD( aArray, { "010910",41.50,40.68,46.63,128.81,0.22,0.39,0.36,0.32,0.50,0.88,256.24,145.91,35.28,18.18,12.46,86 } )
AADD( aArray, { "010911",45.63,43.98,48.25,137.86,0.15,0.24,0.27,0.22,0.54,0.93,257.56,147.64,34.22,24.43,16.55,87 } )
AADD( aArray, { "010912",42.99,43.35,41.03,127.37,0.19,0.23,0.26,0.23,0.48,0.84,263.08,150.90,39.68,16.16,10.71,89 } )
AADD( aArray, { "010913",35.21,42.97,43.50,121.67,0.32,0.14,0.21,0.22,0.47,0.83,257.45,146.70,39.92,14.89,10.15,85 } )
AADD( aArray, { "010914",44.06,44.00,40.57,128.62,0.22,0.25,0.21,0.23,0.50,0.87,258.78,148.28,40.75,21.09,14.22,86 } )
AADD( aArray, { "010915",42.36,50.50,42.59,135.44,0.20,0.16,0.27,0.21,0.55,0.95,246.74,142.01,29.08,22.51,15.85,84 } )
AADD( aArray, { "010916",45.55,48.95,45.53,140.03,0.17,0.23,0.24,0.21,0.51,0.80,275.21,174.66,21.22,-13.40,-7.67,90 } )
AADD( aArray, { "010917",44.72,44.90,43.55,133.17,0.16,0.18,0.34,0.23,0.53,0.93,249.50,143.54,34.67,24.30,16.93,85 } )
AADD( aArray, { "010918",46.28,46.94,40.98,134.20,0.28,0.19,0.22,0.23,0.51,0.89,262.98,151.17,39.39,22.42,14.83,87 } )
AADD( aArray, { "010919",44.41,47.79,48.95,141.15,0.23,0.30,0.21,0.25,0.53,0.92,266.84,152.87,32.08,20.37,13.32,88 } )
AADD( aArray, { "010920",44.68,45.19,46.12,135.99,0.25,0.24,0.21,0.24,0.49,0.86,276.66,158.36,37.26,14.90,9.41,93 } )
AADD( aArray, { "010921",44.35,40.22,42.18,126.75,0.29,0.27,0.23,0.26,0.51,0.88,249.72,143.31,32.38,15.81,11.03,82 } )
AADD( aArray, { "010922",36.54,42.74,45.24,124.52,0.34,0.38,0.21,0.31,0.47,0.82,266.28,152.32,41.58,13.78,9.05,88 } )
AADD( aArray, { "010923",46.66,47.37,45.68,139.72,0.25,0.18,0.20,0.21,0.53,0.92,265.62,151.44,34.05,22.33,14.74,89 } )
AADD( aArray, { "010924",43.95,43.37,43.98,131.29,0.18,0.25,0.30,0.24,0.50,0.87,264.19,150.37,35.43,16.35,10.87,89 } )
AADD( aArray, { "010925",42.41,44.85,44.30,131.56,0.22,0.30,0.20,0.24,0.50,0.89,261.54,148.45,33.91,17.01,11.46,87 } )
AADD( aArray, { "010926",42.44,44.02,41.60,128.06,0.23,0.35,0.20,0.26,0.49,0.86,262.09,148.25,37.77,17.58,11.86,87 } )
AADD( aArray, { "010927",41.01,48.08,42.33,131.42,0.26,0.28,0.26,0.27,0.51,0.89,257.46,147.55,29.22,13.08,8.87,85 } )
AADD( aArray, { "010928",43.97,45.94,45.79,135.70,0.19,0.32,0.27,0.26,0.54,0.95,251.60,142.49,25.68,18.90,13.26,84 } )
AADD( aArray, { "010929",46.28,48.30,42.09,136.68,0.22,0.23,0.19,0.22,0.56,0.99,243.87,138.35,25.20,23.53,17.01,81 } )
AADD( aArray, { "011001",47.75,47.44,51.15,146.35,0.19,0.14,0.15,0.16,0.41,0.75,355.84,195.95,55.57,5.98,3.05,90 } )
AADD( aArray, { "011002",43.32,43.77,52.00,139.09,0.15,0.16,0.19,0.17,0.53,0.92,264.19,150.52,33.25,21.82,14.49,86 } )
AADD( aArray, { "011003",42.83,48.96,43.29,135.07,0.30,0.19,0.21,0.23,0.52,0.92,259.00,146.88,31.42,19.62,13.36,84 } )
AADD( aArray, { "011004",45.34,41.87,44.42,131.62,0.21,0.25,0.23,0.23,0.50,0.87,264.08,150.48,35.72,16.86,11.21,87 } )
AADD( aArray, { "011005",41.29,42.05,44.19,127.53,0.35,0.19,0.20,0.24,0.50,0.88,254.80,144.48,36.58,19.63,13.58,83 } )
AADD( aArray, { "011006",45.49,42.24,45.75,133.49,0.21,0.20,0.45,0.29,0.52,0.92,255.58,145.03,29.74,18.20,12.55,84 } )
AADD( aArray, { "011007",45.59,44.23,39.81,129.63,0.22,0.35,0.21,0.26,0.51,0.90,254.03,144.81,34.44,19.25,13.29,82 } )
AADD( aArray, { "011009",45.61,38.36,45.54,129.51,0.23,0.23,0.26,0.24,0.50,0.88,258.89,147.62,31.92,13.82,9.36,85 } )

RETURN aArray


FUNCTION CheckDBF()
//Verificar y/o crear base de datos de ejemplo
LOCAL aValues, aTitCol, aStruct, ii, nJ
IF FILE( "G_GRAPH.DBF" )
 RETURN NIL
ENDIF
//No existe, crearla y llenarla

//Datos en matriz
aValues := GETARRAY()
aTitCol := GETTITLES()

aStruct := {}
AADD( aStruct, { "FECHA", "C", 6, 0 } )
FOR ii = 1 TO LEN( aTitCol )
 AADD( aStruct, { aTitCol[ii], "N", 8, 2 } )
NEXT ii
DBCREATE( "G_GRAPH.DBF", aStruct )
USE G_GRAPH
//Agregar registros
FOR ii = 1 TO LEN( aValues )
 DBAPPEND()
 FOR nJ = 1 TO LEN( aValues[ii] )
  FIELDPUT( nJ, aValues[ii, nJ] )
 NEXT nJ
NEXT ii
DBCLOSEAREA()
RETURN NIL


FUNCTION Mn1Eva( oGWnd )
//solucion de ecuaciones de una variable
LOCAL oGraph
IF ! ISOBJECT( oGWnd )
 lFin := .T.   //Para lClipxNet
 RETURN NIL
ENDIF
oGraph := oGWnd:oGraph

//Iteracion i
DO CASE
CASE nMetNum == 1  //rem *** particion de intervalo ***
IF i == 1 .AND. ;
 EVAL( bf,x0 ) * EVAL( bf,x1 ) > 0
 oText:=oGraph:AddText( "Rango de x = "+ALLTRIM(STR(x0)) ;
  +" a "+ALLTRIM(STR(x1)) )
 oText:oFontT := oGraph:oTitle:oFontT
 oText:nClrT := RGB( 128, 0, 0 )
 oGWnd:oTimer:deactivate()

 oText := oGraph:AddText( "raiz fuera del rango dado" )
 oText:PosCenter()
 oText:oFontT := oGraph:oTitle:oFontT
 oText:nClrT := RGB( 128, 0, 0 )
 //Ver todas las Filas
 oGraph:nRowView := oGraph:oData:RecCount()
 oGWnd:UpdateView()
 lFin := .T.   //Para lClipxNet
 RETU NIL
ENDI

p[i]:=(a[i]+b[i])/2
AADD( oGraph:oData:aValues, { i, p[i], EVAL( bf, p[i] ) } )
d:=abs(b[i]-a[i])
IF EVAL( bf, p[i] ) == 0 .OR. ;
 d/2 < e .OR. ;
 n<i
 oText:=oGraph:AddText( "Raiz de la ecuacion  x = "+ALLTRIM(STR(p[i])) ;
  +"   Tolerancia = "+ALLTRIM(STR(e)) )
 oText:oFontT := oGraph:oTitle:oFontT
 oText:nClrT := RGB( 128, 0, 0 )
 //Se termino, apaguen todo
 oGWnd:oTimer:deactivate()
 lFin := .T.   //Para lClipxNet

ELSE
 //Siguiente iteracion
 IF EVAL( bf, a[i] ) * EVAL( bf, p[i] ) > 0
  a[i+1]:=p[i]
  b[i+1]:=b[i]
 ELSE
  b[i+1]:=p[i]
  a[i+1]:=a[i]
 ENDIF
 i:=i+1
ENDI

CASE nMetNum == 2  //rem *** iteraciones sucesivas ***
x3:=EVAL( bf, x2 )
AADD( oGraph:oData:aValues, { i, x3, EVAL( bf, x3 )-x3 } )
IF abs(x3-x2)<=e
 oText:=oGraph:AddText( "Raiz de la ecuacion  x = "+ALLTRIM(STR(x3)) ;
  +"   Tolerancia = "+ALLTRIM(STR(e)) )
 oText:oFontT := oGraph:oTitle:oFontT
 oText:nClrT := RGB( 128, 0, 0 )
 oGWnd:oTimer:deactivate()
 lFin := .T.   //Para lClipxNet

ELSEIF abs(x3-x2)>d
 oText:=oGraph:AddText( "Aproximacion x = "+ALLTRIM(STR(x3)) ;
  +"   Tolerancia = "+ALLTRIM(STR(e)) )
 oText:oFontT := oGraph:oTitle:oFontT
 oText:nClrT := RGB( 128, 0, 0 )
 oGWnd:oTimer:deactivate()
 lFin := .T.   //Para lClipxNet

 oText := oGraph:AddText( "no converge " )
 oText:PosCenter()
 oText:oFontT := oGraph:oTitle:oFontT
 oText:nClrT := RGB( 128, 0, 0 )

ELSEIF i>=n
 oText:=oGraph:AddText( "Aproximacion x = "+ALLTRIM(STR(x3)) ;
  +"   Tolerancia = "+ALLTRIM(STR(e)) )
 oText:oFontT := oGraph:oTitle:oFontT
 oText:nClrT := RGB( 128, 0, 0 )
 oGWnd:oTimer:deactivate()
 lFin := .T.   //Para lClipxNet

 oText := oGraph:AddText( "iteraciones agotadas" )
 oText:PosCenter()
 oText:oFontT := oGraph:oTitle:oFontT
 oText:nClrT := RGB( 128, 0, 0 )

ELSE
 //Siguiente iteracion
 d:=abs(x3-x2)
 x2:=x3
 i=i+1
ENDI

CASE nMetNum == 3  //rem *** metodo de newton ***
xn:=x0-EVAL(bf,x0)/EVAL(bd,x0)
AADD( oGraph:oData:aValues, { i, xn, EVAL( bf, xn ) } )
IF abs(xn-x0)<=e
 oText:=oGraph:AddText( "Raiz de la ecuacion  x = "+ALLTRIM(STR(xn)) ;
  +"   Tolerancia = "+ALLTRIM(STR(e)) )
 oText:oFontT := oGraph:oTitle:oFontT
 oText:nClrT := RGB( 128, 0, 0 )
 oGWnd:oTimer:deactivate()
 lFin := .T.   //Para lClipxNet
 
ELSEIF i>=n
 oText:=oGraph:AddText( "Aproximacion x = "+ALLTRIM(STR(xn)) ;
  +"   Tolerancia = "+ALLTRIM(STR(e)) )
 oText:oFontT := oGraph:oTitle:oFontT
 oText:nClrT := RGB( 128, 0, 0 )
 oGWnd:oTimer:deactivate()
 lFin := .T.   //Para lClipxNet

 oText := oGraph:AddText( "iteraciones agotadas" )
 oText:PosCenter()
 oText:oFontT := oGraph:oTitle:oFontT
 oText:nClrT := RGB( 128, 0, 0 )

ELSE
 //Siguiente iteracion
 x0:=xn
 i=i+1
ENDI

CASE nMetNum == 4  //rem *** metodo de la secante ***
x2:=x1-(x1-x0)*EVAL(bf,x1)/(EVAL(bf,x1)-EVAL(bf,x0))
AADD( oGraph:oData:aValues, { i, x2, EVAL( bf, x2 ) } )
IF abs(x2-x1)<=e
 oText:=oGraph:AddText( "Raiz de la ecuacion  x = "+ALLTRIM(STR(x2)) ;
  +"   Tolerancia = "+ALLTRIM(STR(e)) )
 oText:oFontT := oGraph:oTitle:oFontT
 oText:nClrT := RGB( 128, 0, 0 )
 oGWnd:oTimer:deactivate()
 lFin := .T.   //Para lClipxNet
 
ELSEIF i>=n
 oText:=oGraph:AddText( "Aproximacion x = "+ALLTRIM(STR(x2)) ;
  +"   Tolerancia = "+ALLTRIM(STR(e)) )
 oText:oFontT := oGraph:oTitle:oFontT
 oText:nClrT := RGB( 128, 0, 0 )
 oGWnd:oTimer:deactivate()
 lFin := .T.   //Para lClipxNet

 oText := oGraph:AddText( "iteraciones agotadas" )
 oText:PosCenter()
 oText:oFontT := oGraph:oTitle:oFontT
 oText:nClrT := RGB( 128, 0, 0 )

ELSE
 //Siguiente iteracion
 x0:=x1
 x1:=x2
 i=i+1
ENDI

CASE nMetNum == 5  //rem *** metodo de steffenson ***
x1:=EVAL(bf,x0)
x2:=EVAL(bf,x1)
xs:=x0-(x1-x0)**2/(x2-2*x1+x0)
AADD( oGraph:oData:aValues, { 3*i, xs, EVAL( bf, xs )-xs } )
IF abs(xs-x2)<=e
 oText:=oGraph:AddText( "Raiz de la ecuacion  x = "+ALLTRIM(STR(xs)) ;
  +"   Tolerancia = "+ALLTRIM(STR(e)) )
 oText:oFontT := oGraph:oTitle:oFontT
 oText:nClrT := RGB( 128, 0, 0 )
 oGWnd:oTimer:deactivate()
 lFin := .T.   //Para lClipxNet

ELSEIF 3*i>=n
 oText:=oGraph:AddText( "Aproximacion x = "+ALLTRIM(STR(xs)) ;
  +"   Tolerancia = "+ALLTRIM(STR(e)) )
 oText:oFontT := oGraph:oTitle:oFontT
 oText:nClrT := RGB( 128, 0, 0 )
 oGWnd:oTimer:deactivate()
 lFin := .T.   //Para lClipxNet

 oText := oGraph:AddText( "iteraciones agotadas" )
 oText:PosCenter()
 oText:oFontT := oGraph:oTitle:oFontT
 oText:nClrT := RGB( 128, 0, 0 )

ELSE
 //Siguiente iteracion
 x0:=xs
 i=i+1
ENDI

ENDCASE

//Ver todas las Filas
oGraph:nRowView := oGraph:oData:RecCount()
oGWnd:UpdateView()
RETURN NIL


/* El siguiente codigo se uso para pruebas durante el desarrollo de TGraph 3
Se deja como referencia y como ejemplo de aplicacion de caracteristicas
para quien le interese conocerlas y aplicarlas
*/

Function b2D()

Local aValues, oGraphWindow, oColumn
local oFontT, oFontX

  aValues := { { 1 ,       5  ,      6  ,      7  ,     10 }, ;
               { 2 ,       6  ,      7  ,      8  ,     11 }, ;
               { 3 ,       7  ,      8  ,      9  ,     12 }, ;
               { 4 ,       8  ,      9  ,     10  ,     -8 }, ;
               { 5 ,       9  ,     10  ,     11  ,     -7 }, ;
               { 6 ,      10  ,     11  ,     12  ,     -6 }, ;
               { 7 ,      11  ,     12  ,     13  ,     -5 }, ;
               { 8 ,      12  ,     13  ,     14  ,     -4 }, ;
               { 9 ,      13  ,     14  ,     15  ,     -3 }  ;
             }
/*
  aValues := { {  1 ,      - 5  ,   -   6  ,      7  ,     10 }, ;
               {  2 ,      - 6  ,   -   7  ,      8  ,     11 }, ;
               {  3 ,      - 7  ,   -   8  ,      9  ,     12 }, ;
               {  4 ,      - 8  ,   -   9  ,     10  ,     -8 }, ;
               {  5 ,      - 9  ,   -  10  ,     11  ,     -7 }, ;
               {  6 ,      -10  ,   -  11  ,     12  ,     -6 }, ;
               {  7 ,      -11  ,   -  12  ,     13  ,     -5 }, ;
               {  8 ,      -12  ,   -  13  ,     14  ,     -4 }, ;
               {  9 ,      -13  ,   -  14  ,     15  ,     -3 }  ;
             }
*/


// USE C:\BASEDAT\CPEPRO SHARED

   oGraphWindow := GraWnd():New(1,1,(MaxRow()-4)/1,(MaxCol()-1)/1, ;
    "Light Lib Business - 2 dimensional sample", GraServer():New(aValues), .T., ;
    , , , , 0, )   //Actualizar cada 5 segundos

//   oGraphWindow:lAdjust := .F.

// oGraphWindow:oTimer:bAction := { || oGraphWindow:ForWard() }
// oGraphWindow:oTimer:nInterval := 5*1000

oGraphWindow:oGraph:AutoData()

oGraphWindow:oGraph:oAxisX:lAxisScale := .f.
oGraphWindow:oGraph:oAxisX:lAxisDate := .F.

oGraphWindow:oGraph:oAxisX:lAutoSize := .t.
oGraphWindow:oGraph:oAxisX:nAxisMin := -4
oGraphWindow:oGraph:oAxisX:nAxisMax := 6
oGraphWindow:oGraph:oAxisX:nStepTwo := 0.2

oGraphWindow:oGraph:oAxisYL:lAutoSize := .t.
oGraphWindow:oGraph:oAxisYL:nAxisMin := -5  //-6  //-6
oGraphWindow:oGraph:oAxisYL:nAxisMax := 30 //-1  //10
oGraphWindow:oGraph:oAxisYL:nStepOne := 10
oGraphWindow:oGraph:oAxisYL:nStepTwo := 1

oGraphWindow:oGraph:oAxisYR:lAutoSize := .t.
oGraphWindow:oGraph:oAxisYR:nAxisMin := -5  //-6  //-6
oGraphWindow:oGraph:oAxisYR:nAxisMax := 20 //-1  //10
oGraphWindow:oGraph:oAxisYR:nStepTwo := 0.5


// oGraphWindow:oGraph:oAxisX:nSkipLab := 1 

oGraphWindow:oGraph:lViewVal := .T.

oGraphWindow:oGraph:lPopUp := .T.

// oGraphWindow:oGraph:oAxisX:l3D := .F.

oGraphWindow:oGraph:oLegend:PosRight()

//oGraphWindow:oGraph:GStackPer()
oGraphWindow:oGraph:GTypeStack()
//oGraphWindow:oGraph:GTypeMaxMin()
//oGraphWindow:oGraph:GTypeLine()
//oGraphWindow:oGraph:GPieSerie()

        oColumn:=oGraphWindow:oGraph:GetColGraph(1)
        oColumn:cTitle   := "Serie 1"
        oColumn:nPoint     := 2

        oColumn:=oGraphWindow:oGraph:GetColGraph(2)
        oColumn:cTitle   := "Serie 2"

//      oColumn:l3D      := .F.
//        oColumn:lFill    := .F.
//        oColumn:lShowVal := .F.
        oColumn:lAxisYL  := .F.
        oColumn:nPoint     := 3

//        oColumn:nPieSt   := 50

        oColumn:=oGraphWindow:oGraph:GetColGraph(3)
        oColumn:cTitle   := "Serie 3"

        oColumn:=oGraphWindow:oGraph:AddColumn( {  |nVal,oData| oData:FieldGet(2)+oData:FieldGet(3)+oData:FieldGet(4) } )
        oColumn:cTitle   := "Serie calculada"

//   oColumn:TypeXY()

   DEFINE FONT oFontT NAME "Times New Roman" SIZE 0,-18 BOLD ITALIC

   oGraphWindow:oGraph:oAxisYL:nClrT           := { 0,125,255}
   oGraphWindow:oGraph:oAxisYL:cText        := "Titulo YL"
   oGraphWindow:oGraph:oAxisYL:cHeader          := "AxisYLH"

   oGraphWindow:oGraph:oAxisYL:bToScale         := { |nV| nV }

   oGraphWindow:oGraph:oAxisYL:cToScale         := "Escalamiento de AxisYL"
   oGraphWindow:oGraph:oAxisYL:oFontS           := oFontT

   oGraphWindow:oGraph:oAxisYL:bToLabel := { |nVal| Transform(nVal,"999.99") }

   oGraphWindow:oGraph:oAxisYL:oFontT := oFontT

   oGraphWindow:oGraph:oAxisYR:nClrT           := { 100,0,255}
   oGraphWindow:oGraph:oAxisYR:cText        := "Titulo de AxisYR"
   oGraphWindow:oGraph:oAxisYR:cHeader          := "AxisYRH"

   oGraphWindow:oGraph:oAxisYR:bToScale         := { |nV| nV }

   oGraphWindow:oGraph:oAxisYR:cToScale         := "Escalamiento de AxisYR"
   oGraphWindow:oGraph:oAxisYR:oFontS           := oFontT

   oGraphWindow:oGraph:oAxisYR:bToLabel := { |nData| Transform(nData,"9999.99") }

   oGraphWindow:oGraph:oAxisX:nClrT           := { 0,255,0}
   oGraphWindow:oGraph:oAxisX:cText := "Titulo de Eje X"
   oGraphWindow:oGraph:oAxisX:cHeader          := "AxisXH"
   oGraphWindow:oGraph:oAxisX:cToScale         := "Escalamiento de AxisX"
   oGraphWindow:oGraph:oAxisX:bToLabel := { |nVal| Transform(nVal,"999.99") }
   oGraphWindow:oGraph:oAxisX:oFontT := oFontT

   oGraphWindow:oGraph:oTitle:cText           := "Titulo principal"
   oGraphWindow:oGraph:oTitle:nClrT  := {255,50,0}
   oGraphWindow:oGraph:oTitle:oFontT := oFontT

   oGraphWindow:oGraph:oTitle:PosTop()

   oGraphWindow:oGraph:oTitle:AliRight()

   oGraphWindow:oGraph:oSubTitle:cText           := "Subtitulo de grafica"
   oGraphWindow:oGraph:oSubTitle:AliRight()

        oGraphWindow:oGraph:nColView := 4
        oGraphWindow:oGraph:nRowView := 12

oGraphWindow:oGraph:AddText( "Texto libre 1", , , , , , , , ,  )

   DEFINE FONT oFontX NAME "Times New Roman" SIZE 0,-110 BOLD
/*
oText := oGraphWindow:oGraph:AddText( "Cancelled" )
oText:nAngleDeg := 30
oText:PosBottom()
// oText:PosCenter()
oText:oFontT := oFontX
oText:nClrT := RGB( 128, 0, 0 )
*/
/*
FOR ii = 0 TO 359 STEP 15
 oText := oGraphWindow:oGraph:AddText( "Texto libre "+TRAN(ii,"999")+" grados", , , , , , , , ,  )
 oText:nAngleDeg := ii
 oText:PosCenter()
 oText:oFontT := oFontT
 oText:nClrT := RGB( INT(ii/1.5),INT(ii/2), INT(ii/1.5) )
NEXT ii
*/

 oGraphWindow:Activate()

oFontT:End()
oFontX:End()

Return (NIL)


FUNCTION VerKley( cBase )
//Verificar y/o crear base de datos de ejemplo 25: Kleyber
LOCAL aValues, aTitCol, aStruct, ii, nJ, aMeses

DEFAULT cBase := "kleyber.dbf"
IF FILE( cBase )
 RETURN NIL
ENDIF
//No existe, crearla y llenarla

aMeses := { "ENE","FEB","MAR","ABR","MAY","JUN", ;
            "JUL","AGO","SEP","OCT","NOV","DIC" }
aStruct := {}
AADD( aStruct, { "MES", "C", 3, 0 } )
AADD( aStruct, { "COMPRAS", "N", 8, 2 } )
AADD( aStruct, { "VENTAS",  "N", 8, 2 } )
AADD( aStruct, { "RBRUTA",  "N", 8, 2 } )
AADD( aStruct, { "RNETA",   "N", 8, 2 } )
DBCREATE( cBase, aStruct )
USE (cBase) SHARED

//Agregar registros
FOR ii = 1 TO 12
 DBAPPEND()
 REPL MES WITH aMeses[ii],COMPRAS WITH SECONDS(),VENTAS WITH SECONDS()*SQRT(RECNO()), ;
  RBRUTA WITH SECONDS() * 80/100, RNETA WITH SECONDS()/SQRT(RECNO())
NEXT ii

DBCLOSEAREA()
RETURN NIL


FUNCTION ActGrafica( oGWnd )
//Actualizacion de grafica de ejemplo 25: Kleyber
LOCAL oGraph, aMeses, ii, i1,i2,i3, lTimer
IF ! ISOBJECT( oGWnd )
 RETURN NIL
ENDIF
oGraph := oGWnd:oGraph
lTimer := oGWnd:oTimer:lActive

DO CASE
CASE nCaso == 1

 //Apagar Timer mientras se hacen calculos
 IF lTimer
  oGWnd:oTimer:deactivate()
 ENDIF

//Inicializar matriz de datos
oGraph:oData:aValues := {}

//Calcular los datos de la manera que sea necesaria, y agregarlos a la matriz

aMeses := { "ENE","FEB","MAR","ABR","MAY","JUN", ;
            "JUL","AGO","SEP","OCT","NOV","DIC" }
FOR ii = 1 TO 12
 i1 := VAL( SUBS( TIME(), 1, 2 ) )
 i2 := VAL( SUBS( TIME(), 4, 2 ) )
 i3 := VAL( SUBS( TIME(), 7, 2 ) )
 AADD( oGraph:oData:aValues, { aMeses[ii], ;
  i1*3*ii, i2*ii,i3*ii, SQRT(i2*i3)*ii } )
NEXT ii

 //Reestablecer Timer
 IF lTimer
  oGWnd:oTimer:activate()
 ENDIF

CASE nCaso == 2
//Inicializar matriz de datos
oGraph:oData:aValues := {}
//El archivo DBF se actualiza por otros procesos
//Tomar datos desde el archivo DBF
DBGOTOP()
WHILE ! EOF()
 AADD( oGraph:oData:aValues, ;
  { FIELD->MES, FIELD->COMPRAS, FIELD->VENTAS, FIELD->RBRUTA, FIELD->RNETA } )
 DBSKIP()
ENDD

CASE nCaso == 3
//No se requiere nada
//El archivo DBF se actualiza por otros procesos
ENDC

//Renovar grafica
oGWnd:UpdateView()
RETURN NIL

