/* 2003/07/12: I.Q. David Arturo Macias Corona   inter_02.prg

Proceso para: Prueba 02 de Interfaz con Modelo en Paralelo
*/

/*Compilacion:
/m /n /a /ustdcha.ch
Macros  de diferenciacion
/DHARBOUR: Harbour
/DNOADS:   No incluir Advantage (por omision se incluye)    No aplicable
/DFIVEWIN  FiveWin
/DFIVECLIP FiveWin 16 bits
/DLINUX    Algunas diferencias necesarias en Linux
*/


#ifdef FIVECLIP  //Evitar error C3048: Preprocessor table overflow
 #include "five16.ch"

 #include "inkey16.ch"
 #include "common.ch"
 #include "error.ch"
 #include "setcurs.ch"

 #include "fileio.ch"

#else
 #ifdef FIVEWIN
  #include "fivewin.ch"
 #else
  #define  CRLF   CHR(13)+CHR(10)
 #endif

 #include "inkey.ch"
 #include "common.ch"
 #include "error.ch"
 #include "setcurs.ch"

 #include "fileio.ch"
// #include "dbinfo.ch"
// #include "llibg.ch"

#endif

//RDD de Clipper 5.3
REQUEST DBFNTX
REQUEST DBFCDX

#ifdef NOADS
#else

//RDD de Advantage Database Server
#ifdef HARBOUR
//DAVID: No se esta incluyendo  REQUEST _ADS

#else
//DAVID: No se esta incluyendo  REQUEST DBFNTXAX
//DAVID: No se esta incluyendo  REQUEST DBFCDXAX
#endif

#endif


FUNC MAIN
PARA xParam

PUBL lLinux := "LINUX" $ UPPE( OS() )
PUBL cDirSepara := IF( lLinux, "/", "\" )
#ifdef FIVEWIN
// CPEVersion := "W"+CPEVersion
PUBL nHandOut := 0   //Auxiliar en sustitucion de QOUT()
PUBL nWLastKey := 0   //Ultima tecla con codigo FW
PUBL nLastKey  := 0   //Codigo INKEY() de Clipper. Pueden ser tecla individual o combinadas
                      //Auxiliar para simular LastKey(), NextKey(), Inkey(), ...

PUBL cKeyboard := "" //Auxiliar para simular KEYBOARD sin edicion (con edicion es dentro de WINDOW/DIALOG)
PUBL lUpdated := .F. //Auxiliar para simular Updated()

PUBL nMaxRow := 29
PUBL nMaxCol := 79

//Valores para salida
PUBL nArcSalida := 0, nPrnLin := 0, nPrnCol := 0, nPrnTMargen := 0, nPrnLMargen := 0, nPrnFacAlt := 1
PUBL oPrn,oFont0,oFont1,oFont2,oFont3,oFont4, oSomBrush

#else
#endif

PUBL nProw := 0    //Auxiliar para posiciones de impresion
PUBL nPcol := 0
PUBL lImpGrafica := .F.   //Impresion en modo grafico
PUBL oObjActivo := NIL    //Para procesos que requieren el objeto actual

SET CENTURY ON

PRIV cArcEntra
PRIV cArcSale
PRIV nSECatendidos
PRIV aCGItodos

PRIV cSvrLogos := "../cgi-bin/logos/"
PRIV cDirInterfaz := ""  //Directorio de control de interfaz
PRIV cArcInterfaz   //Archivo de control de interfaz
PRIV cPrefijo       //Prefijo para archivo de control de interfaz

//Por omision, se usa el prefijo "inter" para la familia de archivos de control de interfaz
//Este valor puede ser sustituido por los valores de la peticion
cPrefijo := "inter"

/*
Nota: El uso de prefijos para el archivo de control de interfaz esta implementado para que las peticiones
puedan diferenciarse segun sea conveniente, ya que se puede tener en ejecucion diversos programas
"servidores de procesos", cada uno de ellos atendiendo archivos de control de un prefijo especifico
Los programas "servidores de procesos" pueden tener procesos muy diferentes entre ellos
Por ejemplo:
contabil.exe   Atiende peticiones de prefijo "conta"
ventas.exe     Atiende peticiones de prefijo "venta"
*/

//Valores de sustitucion
IF TYPE("XPARAM")=="C"
 cPrefijo := LEFT( LOWE( xParam ), 5 )
ENDI

/*Es conveniente que se implementen procesos de contencion adicionales, por ejemplo una estructura
de control de errores
Por simplicidad en el ejemplo no se esta incluyendo el manejo de errores
*/

// Proceso de Intercambio
// Se asume un ciclo continuo
nSECatendidos := 0
WHILE ! LASTKEY() == K_ESC  //Ciclo de atencion
 // Esperar un poco
 INKEY( 2.0 )
 SETCOLOR( "W+/B" )
 CLS
 @2,0 SAY "PROCESO CON UN ARCHIVO DE CONTROL DE TRANSFERENCIA"
 @4,0 SAY "SIMULACION DE PROCESO POR EL LADO DE PC"

 @10,0 SAY "Archivos de Intercambio: "
 @ROW()+1, 0 SAY cDirInterfaz+cPrefijo+"*.tgc" PICT "@S78" COLO "N/W"

 @18,0 SAY "Total de registros procesados: "+STR( nSECatendidos )
 @22,0 SAY "Salir de proceso con {Esc} o ALT-C"

 cArcInterfaz := DIRECTORY( cDirInterfaz+cPrefijo+"*.tgc" )
 IF EMPTY( cArcInterfaz ) .OR. ;
  ! VALTYPE( cArcInterfaz ) == "A" .OR. ;  //Por "rarezas" de Win98
  ! VALTYPE( cArcInterfaz[ 1, 1 ] ) == "C" .OR. ;  //Por "rarezas" de Win98
  ! FILE( cDirInterfaz+LOWE(cArcInterfaz[ 1, 1 ]) )
  LOOP   //Seguir intentando
 ENDI
 //Existe cArcInterfaz, lo que indica que hay una peticion pendiente
 cArcInterfaz := cDirInterfaz+LOWE(cArcInterfaz[ 1, 1 ])
 INKEY(1)  //Esperar un poco para que el otro sistema cierre cArcInterfaz

 @22,0
 @22,0 SAY "Procesando peticion ..."

 //Atender peticion
 //Valores contenidos en archivos de interfaz
 aCGItodos := ALLTRIM(MEMOREAD( cArcInterfaz ))
 //Prevision para LF=CHR(10) como fin de linea en Linux
 IF ! CHR(13)+CHR(10) $ aCGItodos
  aCGItodos := STRTRAN( aCGItodos, CHR(10), CHR(13)+CHR(10) )
 ENDI
 aCGItodos := SGPTOD( aCGItodos, CRLF )
 cArcEntra := ALLTRIM( SGCGIvaria("CARCENTRA") )
 cArcSale  := ALLTRIM( SGCGIvaria("CARCSALE") )

 IF EMPTY( cArcSale ) .OR. ;
  ! FILE( cArcSale )
  // No se tiene donde dejar respuesta. Ignorar peticion
  nSECatendidos++
  FERASE( cArcInterfaz )  //Borrar el archivo de interfaz indica que termino el proceso
  LOOP
 ENDI
 IF EMPTY( cArcEntra ) .OR. ;
  ! FILE( cArcEntra ) .OR. ;
  EMPTY( aCGItodos := MEMOREAD( cArcEntra ) )  //No tiene datos
  // No se puede saber que hacer. Avisar algo
  SGSALIDA0( cArcSale, TRUE, FALSE, FALSE )
  QOUT( "<HTML><BODY>" )
//  QOUT( "<H2>"+cIDsistema+" ("+cIDsisdesc+")"+": Server Error</H2><P>" )
  QOUT( "No se tiene informacion para efectuar proceso<BR>" )
  QOUT( "</BODY></HTML>" )
  SGSALIDA0( )
  nSECatendidos++
  FERASE( cArcInterfaz )  //Borrar el archivo de interfaz indica que termino el proceso
  LOOP
 ENDI
 //Prevision para LF=CHR(10) como fin de linea en Linux
 IF ! CHR(13)+CHR(10) $ aCGItodos
  aCGItodos := STRTRAN( aCGItodos, CHR(10), CHR(13)+CHR(10) )
 ENDI
 // Procesar de acuerdo a informacion de archivo de entrada
 aCGItodos := SGPTOD( aCGItodos, CRLF )

 //Continuar en el Proceso Particular para cada sistema
 CGIPROCESO()

 // Termina el proceso en PC
 nSECatendidos++
 FERASE( cArcInterfaz )  //Borrar el archivo de interfaz indica que termino el proceso

ENDD

// Fin
//ClipNet-xNet enviara el contenido de cArcSale

RETU (0)


FUNC CGIPROCESO
//Proceso Particular para cada sistema
PRIV cCGItarea
//Identificacion de la peticion
cCGItarea := UPPE( SGCGIvaria( "CGITAREA" ) )
DO CASE
CASE cCGItarea == "AA"    //Descripcion de la tarea AA
 TAREA_AA()
CASE cCGItarea == "BB"    //Descripcion de la tarea BB
 TAREA_BB()
CASE cCGItarea == "CC"    //Descripcion de la tarea CC
 // TAREA_CC()
OTHE
 //Avisar algo
 SGSALIDA0( cArcSale, .T., .F., .F. )
 QOUT('<HTML>')
 QOUT('<HEAD><TITLE>Modelo ClipNet: Interfaz con Modelo en Paralelo</TITLE>')
 QOUT('   <META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-1">' )
 QOUT('   <META NAME="Author" CONTENT="David Arturo Macias Corona">' )
 QOUT('   <META NAME="GENERATOR" CONTENT="Mozilla/4.04 [en] (OS/2; I) [Netscape]">' )
 QOUT('   <META NAME="GENERATOR" CONTENT="Sistemas Genericos [SGD]">' )
 QOUT('</HEAD>')

 QOUT('<BODY background="'+cSvrLogos+'fondo0.gif" leftMargin=5 topMargin=5>')
 QOUT('<p align="center">' )
 QOUT('<img border="0" src="../cgi-bin/logos/logo.jpg" width="750" height="57" >')
 QOUT('</p>')
 QOUT('<CENTER><H2>"'+cPrefijo+'": No se especifico tarea a procesar</H2></CENTER>' )
 QOUT('<CENTER><H2>'+cArcInterfaz+': No se especifico tarea a procesar</H2></CENTER>' )
 QOUT('<BR>' )
 QOUT('</BODY></HTML>' )
 // Cerrar salida
 SGSALIDA0()
ENDC
RETU NIL

FUNC TAREA_AA
// Ejemplos 3, 5 de Modelo en Paralelo
// Observar que es el mismo ejemplo que se uso para el Modelo en Serie, pero en esta
// ocasion aplicado como un proceso especifico dentro del Modelo en Paralelo
 //Procesar y escribir informacion de salida
 SET CONSOLE OFF
 SET PRINTER TO (cArcSale)
 SET PRINTER ON
 QOUT('<HTML>')
 QOUT('<HEAD><TITLE>Modelo ClipNet: Ejemplos 3, 5 de Modelo en Paralelo</TITLE>')
 QOUT('   <META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-1">' )
 QOUT('   <META NAME="Author" CONTENT="David Arturo Macias Corona">' )
 QOUT('   <META NAME="GENERATOR" CONTENT="Mozilla/4.04 [en] (OS/2; I) [Netscape]">' )
 QOUT('   <META NAME="GENERATOR" CONTENT="Sistemas Genericos [SGD]">' )
 QOUT('</HEAD>')

 QOUT('<BODY background="'+cSvrLogos+'fondo0.gif" leftMargin=5 topMargin=5>')
// QOUT('<p align="center">' )
// QOUT('<img border="0" src="../cgi-bin/logos/logo.jpg" width="750" height="57" >')
// QOUT('</p>')

 QOUT( "Computadora: "+NETNAME()+", Fecha y hora: "+DTOC(DATE())+" "+TIME()+"<BR>" )
 QOUT('<CENTER><H2>Ejemplos 3 y 5 de Modelo en Paralelo</H2></CENTER>' )
 QOUT( "<HR>" )
 QOUT( "Archivo de entrada, cArcEntra = "+cArcEntra+"<BR>" )
 QOUT( "Archivo de salida,  cArcSale  = "+cArcSale +"<BR>" )
 QOUT( "Archivo de control de interfaz,  cArcInterfaz = "+cArcInterfaz +"<BR>" )

 QOUT( "<BR>" )
 QOUT( "Contenido de Archivo de entrada:<BR>" )
 QOUT( "<PRE>" )
 QOUT( MEMOREAD( cArcEntra ) )
 QOUT( "</PRE>" )

 QOUT('<BR>' )
 QOUT('</BODY></HTML>' )
 // Cerrar salida
 SET PRINTER OFF
 SET PRINTER TO
 SET CONSOLE OFF
RETU NIL


FUNC TAREA_BB
// Ejemplo 6 de Modelo en Paralelo
LOCAL ii, jj, aDirec
LOCAL lInicio, aIncCol

PRIV aDatos := {}, aAcum, aTitulos
PRIV cArcTG3   //Archivo para intercambio e imagen tipo BMP
PRIV cArcJPG   //Archivo de imagen tipo JPG
PRIV cArcEjec := "htg3xnet.exe"  //Archivo ejecutable con TGraph 3
PRIV cBmp2Jpg := "nconvert.exe"  //Archivo ejecutable para conversion BMP a JPG
PRIV lBmp2Jpg := .T.             //Aplicar conversion BMP a JPG

PRIV nDatos, xFor
PRIV cPerio1, cPerio2
PRIV cInterv1, cInterv2
PRIV cCliente, cEstado, cAtiende, cEjecuta, cTipo
PRIV xPXFormula

//Valores de sustitucion
IF SGCGIvaria( "CGIEJEC",,TRUE )
 cArcEjec := LOWE( ALLTRIM(SGCGIvaria("CGIEJEC")) )
ENDI

// Escribir informacion en archivo de salida
SGSALIDA0( cArcSale, .T., .F., .F. )

QOUT('<HTML>')
QOUT('<HEAD><TITLE>Modelo ClipNet: Ejemplo 6 de Modelo en Paralelo</TITLE>')
QOUT('   <META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-1">' )
QOUT('   <META NAME="Author" CONTENT="David Arturo Macias Corona">' )
QOUT('   <META NAME="GENERATOR" CONTENT="Mozilla/4.04 [en] (OS/2; I) [Netscape]">' )
QOUT('   <META NAME="GENERATOR" CONTENT="Sistemas Genericos [SGD]">' )
QOUT('</HEAD>')

QOUT('<BODY background="'+cSvrLogos+'fondo0.gif" leftMargin=5 topMargin=5>')

// Base de datos de Intervenciones
IF ! FILE( "libitv.dbf" )
 QOUT('<CENTER><H1> No existe LibItv.dbf </H1></CENTER>' )
 QOUT('<BR>' )
 QOUT('</BODY></HTML>' )
 // Cerrar salida
 SGSALIDA0()
 RETU
ENDI

//DAVID: Pruebas
//CHASetServer( 1 )   //ADS Local Server
//CHARddSetDefault("ADSCDX")

// CHARddSetDefault("DBFCDX")
RddSetDefault("DBFCDX")

// IF ! CPERUSE( "libitv",.F.,5,.F., 1,"libitv",.F., )  //"DBFCDX" )
DBUSEAREA( , , "libitv", "libitv", .T., )
IF NETERR( )
 QOUT('<CENTER><H1> No puede accesarse la base de datos </H1></CENTER>' )
 QOUT('<BR>' )
 QOUT('</BODY></HTML>' )
 // Cerrar salida
 SGSALIDA0()
 RETU
ENDI
OrdListAdd( "libitv" )

cPerio1 := SGCGIvaria( "CPERIO1" )
cPerio2 := SGCGIvaria( "CPERIO2" )
cInterv1 := SGCGIvaria( "INTERV1" )
cInterv2 := SGCGIvaria( "INTERV2" )
cCliente := SGCGIvaria( "CLIENTE" )
cEstado := SGCGIvaria( "ESTADO" )
cAtiende := SGCGIvaria( "CATIENDE" )
cEjecuta := SGCGIvaria( "CEJECUTA" )
cTipo := SGCGIvaria( "TIPO" )

IF EMPTY( cPerio2 )
 cPerio2 := LEFT(DTOS(DATE()-30*0),6)
ENDI
IF EMPTY( cPerio1 )
 cPerio1 := LEFT(DTOS(DATE()-30*12*2),6)
ENDI

QOUT('<p align="center">' )
QOUT('<img border="0" src="../cgi-bin/logos/logo.jpg" width="750" height="57" >')
QOUT('</p>')
QOUT('Generalmente tambien estas pantallas tienen muchos iconos fijos y/o girando, "banners", muchos ' )
QOUT('colores y tipos de letra, conectores, programas Java incrustados y hasta figuras volando por toda la pantalla' )
QOUT('<br>')
QOUT('Para propositos practicos no se usaran esos elementos, pero son aplicables igual que si se ')
QOUT('usaran solamente elementos de texto')
QOUT('<br>')

QOUT('<div align="center"><center>')
QOUT('<table border="0" cellpadding="1" cellspacing="1" width="100%">')
QOUT('<tr>')
QOUT('<td width="424"><p align="center"><b><font face="Comic Sans MS" color="#000080" size="5">')
QOUT('ESTADISTICAS DE INTERVENCIONES')
QOUT('</font></b></td>')
QOUT('</tr>')
QOUT('</table>')
QOUT('</center></div>')

QOUT( "<BR><B>De periodo:</B> "+cPerio1+"<B>  a periodo: </B>"+cPerio2 )
//Condiciones. Podria aplicarse filtro en lugar de FOR
xFor := ".t."
IF ! EMPTY( cInterv1 )
 //Para aprovechar ADS
 xFor := xFor+'.and.libitv->interv>='+cInterv1
 QOUT( "<BR><B>De intervencion: </B>"+cInterv1 )
ENDI
IF ! EMPTY( cInterv2 )
 //Para aprovechar ADS
 xFor := xFor+'.and.libitv->interv<='+cInterv2
 QOUT( "<BR><B>A intervencion: </B>"+cInterv2 )
ENDI
IF ! EMPTY( cCliente )
 //Para aprovechar ADS
 xFor := xFor+'.and.libitv->cliente=="'+PADR(cCliente,LEN(libitv->cliente))+'"'
 QOUT( "<BR><B>Cliente: </B>"+cCliente )
ENDI
IF ! EMPTY( cEstado )
 //Para aprovechar ADS
 xFor := xFor+'.and.libitv->estado=="'+UPPE(cEstado)+'"'
 QOUT( "<BR><B>Estado: </B>"+cEstado )
ENDI
IF ! EMPTY( cAtiende )
 //Para aprovechar ADS
 xFor := xFor+'.and.libitv->atencion=="'+PADR(cAtiende,LEN(libitv->atencion))+'"'
 QOUT( "<BR><B>Atiende: </B>"+cAtiende )
ENDI
IF ! EMPTY( cEjecuta )
 //Para aprovechar ADS
 xFor := xFor+'.and.libitv->ejecucion=="'+PADR(cAtencion,LEN(libitv->ejecucion))+'"'
 QOUT( "<BR><B>Ejecuta: </B>"+cEjecuta )
ENDI
IF ! EMPTY( cTipo )
 //Para aprovechar ADS
 xFor := xFor+'.and.libitv->tipo=="'+UPPE(cTipo)+'"'
 QOUT( "<BR><B>Tipo: </B>"+cTipo )
ENDI

//Crear bloque de codigo
xFor := SGBLOCK( xFor )

nDatos := 0
DBGOTOP()
WHILE ! EOF()
 IF ! EVAL( xFor )
  DBSKIP( 1 )
  LOOP
 ENDI
 acumfecha( DTOS(FSOLIC), 2 )
 acumfecha( DTOS(FPRES ), 3 )
 acumfecha( DTOS(FAUT  ), 4 )
 acumfecha( DTOS(FTERM ), 5 )
 acumfecha( DTOS(FENTRE), 6 )
 acumfecha( DTOS(FCANCEL), 7 )
 nDatos := nDatos + 1
 DBSKIP( 1 )
ENDD

 aDatos := ASORT( aDatos, , , { |x,y| x[1] < y[1] } )

aTitulos := { "Periodo", ;
              "Solicitadas", ;
              "Presupuestadas", ;
              "Autorizadas", ;
              "Terminadas", ;
              "Entregadas", ;
              "Canceladas" }

QOUT('<font face="Arial Narrow" size="3">')
QOUT('<div align="center"><center>' )

IF SGCGIVARIA( "TG3XNET", , .T. ) .AND. ! EMPTY( aDatos ) .AND. FILE( cArcEjec )
 //Lo inevitable: TGraph 3 y ClipNet-xNet juntos

 //Determinar columnas a incluir
 aIncCol := AFILL( ARRAY( LEN( aTitulos ) ), .F. )
 FOR jj = 2 TO LEN( aTitulos )
  aIncCol[jj] := SGCGIVARIA( "SERIE"+ALLTRIM(STR(jj-1)), , .T. )    //CheckBox, si existe es ON
 NEXT jj
 //Cerrar cArcSale
 SGSALIDA0()
 
 IF "OS/2" $ UPPE( OS() )  //ODIN no cierra la ventana de NConvert.exe
  lBmp2Jpg := .F.   //Se usaran BMP
 ENDI

 IF ! lBmp2Jpg   //Depurar BMPs
  // Automantenimiento de archivos tg3*.bmp para evitar basura
  aDirec := DIRECTORY( LOWE( SGCGIVARIA("DirTG3") )+"tg3*.bmp" )
  FOR ii = 1 TO LEN( aDirec )
   IF ( DATE() - aDirec[ ii, 3 ] ) > 1
    FERASE( LOWE( SGCGIVARIA("DirTG3") )+LOWE( aDirec[ii,1] ) )
   ENDI
  NEXT ii
 ENDI

 //Abrir archivo de intercambio para programa con TGraph 3
 cArcTG3 := SGARCTMP( LOWE( SGCGIVARIA("DirTG3") )+"tg3.bmp", .T. )   //Archivo para intercambio e imagen
 SGSALIDA0( cArcTG3, .T., .F., .F. )
 //Tipo de grafica y atributos
 QOUT( 'nTGrafica := '+STR( MAX(1,VAL( SGCGIVARIA("nTGrafica" ))) ) )
 QOUT( 'lRotate := '+IF( SGCGIVARIA("lRotate",,.T.),'.T.','.F.') )
 QOUT( 'lAxisInv := '+IF( SGCGIVARIA("lAxisInv",,.T.),'.T.','.F.') )
 QOUT( 'l3d := '+IF( SGCGIVARIA("l3d",,.T.),'.T.','.F.') )
 QOUT( 'lViewVal := '+IF( SGCGIVARIA("lViewVal",,.T.),'.T.','.F.') )
 QOUT( 'lLegend := '+IF( SGCGIVARIA("lLegend",,.T.),'.T.','.F.') )
 QOUT( 'lFill := '+IF( SGCGIVARIA("lFill",,.T.),'.T.','.F.') )
 QOUT( 'cBitMap := "epsilon.bmp"' )
 //Titulos
 lInicio := .T.
 QOUT( 'aTitCol' )
 FOR jj = 1+1 TO LEN( aTitulos )
  IF aIncCol[jj]
   QQOUT( IF( lInicio,"",",")+'"'+aTitulos[ jj ]+'"' )
   IF lInicio
    lInicio := .F.
   ENDI
  ENDI
 NEXT jj
 //Y todos los datos
 FOR ii = 1 TO LEN( aDatos )
  QOUT( '"'+aDatos[ ii, 1 ]+'"' )
  FOR jj = 2 TO LEN( aDatos[ ii ] )
   IF aIncCol[jj]
    QQOUT( ","+ALLTRIM(STR( aDatos[ ii, jj ] )) )
   ENDI
  NEXT jj
 NEXT ii
 SGSALIDA0( )

 //Prevision para LF=CHR(10) como fin de linea en Linux
 xPXFormula := ALLTRIM( MEMOREAD( cArcTG3 ) )
 IF ! CHR(13)+CHR(10) $ xPXFormula
  xPXFormula := STRTRAN( xPXFormula, CHR(10), CHR(13)+CHR(10) )
  MEMOWRIT( cArcTG3, xPXFormula )
 ENDI
 xPXFormula := NIL    //Recuperar memoria

 IF "LINUX" $ UPPE( OS() )
  cArcEjec := "wine -- "+cArcEjec   //Usar WINE. Se aplica "--" para evitar confusion de WINE con los parametros del programa
 ELSEIF "OS/2" $ UPPE( OS() )
  cArcEjec := "pe "+cArcEjec   //Usar ODIN en su modalidad PE
 ELSE
 ENDI

 //Linux: al ejecutarse mediante wine, no requiere verificar "/" y "./" para el ejecutable
 __Run( cArcEjec+" "+cArcTG3 )

 IF "WIN" $ UPPE(OS())
  //Al parecer la "familia Windows" ocupa un poco de tiempo para reaccionar
  //Podria ser su "clasico" problema de "visibilidad" en disco
  INKEY(1)
 ENDI

 IF lBmp2Jpg
  //Conversion BMP a JPG
IF lLinux
 //En Linux se borran todos.  Pendiente de revisar
ELSE
  // Automantenimiento de archivos tg3*.jpg para evitar basura
  aDirec := DIRECTORY( LOWE( SGCGIVARIA("DirTG3") )+"tg3*.jpg" )
  FOR ii = 1 TO LEN( aDirec )
   IF ( DATE() - aDirec[ ii, 3 ] ) > 1
    FERASE( LOWE( SGCGIVARIA("DirTG3") )+LOWE( aDirec[ii,1] ) )
   ENDI
  NEXT ii
ENDI

  cArcJPG := SGARCTMP( LOWE( SGCGIVARIA("DirTG3") )+"tg3.jpg", .T. )   //Archivo para imagen JPG
  IF "LINUX" $ UPPE( OS() )
   cBmp2Jpg := "wine -- "+cBmp2Jpg   //Usar WINE. Se aplica "--" para evitar confusion de WINE con los parametros del programa
  ELSEIF "OS/2" $ UPPE( OS() )
   cBmp2Jpg := "pe "+cBmp2Jpg   //Usar ODIN en su modalidad PE
  ELSE
  ENDI

  //Linux: al ejecutarse mediante wine, no requiere verificar "/" y "./" para el ejecutable
  __Run( cBmp2Jpg+" -in bmp -out jpeg -quiet -o "+cArcJPG+" "+cArcTG3 )
  FERASE( cArcTG3 )
 ENDI

 //Reabrir cArcSale con ADDITIVE
 SGSALIDA0( cArcSale, .T., .F., .T. )
 QOUT('<HR>')
 
 QOUT('<FONT FACE="Arial,Helvetica" COLOR="#CC6600" SIZE=-1>')
 QOUT('Documento elaborado dinamicamente por ')
 QOUT( NETNAME()+'   '+DTOS(DATE())+' '+TIME() )
 // QOUT( '<BR>' )
 QOUT( 'usando ' )
 QOUT('<FONT FACE="Arial,Helvetica" COLOR="#009900" SIZE=+1>')
 QOUT( '<I>Sistemas Genericos: Modelo ClipNet-xNet</I>')
 QOUT( '</FONT></FONT>')

 QOUT('<BR>')
 QOUT('<FONT FACE="Arial,Helvetica" COLOR="#CC6600" SIZE=-1>')
 QOUT('Grafica elaborada dinamicamente ')
 QOUT( 'usando ' )
 QOUT('<FONT FACE="Arial,Helvetica" COLOR="#009900" SIZE=+1>')
 QOUT( '<I>Sistemas Genericos: Modelo TGraph 3 y FiveWin-Harbour 2.4 (Julio 2003)</I>')
 QOUT( '</FONT></FONT>')
 QOUT('<HR>')
 
 //Aplicar solo el nombre del archivo de imagen, sin directorio
 //Se asume que el archivo esta en el directorio de paginas indicado por DirTG3
 QOUT('<img border="0" src="/'+FILENAME( IF(lBmp2Jpg,cArcJPG,cArcTG3) )+'" >')

ENDI

// Visualizacion en tabla

//QOUT( '<TABLE BORDER=1 width="1880">' )
QOUT( '<TABLE BORDER=1 ' )

QOUT( '<TR bgcolor=#99ff99 > ' )
FOR ii = 1 TO LEN( aTitulos )
 QQOUT( '<TH>'+aTitulos[ii]+'</TH>' )
NEXT ii
QQOUT( '</TR>' )

aAcum := { "Total", 0,0,0,0,0,0 }
FOR ii = 1 TO LEN( aDatos )
 QOUT( '<TR>' )
 QQOUT( '<TD>' )
 QQOUT( aDatos[ ii, 1 ] )
 QQOUT( '</TD>' )
 FOR jj = 2 TO LEN( aDatos[ ii ] )
  QQOUT( '<TD align=right >' )
  QQOUT( TRAN( aDatos[ ii, jj ], "###,###" ) )
  QQOUT( '</TD>' )
  aAcum[ jj ] := aAcum[ jj ] + aDatos[ ii, jj ]
 NEXT jj
 QQOUT( '</TR>' )
NEXT ii
 QOUT( '<TR>' )
 QQOUT( '<TD>' )
 QQOUT( aAcum[ 1 ] )
 QQOUT( '</TD>' )
 FOR jj = 2 TO LEN( aAcum )
  QQOUT( '<TD align=right >' )
  QQOUT( TRAN( aAcum[ jj ], "###,###" ) )
  QQOUT( '</TD>' )
 NEXT jj
 QQOUT( '</TR>' )

QOUT('</TABLE>')
QOUT('</center></div>')
QOUT('</font>')

QOUT( '<H3>Datos puntuales: '+ALLTRIM(STR( nDatos ))+'/'+ALLTRIM(STR( LASTREC() ))+'</H3>'  )
DBCLOSEAREA()

QOUT('<div align="center"><center>')
QOUT('<table border="0" cellspacing="0" width="590" height="129" cellpadding="0">')
QOUT('  <tr>')
QOUT('    <td width="280" height="21" align="center" valign="top"><font face="Comic Sans MS"')
QOUT('    size="2" color="#CC0000">')
QOUT('    <b>Mis Oficinas Centrales<br>')
QOUT('    </b></font><font face="Comic Sans MS" size="1" color="#CC0000">Mesopotamia # 12345<br>')
QOUT('    Jardines colgantes de Babilonia<br>')
QOUT('    Guadalajara, Jal., C.P. 44000<br>')
QOUT('    </font><font face="Comic Sans MS" size="1" color="#0000FF">')
QOUT('Telefonos: 3000-0000 y 3000-0001   Fax: 3000-0002<br>')
QOUT('E-mail: <a href="mailto:dmacias@mail.udg.mx">dmacias@mail.udg.mx</a></font></td>')
QOUT('  </tr>')
QOUT('</table>')
QOUT('</center></div>')

QOUT('</BODY></HTML>' )
// Cerrar salida
SGSALIDA0()

RETU NIL

FUNC ACUMFECHA( cFecha, nCol )
LOCAL cPeriodo, nElem
IF EMPTY( cFecha ) .OR. EMPTY( nCol )
 RETU NIL
ENDI
cPeriodo := LEFT( cFecha, 6 )
IF cPeriodo < cPerio1 .OR. cPeriodo > cPerio2
 RETU NIL
ENDI
IF (nElem := ASCAN( aDatos, { |x| x[ 1 ]==cPeriodo }) ) == 0   //No existe el periodo
 AADD( aDatos, { cPeriodo, 0, 0, 0, 0, 0, 0 } )
 nElem := LEN( aDatos )
ENDI
aDatos[ nElem, nCol ] := aDatos[ nElem, nCol ] + 1
RETU NIL


FUNC SGTTOL( cCadena )
// Texto a vector de lineas: (TextoTOLineas)
//Prevision para LF=CHR(10) como fin de linea en Linux
IF ! CHR(13)+CHR(10) $ cCadena
 cCadena := STRTRAN( cCadena, CHR(10), CHR(13)+CHR(10) )
ENDI
RETU SGPTOD( cCadena, CHR(13)+CHR(10), , FALSE )

FUNC SGPTOD( cLisPares, cDelimita, lComillas, lPares, nLonFija )
// Pares (Variable:=Valor) a Diccionario: (ParesTODiccionario)
// o Vector de elementos separados por delimitador o longitud fija
LOCAL nPos,cVarVal,aMatDic:={}
PRIV cElemento, cAsignacion

 IF lPares == NIL ; lPares := TRUE ; ENDI
IF cLisPares == NIL
 RETU aMatDic
ENDI
IF lPares
 // Pares (Variable:=Valor) a Diccionario: (ParesTODiccionario)
 IF ! ISCHARACTER( cLisPares ) .OR. ! ISCHARACTER( cDelimita )
  RETU aMatDic
 ENDI
 WHIL ! EMPTY( cLisPares )
  IF ! ( nPos := AT( cDelimita, cLisPares ) ) == 0   //Posicion de delimitador
   cVarVal := LEFT( cLisPares, nPos - 1 )  //Extraer linea
   cLisPares := SUBS( cLisPares, nPos + LEN( cDelimita ) )  //Texto restante
  ELSE
   cVarVal := cLisPares ; cLisPares := SPAC(0)
  ENDI
  IF EMPTY( cVarVal )
   LOOP
  ENDI
  IF ( nPos := AT( "=", cVarVal ) ) == 0  //No hay par Variable=Valor
   cElemento := UPPE( ALLTRIM( cVarVal ) )   //Se asigna como Variable
   cAsignacion := ""
  ELSE
   SGEXASIG( cVarVal, @cElemento, @cAsignacion, lComillas )
  ENDI
  IF EMPTY( cElemento )  //No hay variable
   LOOP
  ENDI
  // Agregar a diccionario sin reemplazar en caso de existir
  SGDICGEN( aMatDic, cElemento, 2, cAsignacion, FALSE )
 ENDD

ELSE // Vector de elementos separados
 IF ISNUMBER( nLonFija ) .AND. nLonFija > 0
  //Por longitud fija
  WHIL ! EMPTY( cLisPares )
   cVarVal := LEFT( cLisPares, nLonFija )  //Extraer linea
   cLisPares := SUBS( cLisPares, nLonFija + 1 )  //Texto restante
   AADD( aMatDic, cVarVal )
  ENDD
 ELSE
  //Por delimitador
  IF ! ISCHARACTER( cLisPares ) .OR. ! ISCHARACTER( cDelimita )
   RETU aMatDic
  ENDI
  WHIL ! EMPTY( cLisPares )
   IF ! ( nPos := AT( cDelimita, cLisPares ) ) == 0   //Posicion de delimitador
    cVarVal := LEFT( cLisPares, nPos - 1 )  //Extraer linea
    cLisPares := SUBS( cLisPares, nPos + LEN( cDelimita ) )  //Texto restante
   ELSE
    cVarVal := cLisPares ; cLisPares := SPAC(0)
   ENDI
   AADD( aMatDic, cVarVal )
  ENDD
 ENDI
ENDI
RETU aMatDic


PROC SGEXASIG(cLin,cElemento,cAsignacion , lComillas )
// Extraer asignacion

// Basada en EXTRAEASIG() de GenRes

LOCAL nCar:=0
IF cLin == NIL
 cElemento := cAsignacion := ""
 RETU
ENDI
 IF lComillas == NIL ; lComillas := FALSE ; ENDI

IF (AT(":=",cLin)!=0)  //Asignacion en linea ( := )
 nCar:=AT(":=",cLin)
 IF AT("=",cLin)>nCar  //Valido :=
  cElemento:=UPPE(ALLTRIM(LEFT(cLin,nCar-1)))   //Extraer elemento
  cAsignacion:=ALLTRIM(SUBS(cLin,nCar+2)) //Asignacion
 ELSE  //Asignacion simple  ( = )
  nCar:=AT("=",cLin)
  cElemento:=UPPE(ALLTRIM(LEFT(cLin,nCar-1)))   //Extraer elemento
  cAsignacion:=ALLTRIM(SUBS(cLin,nCar+1)) //Asignacion
 ENDI
ELSE  //Asignacion simple  ( = )
 nCar:=AT("=",cLin)
 cElemento:=UPPE(ALLTRIM(LEFT(cLin,nCar-1)))   //Extraer elemento
 cAsignacion:=ALLTRIM(SUBS(cLin,nCar+1)) //Asignacion
ENDI
IF lComillas  //Eliminar comillas en los extremos
 // Suprimir ", ', []
 IF LEFT( cAsignacion, 1 ) $ CHR(ASC('"'))+CHR(ASC("'"))+CHR(ASC('['))
  cAsignacion := SUBS( cAsignacion, 2 )
 ENDI
 IF RIGHT( cAsignacion, 1 ) $ CHR(ASC('"'))+CHR(ASC("'"))+CHR(ASC(']'))
  cAsignacion := LEFT( cAsignacion, LEN(cAsignacion) - 1 )
 ENDI
// cAsignacion := ALLTRIM( cAsignacion )
ENDI
RETU


FUNC SGDICGEN( aDicGen, cCodigo, nProceso, xValor, p1, p2 )
// Diccionario Generico
LOCAL nElem := 0
LOCAL ii

IF cCodigo == NIL .OR. nProceso == NIL  //No hay nada que hacer
 RETU FALSE
ENDI
IF ! ISARRAY( aDicGen ) .OR. ;  //Debe ser matriz de diccionario
 ! ISCHARACTER( cCodigo ) .OR. ;    //Debe ser caracter
 ! ISNUMBER( nProceso )          //Debe ser numerico
 RETU FALSE
ENDI

DO CASE
CASE ( nProceso == 1 .OR. nProceso == 5 )   //Entregar valor
IF ! ( (nElem := ASCAN( aDicGen, { |x| x[ 1 ]==cCodigo }) ) == 0 )   // Existe el codigo
 RETU aDicGen[ nElem, 2 ]
ENDI

CASE nProceso == 2     // Registrar/reemplazar
//No se verifica tipo de dato para Valor, puede tener cualquier tipo, incluyendo NIL
 IF p1 == NIL ; p1 := FALSE ; ENDI    //Omision: no reemplazar
IF ( (nElem := ASCAN( aDicGen, { |x| x[ 1 ]==cCodigo }) ) == 0 )   //No Existe
 //Agregar a aDicGen
 AADD( aDicGen, { cCodigo, NIL } )
 nElem := LEN( aDicGen ) ; p1 := TRUE
ENDI
IF p1     //Reemplazar
 aDicGen[ nElem, 2 ] := xValor
 RETU TRUE
ENDI

CASE nProceso == 3     //Borrar matriz de diccionario
IF ! ( (nElem := ASCAN( aDicGen, { |x| x[ 1 ]==cCodigo }) ) == 0 )   // Existe
 FOR ii = nElem TO LEN( aDicGen ) - 1
  aDicGen[ ii ] := aDicGen[ ii + 1 ]
 NEXT ii
 ASIZE( aDicGen, LEN( aDicGen ) - 1 )
 RETU TRUE
ENDI

CASE nProceso == 4     //Indicar existencia en diccionario
IF ! ( (nElem := ASCAN( aDicGen, { |x| x[ 1 ]==cCodigo }) ) == 0 )   // Existe
 RETU TRUE
ENDI

ENDC
RETU FALSE


FUNC SGCGIvaria( cCodigo, aCGIvaria, lCGIexiste )
// Entregar Valor contenido en matrices CGI
IF cCodigo == NIL .OR. ; //No hay nada que hacer
 ! ISCHARACTER( cCodigo )
 RETU SPAC( 0 )
ENDI
IF aCGIvaria == NIL
 aCGIvaria := aCGItodos
ENDI
DEFAULT lCGIexiste TO FALSE
cCodigo := UPPE( cCodigo )
IF lCGIexiste
 RETU SGDICGEN( aCGIvaria, cCodigo, 4 )  //Verifica existencia
ENDI
IF SGDICGEN( aCGIvaria, cCodigo, 4 )   //Existe la variable
 RETU SGDICGEN( aCGIvaria, cCodigo, 1 )  //Retorna Valor
ENDI
RETU SPAC( 0 )


FUNC SGSALIDA0( cDestino, lOperaPantalla, xMensaje, lAgregar, nHandler )
//Flujo basico de salida
LOCAL lHandler
IF ! cDestino==NIL   //Abrir
// p_zona := NIL  //Inicializar
 IF ! xMensaje == NIL   //Mensaje
  IF ISLOGICAL( xMensaje ) .AND. xMensaje
//   xMensaje := SGIDI( "g_Procesando" )+" ..."
  ENDI
  IF ISCHARACTER( xMensaje )
//   p_zona := SGAVISO( xMensaje , FALSE )
  ENDI
 ENDI
  IF lOperaPantalla == NIL ; lOperaPantalla := TRUE ; ENDI
  IF lAgregar == NIL ; lAgregar := FALSE ; ENDI
 #ifdef FIVEWIN
 lHandler := ( ISNUMBER( nHandler ) )  //Usar Handler diferente a nHandOut ?
 IF ! lHandler .AND. ;
    ! EMPTY( nHandOut )
  FCLOSE( nHandOut ) ; nHandOut := 0
 ENDI
 IF lAgregar
  // Abrir en modo: Leer y escribir + Compartido
  nHandler := FOPEN( cDestino, FO_READWRITE+FO_SHARED )
  //ADDITIVE: fin de archivo
  FSEEK( nHandler, 0, FS_END )
 ELSE
  nHandler := FCREATE( cDestino, FC_NORMAL )
 ENDI
 IF ! lHandler  //Usar nHandOut
  nHandOut := nHandler
 ENDI
 RETU nHandler

 #else
 IF lOperaPantalla
  SET( _SET_CONSOLE , FALSE )  //Apagar pantalla
 ENDI
 SET( _SET_PRINTFILE, cDestino, lAgregar ) ; SET( _SET_PRINTER, TRUE )
// RETU p_zona
 RETU NIL
 #endif
ELSE   //Cerrar
  IF lOperaPantalla == NIL ; lOperaPantalla := TRUE ; ENDI
 #ifdef FIVEWIN
 DEFAULT nHandler TO nHandOut
 IF ! EMPTY( nHandler )
  FCLOSE( nHandler )
  IF nHandler == nHandOut
   nHandOut := 0
  ENDI
  nHandler := 0
 ENDI
 #else
 SET( _SET_PRINTER, FALSE ) ; SET( _SET_PRINTFILE, "" )
 IF lOperaPantalla
  SET( _SET_CONSOLE , TRUE )  //Prender pantalla
 ENDI
// IF ! p_zona == NIL
//  SGDICZON( p_zona, 3 )     //Restaurar zona
//  SGDICZON( p_zona, 4 )     //Eliminar zona de diccionario
// ENDI
 #endif

// p_zona := NIL
 RETU TRUE
ENDI
RETU FALSE


FUNC YOUT( cOutTexto, oFontX, nWidth, nClrText, nBkMode, nPad, lSombra, ;
 lImpresora, nHandler )
//Sustitucion de QOUT()
//Basicamente efectua salto de linea

#ifdef FIVEWIN  //FiveWin
 DEFAULT lImpresora TO FALSE
 DEFAULT nHandler TO nHandOut
 IF lImpresora
  //Aumentar el espaciado entre lineas sin cambio entre columnas
  nPrnLin += oPrn:GetTextHeight( "", oFont0 ) * nPrnFacAlt
  nPrnCol := oPrn:GetTextWidth( "B", oFont0 ) * nPrnLMargen
 ELSE
  FWRITE( nHandler, CRLF )
 ENDI
#else  //Clipper, cualquier salida
 QOUT()
#endif
//Valores de emulacion PRow(),PCol()
nPRow += 1
nPCol := 0  //+ nPrnLMargen
//Sincronizar con PRow(), PCol() de Clipper
SetPrc( PtRow(), PtCol() )
RETU YYOUT( cOutTexto, oFontX, nWidth, nClrText, nBkMode, nPad, lSombra, ;
 lImpresora, nHandler )


FUNC YYOUT( xOutTexto, oFontX, nWidth, nClrText, nBkMode, nPad, lSombra, ;
 lImpresora, nHandler )
//Sustitucion de QQOUT()
//Basicamente imprime en la posicion actual
LOCAL nStartCol
LOCAL cOutTexto := xOutTexto

DO CASE
CASE ISDATE( xOutTexto )
 cOutTexto := DToC( xOutTexto )
CASE ISNUMBER( xOutTexto )
 cOutTexto := STR( xOutTexto )
CASE ISLOGICAL( xOutTexto )
 cOutTexto := IF( xOutTexto, "T", "F" )
CASE ISCHARACTER( xOutTexto )
 cOutTexto := xOutTexto
OTHE
 cOutTexto := ""    //YYOUT() invalido
ENDC
/*
IF ! ISCHARACTER( cOutTexto )
 RETU NIL
ENDI
*/
#ifdef FIVEWIN  //FiveWin
 DEFAULT lImpresora TO FALSE
 DEFAULT nHandler TO nHandOut
 IF lImpresora
  DEFAULT oFontX TO oFont0
  DEFAULT nClrText TO CLR_BLACK
  DEFAULT nBkMode TO 1
  DEFAULT nPad TO 0  //PAD_LEFT
  DEFAULT lSombra TO FALSE

  DO CASE
  CASE nPad == 0   //RPT_LEFT
   nStartCol := nPrnCol
  CASE nPad == 1   //RPT_RIGHT
   nStartCol := nPrnCol + ;
    IF(EMPTY(nWidth),oPrn:nHorzRes()-nPrnCol,nWidth)-;
    oPrn:GetTextWidth( cOutTexto, oFontX )
  CASE nPad == 2   //RPT_CENTER
   nStartCol := nPrnCol + ;
    Int(IF(EMPTY(nWidth),oPrn:nHorzRes()-nPrnCol,nWidth)/2) -;
    Int(oPrn:GetTextWidth( cOutTexto, oFontX )/2)
  OTHE
   nStartCol := nPrnCol
  ENDC

  IF lSombra
   SetbkMode( oPrn:hDCOut, 1 )  //Transparent
// HP LaserJet 1100 agrega una columna mas con COURIER (?)
   oPrn:FillRect({ nPrnLin, nStartCol , ;
    nPrnLin+oPrn:GetTextHeight( "", oFontX ) ,;
    nStartCol+oPrn:GetTextWidth( cOutTexto, oFontX ) } ,;
    oSomBrush )
  ENDI
  oPrn:Say( nPrnLin, nStartCol, OEMTOANSI(cOutTexto), oFontX, nWidth, nClrText )

  //Aumentar nPrnCol basado en tamao de fuente de oFont0
  nPrnCol += oPrn:GetTextWidth( cOutTexto, oFont0 )

 ELSE
  FWRITE( nHandler, cOutTexto )
 ENDI
#else  //Clipper, cualquier salida
 QQOUT( cOutTexto )
#endif

//Valores de emulacion PRow(),PCol()
nPRow += 0
nPCol += LEN( cOutTexto )
//Sincronizar con PRow(), PCol() de Clipper
SetPrc( PtRow(), PtCol() )
RETU NIL


FUNC YYYOUT( cOutTexto )
//Aplicar comando de impresora sin "mover" posicion de impresion
LOCAL nRow0, nCol0
#ifdef FIVEWIN
IF lImpGrafica
 RETU ""
ENDI
#else
#endif
nRow0 := PtRow()
nCol0 := PtCol()
YYOUT( cOutTexto )
PtSetPrc( nRow0, nCol0 )
RETU ""   //Evita que tenga dimension si se usa combinada PtSay(x,y,YYYOut(cCmd)+Texto)


FUNC PtRow()
//Emular PRow() para FiveWin
RETU nPRow


FUNC PtCol()
//Emular PCol() para FiveWin
RETU nPCol


FUNC PtSetPrc( nRow, nCol )
//Emular SetPrc() para FiveWin
IF ! ISNUMBER( nRow )
 nRow := PtRow()
ENDI
IF ! ISNUMBER( nCol )
 nCol := PtCol()
ENDI
nPRow := MAX( 0, nRow )
nPCol := MAX( 0, nCol )  //+ nPrnLMargen
IF lImpGrafica
 #ifdef FIVEWIN
 nPrnLin := oPrn:GetTextHeight( "", oFont0 ) * nPrnFacAlt * ( nPrnTMargen + nPRow )
 nPrnCol := oPrn:GetTextWidth( "B", oFont0 ) * ( nPrnLMargen + nPCol )
 #else
 #endif
ELSE
ENDI
//Sincronizar con PRow(), PCol() de Clipper
SetPrc( PtRow(), PtCol() )
RETU NIL


FUNC SGBLOCK( bBloque )
//Crea bloque de codigo
IF ! bBloque == NIL .AND. VALTYPE(bBloque) == "C"
 bBloque := IF("|"$bBloque,"","|| ")+bBloque
 bBloque := &("{ "+bBloque+" }")
ENDI
RETU bBloque


FUNC SGARCTMP(cExtension,lCrear)
// Generar nombre unico para la ubicacion.extension dadas
LOCAL cArchivo, nK
LOCAL cDir, nPos
 DEFAULT cExtension TO "tmp"
 DEFAULT lCrear TO FALSE
IF ! (nPos:=AT(".",cExtension)) == 0
 cDir := SUBS( cExtension,1,nPos-1 )
 cExtension := SUBS( cExtension,nPos )
ELSE
 cDir := ""
 cExtension := "."+cExtension
ENDI
IF EMPTY( cDir )
 cDir := SET(_SET_DEFAULT)
ENDI
//Para reconocimiento de archivos en Linux
cDir := LOWE(cDir)
cExtension := LOWE(cExtension)
nK := 1 ; cArchivo := ALLTRIM(STR(nK))
WHILE FILE( cDir+cArchivo+cExtension )
 cArchivo := ALLTRIM(STR(++nK))
ENDD
IF lCrear
 // Crear archivo vacio
 FCLOSE( FCREATE( cDir+cArchivo+cExtension ) )
ENDI
RETU cDir+cArchivo+cExtension


FUNC FileName( cCadena )
//Nombre de archivo sin incluir directorios
LOCAL nPos     // Ubicar posicion de busqueda en cadena
// Remover disco, si hay
IF (nPos:=AT(":",cCadena))!=0
 cCadena:=SUBS(cCadena,++nPos)
ENDI
// Remover camino, si hay
IF (nPos:=RAT( cDirSepara,cCadena))!=0
 cCadena:=SUBS(cCadena,++nPos)
ENDI
RETU cCadena


/***
*
*  FILEEXTEN( <cFile> ) --> cFileExt
*
*  Extract the three letter extension from a filename
*
*/
//DAVID: La version Win32:Samples.lib:FileExt() produce GPF si cFile no tiene punto
FUNCTION FILEEXTEN( cFile )

   LOCAL nPos        // Marks the position of the extension, if any
   LOCAL cFileExt    // Return value, the extension of cFile

   // Does the file extension exist?
   IF ( nPos := RAT( ".", cFile )) != 0
      cFileExt := SUBSTR( cFile, nPos + 1 )  // Extract it
   ELSE
      cFileExt := ""                         // None exists, return ""
   ENDIF

   RETURN ( cFileExt )


#ifdef HARBOUR
FUNC SGHrbRun( cHRBArchivo, xParam1, xParam2, xParam3, xParam4, xParam5, xParam6, xParam7, xParam8, xParam9 )
// Ejecutar "Harbour Portable Object (.hrb)" o "Archivos fuente (.prg)", leido de disco
LOCAL xHrbRetorna
LOCAL cHrbEjecuta  //Archivo .hrb
LOCAL cHrbPrg,xPXFormula      //Archivo .prg temporal
LOCAL cHrbComp := "harbour"+IF( lLinux, "", ".exe" )
LOCAL cHrbSwitch := "-m -n -gh -q0"

IF ! ISCHARACTER(cHRBArchivo)  //Debe ser cadena
 RETU FALSE
ENDI
cHRBArchivo := LOWE( ALLTRIM( cHRBArchivo ) )
IF ! FILE( cHRBArchivo )
// CPEAVISO( 'No existe el archivo de PrgExt:'+cPXArchivo )
 RETU FALSE
ENDI
cHrbEjecuta := cHrbArchivo
IF "+"+LOWE( FILEEXTEN( cHrbArchivo ) )+"+" $ "+prg+"  //"Archivos fuente (.prg)"

 //Prevision para LF=CHR(10) como fin de linea en Linux
 xPXFormula := ALLTRIM( MEMOREAD( cHrbArchivo ) )
 IF lLinux
  IF CHR(13)+CHR(10) $ xPXFormula
   xPXFormula := STRTRAN( xPXFormula, CHR(13)+CHR(10), CHR(10) )
  ENDI
 ELSE
  IF ! CHR(13)+CHR(10) $ xPXFormula
   xPXFormula := STRTRAN( xPXFormula, CHR(10), CHR(13)+CHR(10) )
  ENDI
 ENDI
 cHrbPrg := SGArcTmp( "hrb.prg" )
 MEMOWRIT( cHrbPrg, xPXFormula )
 xPXFormula := NIL    //Recuperar memoria

 //Crear archivo .hrb temporal
 cHrbEjecuta := SGArcTmp( "hrb.hrb" )
 //Se asume que el entorno Harbour esta disponible en PATH, SET, ...
 __Run( cHrbComp + " " + cHrbPrg + " " + cHrbSwitch )
 FERASE( cHrbPrg )

ENDI
//Ejecutar archivo .hrb
xHrbRetorna := __hrbRun( cHRBEjecuta, xParam1, xParam2, xParam3, xParam4, xParam5, xParam6, xParam7, xParam8, xParam9 )
IF "+"+LOWE( FILEEXTEN( cHrbArchivo ) )+"+" $ "+prg+"  //"Archivos fuente (.prg)"
 FERASE( cHrbEjecuta )   //Borrar archivo .hrb temporal
ENDI
RETU xHrbRetorna
#else
#endif
