/* 2004/02/02: I.Q. David Arturo Macias Corona   visuadb.prg

Proceso para Visualizar/Editar una base de datos usando servidores MySQL
MaCDavid, 20031216: Aplicacion de edicion ABC/C: Altas, Bajas, Cambios, Consultas
MaCDavid, 20040205: Adaptacion para servidores MySQL
MaCDavid, 20040212: Adaptacion para manejar archivos DBF o archivos MySQL
*/

/* El proceso esta basado en el control por numero de registro
En una estructura tipo DBF, el numero de registro es constante para un
registro dado entre consultas diferentes, a menos que se apliquen procesos
PACK o ZAP entre consultas

ADVERTENCIA: En una estructura tipo MySQL, el numero de registro puede no ser constante
para un registro dado entre consultas diferentes, debido a que la tabla resultante de
la consulta puede diferir en los registros contenidos y por lo tanto pueden
cambiar de numeracion.
En consecuencia, la identificacion del registro por numero no es confiable
*/

#define  TRUE   .T.
#define  FALSE  .F.
#define  K_ESC  27


FUNC MAIN

PRIV ii
PRIV jj
PRIV cSvrLogos := "../cgi-bin/logos/"
PRIV cContador := "visuadb.cnt"

PRIV cMetodo := SGCGIvaria("REQUEST_METHOD")

PRIV lesMySQL := .F.   //Diferenciar proceso para DBF o MySQL

PRIV cMySQLhost := SGCGIvaria( "cMySQLhost" )  // "127.0.0.1"  //"localhost"
PRIV cMySQLuser := SGCGIvaria( "cMySQLuser" )  // "root"
PRIV cMySQLpass := SGCGIvaria( "cMySQLpass" )  // ""
PRIV cBaseSQL := SGCGIvaria( "cBaseSQL" )  // "david"
PRIV cTableSQL := SGCGIvaria( "cTableSQL" )  // "libnom"

PRIV oServer   //Conexion a MySQL
PRIV oTable    //Resultado de la consulta
PRIV oRecord   //Fila
PRIV cWhereSQL

//Por omision se procesan archivos DBF
lesMySQL := ( ! EMPTY( cMySQLhost ) .AND. ;
              ! EMPTY( cBaseSQL ) .AND. ;
              ! EMPTY( cTableSQL ) )

PRIV aRdd := { "DBFCDX", "DBFNTX" }
PRIV lAds := "WINDOWS" $ UPPE(OS()) .OR. "LINUX" $ UPPE(OS())
IF lAds
 aRdd := { "DBFCDX", "DBFNTX", "DBFCDXAX", "DBFNTXAX", "ADSCDX", "ADSNTX" }
ENDI
PRIV nCheckADS
PRIV lCheckADS

PRIV cBaseDBF
PRIV cBaseDBF1 := SGCGIvaria( "cBasedbf1" )
PRIV cBaseDBF2 := SGCGIvaria( "cBasedbf2" )
PRIV cIndice := SGCGIvaria( "cIndice" )
PRIV cOrden := SGCGIvaria( "cOrden" )
PRIV cRDD := UPPE( SGCGIvaria( "cRDD" ) )
PRIV cADStipo := UPPE( SGCGIvaria( "cADStipo" ) )
PRIV nRecno := VAL( SGCGIvaria( "nRecno" ) )
PRIV nRango := VAL( SGCGIvaria( "nRango" ) )
PRIV cFiltro := SGCGIvaria( "cFiltro" )
PRIV cCampos := SGCGIvaria( "cCampos" )
PRIV cSkip := SGCGIvaria( "cSkip" )
PRIV aCampos
PRIV nPos
PRIV cField
PRIV cCadena
PRIV cAlias
PRIV cScrName

//Visualizacion/edicion de registro individual
// PRIV cUsuario
// PRIV cPassWd
PRIV lEdicion := SGCGIvaria( "LEDICION",,.T. )
PRIV cOpera := UPPE( SGCGIvaria("cOpera") )
PRIV nRegistro := VAL( SGCGIvaria( "nRegistro" ) )
PRIV lMultiple
PRIV lAplicar
PRIV lExiste
PRIV aEstruc
PRIV cTipo
PRIV cValor
PRIV cVarLen
PRIV cVarVal

//Uso de condicion en vez de filtro
PRIV xFor

//Procesos particulares
PRIV cMuestra := SGCGIvaria("cMuestra")
PRIV cEditar  := SGCGIvaria("cEditar")
PRIV cActualiza := SGCGIvaria("cActualiza")
PRIV cPagina  := SGCGIvaria("cPagina")
PRIV bMuestra
PRIV bEditar
PRIV bActualiza
PRIV bPagina

//Por el momento se asumen especificaciones de archivos .fml en disco
IF EMPTY( cMuestra )
 cMuestra := 'MUESTRA()'
ELSE
 cMuestra := 'SGFML("'+cMuestra+'")'
ENDI
IF EMPTY( cEditar )
 cEditar := 'EDITAR()'
ELSE
 cEditar := 'SGFML("'+cEditar+'")'
ENDI
IF EMPTY( cActualiza )
 cActualiza := 'ACTUALIZA()'
ELSE
 cActualiza := 'SGFML("'+cActualiza+'")'
ENDI
IF EMPTY( cPagina )
 cPagina := 'PAGINA()'
ELSE
 cPagina := 'SGFML("'+cPagina+'")'
ENDI
//Crear bloques de codigo
bMuestra := SGBLOCK( cMuestra )
bEditar := SGBLOCK( cEditar )
bActualiza := SGBLOCK( cActualiza )
bPagina := SGBLOCK( cPagina )

/* Se puede usar:
- SGOutStd(): para simular la salida directa al servidor Web
  En este caso no se requiere cArcSale, y no debe usarse QOUT()
- cArcSale y QOUT(): para enviar la salida al archivo cArcSale, el cual es definido y usado por el modelo ClipxNet
  para usarlo como "salida" que se enviara al servidor Web
*/

// Escribir informacion en archivo de salida
SGSALIDA0( cArcSale, .T., .F., .F. )

QOUT('<HTML>')
QOUT('<HEAD><TITLE>Modelo ClipNet: Visualizar'+IF(lEdicion,'/Editar ','') ;
 +' una base de datos tipo '+IF(lesMySQL,'MySQL','DBF')+'</TITLE>')
QOUT('   <META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-1">' )
QOUT('   <META NAME="Author" CONTENT="David Arturo Macias Corona">' )
QOUT('   <META NAME="GENERATOR" CONTENT="Mozilla/4.04 [en] (OS/2; I) [Netscape]">' )
QOUT('   <META NAME="GENERATOR" CONTENT="Sistemas Genericos [SGD]">' )
QOUT('</HEAD>')

// QOUT('<BODY background="'+cSvrLogos+'fondo0.gif" leftMargin=5 topMargin=5>')
QOUT('<BODY >')

QOUT('<p align="center">' )
QOUT('<img border="0" src="../cgi-bin/logos/logo.jpg" width="750" height="57" >')
QOUT('</p>')

DO CASE
CASE ! lesMySQL
 // Base de datos
 cBaseDBF := cBaseDBF2  //Archivo de listado
 IF ! EMPTY( cBaseDBF1 )   //Archivo escrito tiene prioridad sobre archivo de listado
  cBaseDBF := cBaseDBF1
 ENDI
 IF EMPTY( cBaseDBF )
  QOUT('<CENTER><H1> Debe especificar una base de datos</H1></CENTER>' )
  QOUT('<BR>' )
  QOUT('</BODY></HTML>' )
  // Cerrar salida
  SGSALIDA0()
  RETU
 ENDI
 IF ! FILE( cBaseDBF )
  QOUT('<CENTER><H1> No existe la base de datos:'+cBaseDBF+' </H1></CENTER>' )
  QOUT('<BR>' )
  QOUT('</BODY></HTML>' )
  // Cerrar salida
  SGSALIDA0()
  RETU
 ENDI

 CHARDDSetDefault( "DBFCDX" )  //Establecer RDD por omision
 IF EMPTY( cRdd ) .OR. ;
  ( ASCAN( aRdd, SGBLOCK( '|x| UPPE(ALLTRIM(cRdd)) == x ' ) ) == 0 )
  cRdd := CHARDDSETDEFAULT()  //Usar el RDD actual
 ENDI
 CHARDDSetDefault( cRdd )  //Establecer RDD por omision
 IF "ADS" $ cRdd .OR. "AX" $ cRdd    //Advantage
  IF cADStipo == "LOCAL"
   CHASetServer( 1 )   //ADS Local Server
  ELSE
   CHASetServer( 2 )   //ADS Remote Server

   IF lLinux
    //Pendiente implementar verificacion de ADS activo
    //Tomar en consideracion de que INKEY(n) no funciona sin "ncurses"

   ELSE
    //5 intentos de verificacion de ADS activo
    nCheckADS := 1
    lCheckADS := .F.
    WHIL ! ( lCheckADS := CHALoaded( CHAGetDrive( cBaseDBF ) ) ) .AND. ;  //Verificar Servidor ADS activo
     nCheckADS <= 5
     INKEY(0.5)
     nCheckADS := nCheckADS+1
    ENDD
    IF ! lCheckADS   //No hay Servidor ADS activo
     QOUT('<CENTER><H1>No se tiene disponible ADS remoto</H1></CENTER>' )
     QOUT('<BR>' )
     QOUT('</BODY></HTML>' )
     // Cerrar salida
     SGSALIDA0()
     RETU
    ENDI
   ENDI
  ENDI
 ENDI

 // CPERUSE: Base,Modo Exclusivo,Segundos,usar mensaje,Area,Alias,Solo Lectura,RDD
 IF ! CPERUSE( cBaseDBF,.F.,5,.F., 1, ,.F., )
  QOUT('<CENTER><H1> No puede accesarse la base de datos '+cBaseDBF+' </H1></CENTER>' )
  QOUT('<BR>' )
  QOUT('</BODY></HTML>' )
  // Cerrar salida
  SGSALIDA0()
  RETU
 ENDI
 cAlias := ALIAS()
 aEstruc := DBSTRUCT( )

 IF ! EMPTY( cIndice ) .AND. FILE( FILEPATH(cBaseDBF)+cIndice )
  OrdListAdd( FILEPATH(cBaseDBF)+cIndice )
 ENDI
 OrdSetFocus( 1 )  //Nota: RDD de ordenes multiples por omision no establecen orden controlador
 IF ! EMPTY( cOrden )
  OrdSetFocus( cOrden )
 ENDI

 IF ! EMPTY( cFiltro )
  // Usar AOFSetFilter() si esta habilitado AOF, en lugar de DBSETFILTER()
  //   Se debe usar solo una de ambas funciones
  DBSETFILTER( SGBLOCK( cFiltro ), cFiltro )
 ENDI

 lMultiple := nRegistro < 1 .OR. nRegistro > (cAlias)->(LASTREC())
 (cAlias)->(DBGOTOP())

CASE lesMySQL

 IF EMPTY( cMySQLhost )
  QOUT('<CENTER><H1> Debe especificar servidor MySQL</H1></CENTER>' )
  QOUT('<BR>' )
  QOUT('</BODY></HTML>' )
  // Cerrar salida
  SGSALIDA0()
  RETU
 ENDI
 IF EMPTY( cBaseSQL ) .OR. EMPTY( cTableSQL )
  QOUT('<CENTER><H1> Debe especificar base de datos y tabla MySQL</H1></CENTER>' )
  QOUT('<BR>' )
  QOUT('</BODY></HTML>' )
  // Cerrar salida
  SGSALIDA0()
  RETU
 ENDI

 oServer := TMySQLServer():New( cMySQLhost, cMySQLuser, cMySQLpass )
 IF oServer:NetErr()
  QOUT('<CENTER><H1> No puede conectarse al servidor MySQL '+cMySQLhost+' </H1></CENTER>' )
  QOUT('<CENTER><H3> Error: ' + oServer:error() + '</H3></CENTER>' )
  QOUT('<BR>' )
  QOUT('</BODY></HTML>' )
  // Cerrar salida
  SGSALIDA0()
  RETU
 ENDI

 oServer:SelectDB( cBaseSQL )
 IF oServer:NetErr()
  QOUT('<CENTER><H1> No puede accesarse la base de datos '+cBaseSQL+' </H1></CENTER>' )
  QOUT('<CENTER><H3> Error: ' + oServer:error() + '</H3></CENTER>' )
  QOUT('<BR>' )
  QOUT('</BODY></HTML>' )
  // Cerrar salida
  SGSALIDA0()
  RETU
 ENDI
 cAlias := ""   //ALIAS()

 oTable := oServer:Query("SELECT * FROM " + cTableSQL + " LIMIT 1")
 // oTable := oServer:Query( "SELECT * FROM " + cTableSQL )
 IF oTable:NetErr()
  QOUT('<CENTER><H1> No puede accesarse la tabla '+cTableSQL+' </H1></CENTER>' )
  QOUT('<CENTER><H3> Error: ' + oTable:error() + '</H3></CENTER>' )
  QOUT('<BR>' )
  QOUT('</BODY></HTML>' )
  // Cerrar salida
  SGSALIDA0()
  RETU
 ENDI

 aEstruc := { }   // DBSTRUCT( )
 FOR ii = 1 TO oTable:FCOUNT()
  AADD( aEstruc, { oTable:FieldName( ii ), ;
                   oTable:FieldType( ii ), ;
                   oTable:FieldLen( ii ), ;
                   oTable:FieldDec( ii ) } )
 NEXT ii

 oTable:Destroy()

 /*
 IF ! EMPTY( cIndice ) .AND. FILE( FILEPATH(cBaseDBF)+cIndice )
  OrdListAdd( FILEPATH(cBaseDBF)+cIndice )
 ENDI
 OrdSetFocus( 1 )  //Nota: RDD de ordenes multiples por omision no establecen orden controlador
 IF ! EMPTY( cOrden )
  OrdSetFocus( cOrden )
 ENDI
 */

 cWhereSQL := ""
 IF ! EMPTY( cFiltro )
  cWhereSQL := " WHERE "+cFiltro
 ENDI

 // Pendiente la aplicacion de LIMIT x,y debido a que requiere bastantes cambios en control de flujo
 oTable := oServer:Query( "SELECT * FROM " + cTableSQL + cWhereSQL )
 IF oTable:NetErr()
  QOUT('<CENTER><H1> No puede accesarse la tabla '+cTableSQL+' </H1></CENTER>' )
  QOUT('<CENTER><H3> Error:  ' + oTable:error() + '</H3></CENTER>' )
  QOUT('<BR>' )
  QOUT('</BODY></HTML>' )
  // Cerrar salida
  SGSALIDA0()
  RETU
 ENDI

 lMultiple := nRegistro < 1 .OR. nRegistro > oTable:LASTREC()
 oTable:GOTOP()

ENDC

IF EMPTY( nRecno )
 nRecno := IF( lesMySQL, oTable:RECNO(), RECNO() )
ENDI
IF ! EMPTY( nRecno )
 IF lesMySQL
  oTable:GOTO( nRecno )
 ELSE
  (cAlias)->(DBGOTO( nRecno ))
 ENDI
ENDI
IF EMPTY( nRango )
 nRango := 20
ENDI
IF ! EMPTY( cSkip )
 //Es conveniente usar SKIP por la existencia de filtro o cualquier otro verificador de registros
 //Se esta ubicado en el primer registro de la tabla visualizada, recorrer una pagina
 IF cSkip == "INICIO"
  IF lesMySQL
   oTable:GOTOP()
  ELSE
   (cAlias)->(DBGOTOP())
  ENDI
 ELSEIF cSkip == "FINAL"
  IF lesMySQL
   oTable:GOBOTTOM()
  ELSE
   (cAlias)->(DBGOBOTTOM())
  ENDI
 ELSEIF cSkip == "ATRAS"
  IF lMultiple  //Listado
   ii := 0
   WHIL ii < nRango .AND. IF(lesMySQL, ! oTable:BOF(), ! (cAlias)->(BOF()) )
    ii := ii + 1
    IF lesMySQL
     oTable:SKIP( -1 )
    ELSE
     (cAlias)->(DBSKIP( -1 ))
    ENDI
   ENDD
  ELSE  //Por registro
   IF lesMySQL
    oTable:GOTO( nRegistro )
    oTable:SKIP( -1 )
   ELSE
    (cAlias)->(DBGOTO( nRegistro ))
    (cAlias)->(DBSKIP( -1 ))
   ENDIF
  ENDIF

 ELSEIF cSkip == "ADELANTE"
  IF lMultiple  //Listado
   ii := 0
   WHIL ii < nRango .AND. IF(lesMySQL, ! oTable:EOF(), ! (cAlias)->(EOF()) )
    ii := ii + 1
    IF lesMySQL
     oTable:SKIP( 1 )
    ELSE
     (cAlias)->(DBSKIP( 1 ))
    ENDI
   ENDD
  ELSE  //Por registro
   IF lesMySQL
    oTable:GOTO( nRegistro )
    oTable:SKIP( 1 )
   ELSE
    (cAlias)->(DBGOTO( nRegistro ))
    (cAlias)->(DBSKIP( 1 ))
   ENDIF
  ENDIF
  IF lesMySQL
   IF oTable:EOF()
    oTable:SKIP( -1 )
   ENDIF
  ELSE
   IF (cAlias)->(EOF())
    (cAlias)->(DBSKIP( -1 ))
   ENDIF
  ENDIF

 ELSEIF cSkip == "RENOVAR"
  //Mantener posiciones
  IF lMultiple  //Listado

  ELSE  //Por registro
   IF lesMySQL
    oTable:GOTO( nRegistro )
   ELSE
    (cAlias)->(DBGOTO( nRegistro ))
   ENDI
  ENDI

 ELSEIF cSkip == "EDICION"

  lAplicar := SGCGIvaria( "LAPLICAR",,.T. )  //Verificar si existe como variable CGI
  DO CASE
  CASE cOpera == "ALTA"
   IF lesMySQL
    IF lAplicar
     EVAL( bActualiza )
     cSkip := "RENOVAR"
     cOpera := ""
     // nRegistro := oTable:RECNO()
     nRegistro := ""
     // lMultiple := .F.
     lMultiple := .T.
     oTable:GOTO( nRecno )
    ELSE  //Solicitar nuevo registro
 //    SGSUB( "EDITAR" )   Se aplica mas adelante
    ENDI
   ELSE
    IF lAplicar
     IF CPERAPPEND(5,.F. ) //Registrar si se agrega registro
      EVAL( bActualiza )
      cSkip := "RENOVAR"
      cOpera := ""
      nRegistro := (cAlias)->(RECNO())
      lMultiple := .F.
     ELSE
      QOUT( '<CENTER><H1> No pudo registrarse la informacion </H1></CENTER>' )
      QOUT( '<BR>' )
     ENDI
    ELSE  //Solicitar nuevo registro
//    SGSUB( "EDITAR" )   Se aplica mas adelante
    ENDI
   ENDI

  CASE cOpera == "BAJA" .OR. cOpera == "CAMBIO"
   IF lesMySQL
    oTable:GOTO( nRegistro )
    IF lAplicar
     EVAL( bActualiza )
     /*
     IF cOpera == "BAJA"
      oTable:SKIP( 1 )
      IF oTable:EOF()
       oTable:SKIP( -1 )
      ENDI
     ENDI
     */

     cSkip := "RENOVAR"
     cOpera := ""
     // nRegistro := oTable:RECNO()
     nRegistro := ""
     // lMultiple := .F.
     lMultiple := .T.
     oTable:GOTO( nRecno )
    ELSE  //Solicitar edicion
//    SGSUB( "EDITAR" )   Se aplica mas adelante
    ENDI
   ELSE
    (cAlias)->(DBGOTO( nRegistro ))
    IF lAplicar
     IF CPERRLOCK(5,.F. ) //Registrar si se bloquea el registro
      EVAL( bActualiza )
      IF cOpera == "BAJA"
       (cAlias)->(DBSKIP( 1 ))
       IF (cAlias)->(EOF())
        (cAlias)->(DBSKIP( -1 ))
       ENDI
      ENDI
      cSkip := "RENOVAR"
      cOpera := ""
      nRegistro := (cAlias)->(RECNO())
      lMultiple := .F.
     ELSE
      QOUT( '<CENTER><H1> No pudo registrarse la informacion </H1></CENTER>' )
      QOUT( '<BR>' )
     ENDI
    ELSE  //Solicitar edicion
//    SGSUB( "EDITAR" )   Se aplica mas adelante
    ENDI
   ENDI

  ENDC

 ENDI

 IF lesMySQL
  IF lMultiple  //Listado
   nRecno := oTable:RECNO()
  ELSE  //Por registro
   IF oTable:RECNO() < nRecno .OR. oTable:RECNO() > ( nRecno+nRango-1 )
    //Se produjo cambio de pantalla
    nRecno := oTable:RECNO()
   ENDI
  ENDI
 ELSE
  IF lMultiple  //Listado
   nRecno := (cAlias)->(RECNO())
  ELSE  //Por registro
   IF (cAlias)->(RECNO()) < nRecno .OR. (cAlias)->(RECNO()) > ( nRecno+nRango-1 )
    //Se produjo cambio de pantalla
    nRecno := (cAlias)->(RECNO())
   ENDI
  ENDI
 ENDI

ENDI

//Conformar campos a visualizar
aCampos := {}
cCadena := UPPE( cCampos )
IF ! EMPTY( cCadena )
 WHILE ! EMPTY( cCadena )
  nPos := AT( ",", cCadena )
  IF ! nPos == 0
   cField := LEFT( cCadena, nPos - 1 )
   cCadena := SUBS( cCadena, nPos + 1 )
  ELSE
   cField := cCadena
   cCadena := ""
  ENDI
  cField := ALLTRIM( cField )
  IF ! IF(lesMySQL,oTable:FIELDPOS( cField ), FIELDPOS( cField ) ) == 0
   AADD( aCampos, cField )
  ENDI
 ENDD
ENDI
IF EMPTY( aCampos )
 //Usar todos los campos de la base de datos
 aCampos := ACLONE( aEstruc )
 FOR ii = 1 TO LEN( aCampos )
  aCampos[ ii ] := aCampos[ ii, 1 ]   //Nombre del campo
 NEXT ii
ENDI

QOUT('<SCRIPT LANGUAGE="JavaScript">')
QOUT('<!-- Hide script from older browsers')
QOUT('function VisuaDBF( cSkip, cOpera, nRegistro )')
QOUT('{')
QOUT(' document.VisuaDBF.cSkip.value = cSkip;')
QOUT(' document.VisuaDBF.cOpera.value = cOpera;')
QOUT(' document.VisuaDBF.nRegistro.value = nRegistro;')
QOUT(' document.VisuaDBF.submit();')
QOUT('}')
// No se puede crear bloque por la existencia de //, por eso se separa
QOUT('/'+'/ End hiding script -->' )
QOUT('</SCRIPT>')

//DAVID: No aplica en Script Apache QOUT('<FORM METHOD=POST ACTION="'+SGCGIvaria("SCRIPT_NAME")+'" name="VisuaDBF" > ' )
cScrName := STRTRAN( SGCGIvaria("PATH_TRANSLATED"), "/", cDirSepara )
cScrName := STRTRAN( cScrName, "\", cDirSepara )
cScrName := FILENAME(cScrName)
QOUT('<FORM METHOD=POST ACTION="'+cScrName+'" name="VisuaDBF" > ' )

// Valores para Consulta
IF lesMySQL
 QOUT('  <INPUT TYPE=HIDDEN NAME="cMySQLhost" VALUE="'+SGCGIvaria("cMySQLhost")+'">' )
 QOUT('  <INPUT TYPE=HIDDEN NAME="cMySQLuser" VALUE="'+SGCGIvaria("cMySQLuser")+'">' )
 QOUT('  <INPUT TYPE=HIDDEN NAME="cMySQLpass" VALUE="'+SGCGIvaria("cMySQLpass")+'">' )
 QOUT('  <INPUT TYPE=HIDDEN NAME="cBaseSQL" VALUE="'+SGCGIvaria("cBaseSQL")+'">' )
 QOUT('  <INPUT TYPE=HIDDEN NAME="cTableSQL" VALUE="'+SGCGIvaria("cTableSQL")+'">' )
ENDI
QOUT('  <INPUT TYPE=HIDDEN NAME="cBaseDBF1" VALUE="'+SGCGIvaria("cBaseDBF1")+'">' )
QOUT('  <INPUT TYPE=HIDDEN NAME="cBaseDBF2" VALUE="'+SGCGIvaria("cBaseDBF2")+'">' )
QOUT('  <INPUT TYPE=HIDDEN NAME="cIndice" VALUE="'+SGCGIvaria("cIndice")+'">' )
QOUT('  <INPUT TYPE=HIDDEN NAME="cOrden" VALUE="'+SGCGIvaria("cOrden")+'">' )
QOUT('  <INPUT TYPE=HIDDEN NAME="cRDD" VALUE="'+SGCGIvaria("cRDD")+'">' )
QOUT('  <INPUT TYPE=HIDDEN NAME="cADStipo" VALUE="'+SGCGIvaria("cADStipo")+'">' )
QOUT('  <INPUT TYPE=HIDDEN NAME="nRecno" VALUE="'+ALLTRIM(STR(nRecno))+'">' )
QOUT('  <INPUT TYPE=HIDDEN NAME="nRango" VALUE="'+SGCGIvaria("nRango")+'">' )
QOUT('  <INPUT TYPE=HIDDEN NAME="cFiltro" VALUE="'+SGCGIvaria("cFiltro")+'">' )
QOUT('  <INPUT TYPE=HIDDEN NAME="cCampos" VALUE="'+SGCGIvaria("cCampos")+'">' )
IF lEdicion
 QOUT('  <INPUT TYPE=HIDDEN NAME="LEDICION" VALUE=.T.>' )
ENDI
//Para procesos particulares
QOUT('  <INPUT TYPE=HIDDEN NAME="cMuestra" VALUE="'+SGCGIvaria("cMuestra")+'">' )
QOUT('  <INPUT TYPE=HIDDEN NAME="cEditar" VALUE="'+SGCGIvaria("cEditar")+'">' )
QOUT('  <INPUT TYPE=HIDDEN NAME="cActualiza" VALUE="'+SGCGIvaria("cActualiza")+'">' )
QOUT('  <INPUT TYPE=HIDDEN NAME="cPagina" VALUE="'+SGCGIvaria("cPagina")+'">' )

IF cSkip == "EDICION"
 QOUT('  <INPUT TYPE=HIDDEN NAME="cSkip" VALUE="'+cSkip+'">' )
 QOUT('  <INPUT TYPE=HIDDEN NAME="cOpera" VALUE="'+cOpera+'">' )
 QOUT('  <INPUT TYPE=HIDDEN NAME="nRegistro" VALUE="'+ALLTRIM(STR(nRegistro))+'">' )
 QOUT('  <INPUT TYPE=HIDDEN NAME="LAPLICAR" VALUE=.T.>' )

 EVAL( bEditar )
 QOUT( '</FORM>' )

 IF lesMySQL
  oTable:Destroy()
  oServer:Destroy()
 ELSE
  DBCLOSEAREA( )
 ENDI

 QOUT('<br>')
 QOUT('<b>Contador de accesos:</b> ' )
 IF ! FILE( cContador )
  MEMOWRIT( cContador, "0" )
 ENDI
  MEMOWRIT( cContador, STR( VAL(MEMOREAD(cContador))+1 )  )
  QQOUT( MEMOREAD(cContador) )
 QOUT('<br>')

 QOUT('</BODY></HTML>' )
 // Cerrar salida
 SGSALIDA0()
 RETU

ELSE
 QOUT('  <INPUT TYPE=HIDDEN NAME="cSkip" VALUE= >' )
 QOUT('  <INPUT TYPE=HIDDEN NAME="cOpera" VALUE= >' )
 QOUT('  <INPUT TYPE=HIDDEN NAME="nRegistro" VALUE= >' )
ENDI

QOUT( )

QOUT('<div align="center"><center>')
QOUT('<table border="0" cellpadding="1" cellspacing="1" width="100%">')
QOUT('<tr>')
QOUT('<td width="424"><p align="center"><b><font face="Comic Sans MS" color="#000080" size="5">')
QOUT('HOJEAR'+IF(lEdicion,'/EDITAR ','')+' UNA BASE DE DATOS TIPO '+IF(lesMySQL,'MySQL','DBF'))
QOUT('</font></b></td>')
QOUT('</tr>')
QOUT('</table>')
QOUT('</center></div>')

//Condiciones. Podria aplicarse filtro en lugar de FOR
xFor := ".t."
QOUT('<HR>')
IF lesMySQL
 QOUT('Servidor de datos MySQL: '+cMySQLhost )
 QOUT('<BR>Base de datos MySQL: '+cBaseSQL )
 QOUT('<BR>Tabla: '+cTableSQL )
ELSE
 QOUT('Base de datos: '+cBaseDBF )
ENDI
IF ! EMPTY( cIndice )
 QOUT('  Indice: '+cIndice )
ENDI
IF ! EMPTY( cOrden )
 QOUT('  Orden: '+cOrden )
ENDI
IF lesMySQL
 QOUT( '<BR>Controlador RDD: MySQL' )
ELSE
 QOUT( '<BR>Controlador RDD:'+CHARddName( ) )
 IF "ADS" $ cRdd .OR. "AX" $ cRdd    //Advantage
  QQOUT( ',  ADS '+cADStipo )
 ENDI
ENDI
IF ! EMPTY( cFiltro )
 QOUT( "<BR>Filtro: "+cFiltro )
ENDI
IF ! EMPTY( cCampos )
 QOUT( "<BR>Campos: "+cCampos )
ENDI

//Crear bloque de codigo
xFor := SGBLOCK( xFor )

OPCIONES( )
IF lMultiple  //Listado
 EVAL( bPagina )
 OPCIONES( )
 QOUT( '</FORM>' )
 IF lesMySQL
  QOUT( '<H3>Datos puntuales: '+ALLTRIM(STR( jj ))+'/'+ALLTRIM(STR( oTable:LASTREC() ))+'</H3>'  )
 ELSE
  QOUT( '<H3>Datos puntuales: '+ALLTRIM(STR( jj ))+'/'+ALLTRIM(STR( (cAlias)->(LASTREC()) ))+'</H3>'  )
 ENDI
ELSE  //Por registro
 EVAL( bMuestra )
 OPCIONES( )
 QOUT( '</FORM>' )
ENDI
IF lesMySQL
 oTable:Destroy()
 oServer:Destroy()
ELSE
 DBCLOSEAREA( )
ENDI

QOUT('<br>')
QOUT('<b>Contador de accesos:</b> ' )
IF ! FILE( cContador )
 MEMOWRIT( cContador, "0" )
ENDI
 MEMOWRIT( cContador, STR( VAL(MEMOREAD(cContador))+1 )  )
 QQOUT( MEMOREAD(cContador) )
QOUT('<br>')

QOUT('</BODY></HTML>' )
// Cerrar salida
SGSALIDA0()
RETU


FUNC PAGINA
//Mostrar una pagina de registros
LOCAL cRecno
// Visualizacion en tabla
QOUT('<font face="Arial Narrow" size="3">')
QOUT('<div align="center"><center>' )

QOUT( '<TABLE BORDER=1 >' )
QOUT( '<TR>' )
QQOUT( '<TH bgcolor=#99ff99 >' )
QQOUT( 'Registro' )
QQOUT( '</TH>' )
IF lEdicion
 QQOUT( '<TH bgcolor=#99ff99 >' )
 QQOUT( 'Baja' )
 QQOUT( '</TH>' )
 QQOUT( '<TH bgcolor=#99ff99 >' )
 QQOUT( 'Cambio' )
 QQOUT( '</TH>' )
ENDI
// Nombres de campos como encabezados
FOR ii = 1 TO LEN( aCampos )
 QQOUT( '<TH bgcolor=#99ff99 >' )
 QQOUT( aCampos[ ii ] )
 QQOUT( '</TH>' )
NEXT ii
QQOUT( '</TR>' )

// Ciclo para registros
jj := 0
WHIL jj < nRango .AND. IF(lesMySQL, ! oTable:EOF(), ! (cAlias)->(EOF()) )
 IF lesMySQL
 ELSE
  IF ! EVAL( xFor )
   (cAlias)->(DBSKIP( 1 ))
   LOOP
  ENDI
 ENDI
 cRecno := ALLTRIM(STR(IF(lesMySQL,oTable:RECNO(),RECNO())))

 QOUT( '<TR>' )
 QQOUT( '<TH>' )
 QQOUT( '<A HREF=javascript:VisuaDBF("RENOVAR","",'+cRecno+')>' )
 IF lesMySQL
  QQOUT( oTable:RECNO() )
 ELSE
  QQOUT( (cAlias)->(RECNO()) )
 ENDI
 QQOUT('</A>')
 QQOUT( '</TH>' )
 IF lEdicion
  QQOUT('<TD bgcolor="COCOCO" >')
  QQOUT( '<A HREF=javascript:VisuaDBF("EDICION","BAJA",'+cRecno+')>' )
  QQOUT( "B" )
  QQOUT('</A>')
  QQOUT('</TD>')

  QQOUT('<TD bgcolor="COCOCO" >')
  QQOUT( '<A HREF=javascript:VisuaDBF("EDICION","CAMBIO",'+cRecno+')>' )
  QQOUT( "C" )
  QQOUT('</A>')
  QQOUT('</TD>')
 ENDI

 FOR ii = 1 TO LEN( aCampos )

  //Casos especiales por campo (ejemplo)
  IF aCampos[ ii ]=="especial_a"
   QQOUT('<TD bgcolor="COCOCO" >')
   QQOUT( '<A HREF=javascript:VisuaDBF("RENOVAR","",'+cRecno+')>' )
   QQOUT( especial_a )
   QQOUT('</A>')
   QQOUT('</TD>')
  ELSEIF aCampos[ ii ]=="especial_b"

  ELSE
   QQOUT( '<TD>' )
    IF lesMySQL
     QQOUT( oTable:FIELDGET( oTable:FIELDPOS(aCampos[ ii ]) ) )    //Tambien visualiza campos MEMO
    ELSE
     QQOUT( (cAlias)->(FIELDGET( FIELDPOS(aCampos[ ii ]) )) )    //Tambien visualiza campos MEMO
    ENDI
   QQOUT( '</TD>' )
  ENDI

 NEXT ii

 QQOUT( '</TR>' )

 jj := jj+1
 IF lesMySQL
  oTable:SKIP( 1 )
 ELSE
  (cAlias)->(DBSKIP( 1 ))
 ENDI
ENDD

QOUT( '</TABLE>' )
QOUT('</center></div>')
QOUT('</font>')
RETU NIL


FUNC MUESTRA
//Mostrar los datos del registro
QOUT('<div align="center"><center>')
QOUT('<table border="0" cellpadding="1" cellspacing="1" width="100%">')
QOUT('<tr>')
QOUT('<td width="424"><p align="center"><b><font face="Comic Sans MS" color="#000080" size="5">')
QOUT('INFORMACION DEL REGISTRO '+ALLTRIM(STR(IF(lesMySQL,oTable:RECNO(),RECNO()))))
QOUT('</font></b></td>')
QOUT('</tr>')
QOUT('</table>')
QOUT('</center></div>')

//Datos del registro

// Visualizacion en tabla
QOUT('<font face="Arial Narrow" size="3">')
QOUT('<div align="center"><center>' )

//QOUT( '<TABLE BORDER=1 width="1880">' )
QOUT( '<TABLE BORDER=1 ' )

QOUT( '<TR> ' )
QQOUT( '<TH bgcolor=#99ff99 >Campo</TH>' )

QQOUT( '<TH bgcolor=#99ff99 >' )
QQOUT( "Contenido" )
QQOUT( '</TH>' )

QQOUT( '</TR>' )

FOR ii = 1 TO LEN( aEstruc )
 QOUT( '<TR>' )
 QQOUT('<TD bgcolor="COCOCO" >')
 QQOUT( aEstruc[ ii, 1 ] + ":"  )
 QQOUT('</TD>')
 QQOUT( '<TD>' )
 IF lesMySQL
  QQOUT( oTable:FIELDGET( oTable:FIELDPOS(aEstruc[ ii, 1 ]) ) )
 ELSE
  QQOUT( FIELDGET( FIELDPOS(aEstruc[ ii, 1 ]) ) )
 ENDI
 QQOUT( '</TD>' )
 QOUT( '</TR>' )
NEXT ii

QOUT('</TABLE>')
QOUT('</center></div>')
QOUT('</font>')
RETU NIL


FUNC EDITAR
//Solicitar datos

QOUT('<div align="center"><center>')
QOUT('<table border="0" cellpadding="1" cellspacing="1" width="100%">')
QOUT('<tr>')
QOUT('<td width="424"><p align="center"><b><font face="Comic Sans MS" color="#000080" size="5">')

QOUT( cOpera+' DE INFORMACION')

QOUT('</font></b></td>')
QOUT('</tr>')
QOUT('</table>')
QOUT('</center></div>')

IF cOpera == "BAJA"
 QOUT('<center>' )
 QOUT('<INPUT TYPE=SUBMIT VALUE="Aplicar Baja">')
 QOUT('</center>')
 EVAL( bMuestra )
 QOUT('<center>' )
 QOUT('<INPUT TYPE=SUBMIT VALUE="Aplicar Baja">')
 QOUT('</center>')
ELSE  //Alta, Cambio

 QOUT('<center>' )
 QOUT('<INPUT TYPE=SUBMIT VALUE="Aplicar">')
 QOUT('<INPUT TYPE=RESET VALUE="Limpiar">')
 QOUT('</center>')
 // Visualizacion en tabla
 QOUT('<font face="Arial Narrow" size="3">')
 QOUT('<div align="center"><center>' )

 //QOUT( '<TABLE BORDER=1 width="1880">' )
 QOUT( '<TABLE BORDER=1 ' )

 QOUT( '<TR> ' )
 QQOUT( '<TH bgcolor=#99ff99 >Campo</TH>' )

 QQOUT( '<TH bgcolor=#99ff99 >' )
 QQOUT( "Contenido" )
 QQOUT( '</TH>' )
 QQOUT( '</TR>' )

 FOR ii = 1 TO LEN( aEstruc )
  QOUT( '<TR>' )
  QQOUT('<TD bgcolor="COCOCO" >')
  QQOUT( aEstruc[ ii, 1 ] + ":"  )
  QQOUT('</TD>')
  cTipo := LEFT( aEstruc[ ii, 2 ], 1 )  //Tipo
  cVarLen := ALLTRIM(STR(aEstruc[ ii, 3 ]))  //Longitud
  QQOUT( '<TD>' )
  //El nombre del campo sera el nombre de la variable CGI
  IF cTipo == "N" .OR. ;
     cTipo == "I"   //TMySQL.prg:  case ::aFieldStruct[nNum][MYSQL_FS_TYPE] == MYSQL_INT24_TYPE
                    //cType := "I"
   IF cOpera == "ALTA"
    cVarVal := 'VALUE="0"'
   ELSE
    IF lesMySQL
     cVarVal := 'VALUE='+STR( oTable:FIELDGET( ii ), aEstruc[ ii, 3 ], aEstruc[ ii, 4 ] )
    ELSE
     cVarVal := 'VALUE='+STR( FIELDGET( ii ), aEstruc[ ii, 3 ], aEstruc[ ii, 4 ] )
    ENDI
   ENDI
   QOUT( '<INPUT TYPE="TEXT" NAME="'+aEstruc[ ii, 1 ]+'" '+cVarVal+' SIZE='+cVarLen ;
    +' MAXLENGTH='+cVarLen+' STYLE="font-family: Comic Sans MS; font-size: 10pt">' )
  ELSEIF cTipo == "L"
/*DAVID: CHECKBOX provoca confusion por la inexistencia de la variable cuando es NO seleccionado
  QOUT( '<INPUT TYPE=CHECKBOX NAME='+aEstruc[ ii, 1 ]+' VALUE=".F." ' ;
    +' STYLE="font-family: Comic Sans MS; font-size: 10pt" >' )
*/
   IF cOpera == "ALTA"
    cVarVal := 'VALUE="N"'
   ELSE
    IF lesMySQL
     cVarVal := 'VALUE="'+IF( oTable:FIELDGET( ii ), "S", "N" )+'"'
    ELSE
     cVarVal := 'VALUE="'+IF( FIELDGET( ii ), "S", "N" )+'"'
    ENDI
   ENDI
   QOUT( '<INPUT TYPE="TEXT" NAME="'+aEstruc[ ii, 1 ]+'" '+cVarVal+' SIZE='+cVarLen ;
    +' MAXLENGTH='+cVarLen+' STYLE="font-family: Comic Sans MS; font-size: 10pt">' )
  ELSEIF cTipo == "D"
   cVarLen := ALLTRIM( STR( LEN( DTOC(DATE()) ) ) )
   IF cOpera == "ALTA"
    cVarVal := 'VALUE="'+DTOC(DATE())+'"'
   ELSE
    IF lesMySQL
     cVarVal := 'VALUE="'+DTOC(oTable:FIELDGET( ii ))+'"'
    ELSE
     cVarVal := 'VALUE="'+DTOC(FIELDGET( ii ))+'"'
    ENDI
   ENDI
   QOUT( '<INPUT TYPE="TEXT" NAME="'+aEstruc[ ii, 1 ]+'" '+cVarVal+' SIZE='+cVarLen ;
    +' MAXLENGTH='+cVarLen+' STYLE="font-family: Comic Sans MS; font-size: 10pt">' )
  ELSEIF cTipo == "M" .OR. ;
         cTipo == "B"  //TMySQL.prg:  case ::aFieldStruct[nNum][MYSQL_FS_TYPE] == MYSQL_MEDIUM_BLOB_TYPE
                       //cType := "B"
   IF cOpera == "ALTA"
    cVarVal := ''
   ELSE
    IF lesMySQL
     cVarVal := oTable:FIELDGET( ii )
    ELSE
     cVarVal := FIELDGET( ii )
    ENDI
   ENDI
   QOUT('  <TEXTAREA NAME="'+aEstruc[ ii, 1 ]+'" rows="7" cols="70">' )
   QOUT( cVarVal )
   QOUT('  </TEXTAREA>' )

  ELSEIF cTipo == "C"
   IF cOpera == "ALTA"
    cVarVal := ''
   ELSE
    IF lesMySQL
     cVarVal := 'VALUE="'+oTable:FIELDGET( ii )+'"'
    ELSE
     cVarVal := 'VALUE="'+FIELDGET( ii )+'"'
    ENDI
   ENDI
   QOUT( '<INPUT TYPE="TEXT" NAME="'+aEstruc[ ii, 1 ]+'" '+cVarVal+' SIZE='+cVarLen ;
    +' MAXLENGTH='+cVarLen+' STYLE="font-family: Comic Sans MS; font-size: 10pt">' )
  ELSE
   //  Quien habra definido otros tipos ?
  ENDI
  QQOUT( '</TD>' )

  QOUT( '</TR>' )
 NEXT ii

 QOUT('</TABLE>')

 QOUT('<INPUT TYPE=SUBMIT VALUE="Aplicar">')
 QOUT('<INPUT TYPE=RESET VALUE="Limpiar">')
 QOUT('</center></div>')
 QOUT('</font>')

ENDI

RETU NIL


FUNC ACTUALIZA
//Actualizar el registro
LOCAL oRec
IF cOpera == "BAJA"
 IF lesMySQL
  oRec := oTable:GetRow( oTable:RECNO() )
  IF ! oTable:Delete( oRec, .T. )
   QOUT( "<BR>Delete error", oTable:Error() )
  ENDI
 ELSE
  DBDELETE()
 ENDI
ELSE  //Alta, Cambio
 IF lesMySQL
  IF cOpera == "CAMBIO"
   oRec := oTable:GetRow( oTable:RECNO() )
  ELSE
   oRec := oTable:GetBlankRow( )
  ENDI
 ENDI
 FOR ii = 1 TO LEN( aEstruc )
  cTipo := LEFT( aEstruc[ ii, 2 ], 1 )  //Tipo
  IF SGCGIvaria( aEstruc[ ii, 1 ],,.T. )  //Solo si existe el CAMPO como variable CGI
   cValor := SGCGIvaria( aEstruc[ ii, 1 ] )  //Valor de la Variable CGI que tenga el nombre del campo
   IF cTipo == "N" .OR. ;
      cTipo == "I"   //TMySQL.prg:  case ::aFieldStruct[nNum][MYSQL_FS_TYPE] == MYSQL_INT24_TYPE
                     //cType := "I"
    IF lesMySQL
     oRec:FIELDPUT( oRec:FIELDPOS(aEstruc[ ii, 1 ]), VAL( cValor ) )
    ELSE
     FIELDPUT( FIELDPOS(aEstruc[ ii, 1 ]), VAL( cValor ) )
    ENDI
   ELSEIF cTipo == "L"
    IF lesMySQL
     oRec:FIELDPUT( oRec:FIELDPOS(aEstruc[ ii, 1 ]), "+"+UPPE(cValor)+"+" $ "+T+Y+S+ON+" )
    ELSE
     FIELDPUT( FIELDPOS(aEstruc[ ii, 1 ]), "+"+UPPE(cValor)+"+" $ "+T+Y+S+ON+" )
    ENDI
   ELSEIF cTipo == "D"
    IF lesMySQL
     oRec:FIELDPUT( oRec:FIELDPOS(aEstruc[ ii, 1 ]), CTOD( cValor ) )
    ELSE
     FIELDPUT( FIELDPOS(aEstruc[ ii, 1 ]), CTOD( cValor ) )
    ENDI
   ELSEIF cTipo == "M" .OR. ;
          cTipo == "B"  //TMySQL.prg:  case ::aFieldStruct[nNum][MYSQL_FS_TYPE] == MYSQL_MEDIUM_BLOB_TYPE
                        //cType := "B"
    IF lesMySQL
     oRec:FIELDPUT( oRec:FIELDPOS(aEstruc[ ii, 1 ]), cValor )
    ELSE
     FIELDPUT( FIELDPOS(aEstruc[ ii, 1 ]), cValor )
    ENDI
   ELSEIF cTipo == "C"
    IF lesMySQL
     oRec:FIELDPUT( oRec:FIELDPOS(aEstruc[ ii, 1 ]), cValor )
    ELSE
     FIELDPUT( FIELDPOS(aEstruc[ ii, 1 ]), cValor )
    ENDI
   ELSE
    //  Quien habra definido otros tipos ?
   ENDI
  ELSE
   IF cTipo == "L"
    /*DAVID:
    Si se usa CHECKBOX para valores logicos:
    - Si es seleccionado, existe como variable CGI con algun valor determinado, por omision "On"
    - Si NO es seleccionado, NO existe como variable CGI
    Por lo tanto, la inexistencia de la variable CGI con el nombre del campo NO implica que el campo
    logico fue falso, ya que pudo NO haberse usado CHECKBOX para el campo logico
    Se deja a criterio del usuario el actualizar o no, dependiendo si uso CHECKBOX o no
    IF lesMySQL
     oRec:FIELDPUT( oRec:FIELDPOS(aEstruc[ ii, 1 ]), .F. )
    ELSE
     FIELDPUT( FIELDPOS(aEstruc[ ii, 1 ]), .F. )
    ENDI
    */
   ENDI
  ENDI
 NEXT ii
 IF lesMySQL
  IF cOpera == "CAMBIO"
   IF ! oTable:Update( oRec, .T. )
    QOUT( "<BR>Update error", oTable:Error() )
   ENDI
  ELSE
   IF ! oTable:Append( oRec )
    QOUT( "<BR>Append error", oTable:Error() )
   ENDI
  ENDI
 ENDI
ENDI
IF lesMySQL
ELSE
 DBCOMMITALL()  //Forza escritura disco
 DBRUNLOCK()
ENDI
RETU .T.


FUNC OPCIONES
//Presentar opciones
LOCAL cRecno := ALLTRIM(STR(IF(lesMySQL,oTable:RECNO(),RECNO())))
QOUT( '<HR>' )
QOUT( '<TABLE BORDER=0 >' )
QOUT( '<TR>' )
QQOUT( '<TD>' )
IF lMultiple
 QOUT( '<A HREF=conddb.fml>Salir</A>' )
ELSE
 QOUT( '<A HREF=javascript:VisuaDBF("RENOVAR","","0")>Salir</A>' )
ENDI
QQOUT( '</TD>' )

QQOUT( '<TD>' )
QOUT( '<A HREF=javascript:VisuaDBF("RENOVAR","",'+IF(lMultiple,"0",cRecno)+')>Renovar</A>' )
QQOUT( '</TD>' )

QQOUT( '<TD>' )
QOUT( '<A HREF=javascript:VisuaDBF("INICIO","",'+IF(lMultiple,"0",cRecno)+')>Inicio</A>' )
QQOUT( '</TD>' )

QQOUT( '<TD>' )
QOUT( '<A HREF=javascript:VisuaDBF("ATRAS","",'+IF(lMultiple,"0",cRecno)+')>Anterior</A>' )
QQOUT( '</TD>' )

QQOUT( '<TD>' )
QOUT( '<A HREF=javascript:VisuaDBF("ADELANTE","",'+IF(lMultiple,"0",cRecno)+')>Siguiente</A>' )
QQOUT( '</TD>' )

QQOUT( '<TD>' )
QOUT( '<A HREF=javascript:VisuaDBF("FINAL","",'+IF(lMultiple,"0",cRecno)+')>Final</A>' )
QQOUT( '</TD>' )
IF lEdicion
 QQOUT( '<TD>' )
 QOUT( '<A HREF=javascript:VisuaDBF("EDICION","ALTA",'+IF(lMultiple,"0",cRecno)+')>Alta</A>' )
 QQOUT( '</TD>' )
ENDI
IF ! lMultiple .AND. lEdicion
 QQOUT( '<TD>' )
 QOUT( '<A HREF=javascript:VisuaDBF("EDICION","BAJA",'+IF(lMultiple,"0",cRecno)+')>Baja</A>' )
 QQOUT( '</TD>' )
 QQOUT( '<TD>' )
 QOUT( '<A HREF=javascript:VisuaDBF("EDICION","CAMBIO",'+IF(lMultiple,"0",cRecno)+')>Cambio</A>' )
 QQOUT( '</TD>' )
ENDI

QQOUT( '</TR>' )
QOUT( '</TABLE>' )
QOUT( '<HR>' )
RETU NIL

